package io.netty.channel.epoll;

import io.netty.buffer.ByteBuf;
import io.netty.buffer.ByteBufAllocator;
import io.netty.channel.ChannelPipeline;
import io.netty.channel.ChannelPromise;
import io.netty.channel.EventLoop;
import io.netty.channel.socket.DatagramChannelConfig;
import io.netty.channel.socket.DatagramPacket;
import io.netty.channel.unix.DatagramSocketAddress;
import io.netty.channel.unix.Socket;
import java.net.InetSocketAddress;
import java.net.SocketAddress;
import java.nio.ByteBuffer;
import java.util.ArrayList;
import java.util.List;

final class EpollDatagramChannel$EpollDatagramChannelUnsafe
  extends AbstractEpollChannel.AbstractEpollUnsafe
{
  EpollDatagramChannel$EpollDatagramChannelUnsafe(EpollDatagramChannel paramEpollDatagramChannel)
  {
    super(paramEpollDatagramChannel);
  }
  
  private final List<Object> readBuf = new ArrayList();
  
  public void connect(SocketAddress remote, SocketAddress local, ChannelPromise channelPromise)
  {
    boolean success = false;
    try
    {
      try
      {
        boolean wasActive = this$0.isActive();
        InetSocketAddress remoteAddress = (InetSocketAddress)remote;
        if (local != null)
        {
          InetSocketAddress localAddress = (InetSocketAddress)local;
          this$0.doBind(localAddress);
        }
        AbstractEpollChannel.checkResolvable(remoteAddress);
        EpollDatagramChannel.access$002(this$0, remoteAddress);
        EpollDatagramChannel.access$102(this$0, this$0.fd().localAddress());
        success = true;
        
        channelPromise.trySuccess();
        if ((!wasActive) && (this$0.isActive())) {
          this$0.pipeline().fireChannelActive();
        }
      }
      finally
      {
        if (!success) {
          this$0.doClose();
        } else {
          EpollDatagramChannel.access$202(this$0, true);
        }
      }
    }
    catch (Throwable cause)
    {
      channelPromise.tryFailure(cause);
    }
  }
  
  void epollInReady()
  {
    assert (this$0.eventLoop().inEventLoop());
    if (this$0.fd().isInputShutdown())
    {
      clearEpollIn0();
      return;
    }
    DatagramChannelConfig config = this$0.config();
    EpollRecvByteAllocatorHandle allocHandle = recvBufAllocHandle();
    allocHandle.edgeTriggered(this$0.isFlagSet(Native.EPOLLET));
    
    ChannelPipeline pipeline = this$0.pipeline();
    ByteBufAllocator allocator = config.getAllocator();
    allocHandle.reset(config);
    epollInBefore();
    
    Throwable exception = null;
    try
    {
      ByteBuf data = null;
      try
      {
        do
        {
          data = allocHandle.allocate(allocator);
          allocHandle.attemptedBytesRead(data.writableBytes());
          DatagramSocketAddress remoteAddress;
          DatagramSocketAddress remoteAddress;
          if (data.hasMemoryAddress())
          {
            remoteAddress = this$0.fd().recvFromAddress(data.memoryAddress(), data.writerIndex(), data.capacity());
          }
          else
          {
            ByteBuffer nioData = data.internalNioBuffer(data.writerIndex(), data.writableBytes());
            remoteAddress = this$0.fd().recvFrom(nioData, nioData.position(), nioData.limit());
          }
          if (remoteAddress == null)
          {
            allocHandle.lastBytesRead(-1);
            data.release();
            data = null;
            break;
          }
          allocHandle.incMessagesRead(1);
          allocHandle.lastBytesRead(remoteAddress.receivedAmount());
          data.writerIndex(data.writerIndex() + allocHandle.lastBytesRead());
          
          readBuf.add(new DatagramPacket(data, (InetSocketAddress)localAddress(), remoteAddress));
          data = null;
        } while (allocHandle.continueReading());
      }
      catch (Throwable t)
      {
        if (data != null) {
          data.release();
        }
        exception = t;
      }
      int size = readBuf.size();
      for (int i = 0; i < size; i++)
      {
        readPending = false;
        pipeline.fireChannelRead(readBuf.get(i));
      }
      readBuf.clear();
      allocHandle.readComplete();
      pipeline.fireChannelReadComplete();
      if (exception != null) {
        pipeline.fireExceptionCaught(exception);
      }
    }
    finally
    {
      epollInFinally(config);
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.epoll.EpollDatagramChannel.EpollDatagramChannelUnsafe
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */