package io.netty.handler.codec.http2;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;

final class DefaultHttp2ConnectionDecoder$PrefaceFrameListener
  implements Http2FrameListener
{
  private DefaultHttp2ConnectionDecoder$PrefaceFrameListener(DefaultHttp2ConnectionDecoder paramDefaultHttp2ConnectionDecoder) {}
  
  private void verifyPrefaceReceived()
    throws Http2Exception
  {
    if (!this$0.prefaceReceived()) {
      throw Http2Exception.connectionError(Http2Error.PROTOCOL_ERROR, "Received non-SETTINGS as first frame.", new Object[0]);
    }
  }
  
  public int onDataRead(ChannelHandlerContext ctx, int streamId, ByteBuf data, int padding, boolean endOfStream)
    throws Http2Exception
  {
    verifyPrefaceReceived();
    return DefaultHttp2ConnectionDecoder.access$900(this$0).onDataRead(ctx, streamId, data, padding, endOfStream);
  }
  
  public void onHeadersRead(ChannelHandlerContext ctx, int streamId, Http2Headers headers, int padding, boolean endOfStream)
    throws Http2Exception
  {
    verifyPrefaceReceived();
    DefaultHttp2ConnectionDecoder.access$900(this$0).onHeadersRead(ctx, streamId, headers, padding, endOfStream);
  }
  
  public void onHeadersRead(ChannelHandlerContext ctx, int streamId, Http2Headers headers, int streamDependency, short weight, boolean exclusive, int padding, boolean endOfStream)
    throws Http2Exception
  {
    verifyPrefaceReceived();
    DefaultHttp2ConnectionDecoder.access$900(this$0).onHeadersRead(ctx, streamId, headers, streamDependency, weight, exclusive, padding, endOfStream);
  }
  
  public void onPriorityRead(ChannelHandlerContext ctx, int streamId, int streamDependency, short weight, boolean exclusive)
    throws Http2Exception
  {
    verifyPrefaceReceived();
    DefaultHttp2ConnectionDecoder.access$900(this$0).onPriorityRead(ctx, streamId, streamDependency, weight, exclusive);
  }
  
  public void onRstStreamRead(ChannelHandlerContext ctx, int streamId, long errorCode)
    throws Http2Exception
  {
    verifyPrefaceReceived();
    DefaultHttp2ConnectionDecoder.access$900(this$0).onRstStreamRead(ctx, streamId, errorCode);
  }
  
  public void onSettingsAckRead(ChannelHandlerContext ctx)
    throws Http2Exception
  {
    verifyPrefaceReceived();
    DefaultHttp2ConnectionDecoder.access$900(this$0).onSettingsAckRead(ctx);
  }
  
  public void onSettingsRead(ChannelHandlerContext ctx, Http2Settings settings)
    throws Http2Exception
  {
    if (!this$0.prefaceReceived()) {
      DefaultHttp2ConnectionDecoder.access$902(this$0, new DefaultHttp2ConnectionDecoder.FrameReadListener(this$0, null));
    }
    DefaultHttp2ConnectionDecoder.access$900(this$0).onSettingsRead(ctx, settings);
  }
  
  public void onPingRead(ChannelHandlerContext ctx, ByteBuf data)
    throws Http2Exception
  {
    verifyPrefaceReceived();
    DefaultHttp2ConnectionDecoder.access$900(this$0).onPingRead(ctx, data);
  }
  
  public void onPingAckRead(ChannelHandlerContext ctx, ByteBuf data)
    throws Http2Exception
  {
    verifyPrefaceReceived();
    DefaultHttp2ConnectionDecoder.access$900(this$0).onPingAckRead(ctx, data);
  }
  
  public void onPushPromiseRead(ChannelHandlerContext ctx, int streamId, int promisedStreamId, Http2Headers headers, int padding)
    throws Http2Exception
  {
    verifyPrefaceReceived();
    DefaultHttp2ConnectionDecoder.access$900(this$0).onPushPromiseRead(ctx, streamId, promisedStreamId, headers, padding);
  }
  
  public void onGoAwayRead(ChannelHandlerContext ctx, int lastStreamId, long errorCode, ByteBuf debugData)
    throws Http2Exception
  {
    this$0.onGoAwayRead0(ctx, lastStreamId, errorCode, debugData);
  }
  
  public void onWindowUpdateRead(ChannelHandlerContext ctx, int streamId, int windowSizeIncrement)
    throws Http2Exception
  {
    verifyPrefaceReceived();
    DefaultHttp2ConnectionDecoder.access$900(this$0).onWindowUpdateRead(ctx, streamId, windowSizeIncrement);
  }
  
  public void onUnknownFrame(ChannelHandlerContext ctx, byte frameType, int streamId, Http2Flags flags, ByteBuf payload)
    throws Http2Exception
  {
    this$0.onUnknownFrame0(ctx, frameType, streamId, flags, payload);
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http2.DefaultHttp2ConnectionDecoder.PrefaceFrameListener
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */