package io.netty.handler.codec.http2;

import io.netty.util.internal.logging.InternalLogger;

final class DefaultHttp2RemoteFlowController$ListenerWritabilityMonitor
  extends DefaultHttp2RemoteFlowController.WritabilityMonitor
{
  private final Http2RemoteFlowController.Listener listener;
  private final Http2StreamVisitor checkStreamWritabilityVisitor = new Http2StreamVisitor()
  {
    public boolean visit(Http2Stream stream)
      throws Http2Exception
    {
      DefaultHttp2RemoteFlowController.FlowState state = DefaultHttp2RemoteFlowController.access$100(this$0, stream);
      if (isWritable(state) != state.markedWritability()) {
        DefaultHttp2RemoteFlowController.ListenerWritabilityMonitor.this.notifyWritabilityChanged(state);
      }
      return true;
    }
  };
  
  DefaultHttp2RemoteFlowController$ListenerWritabilityMonitor(DefaultHttp2RemoteFlowController paramDefaultHttp2RemoteFlowController, Http2RemoteFlowController.Listener listener)
  {
    super(paramDefaultHttp2RemoteFlowController, null);
    this.listener = listener;
  }
  
  void windowSize(DefaultHttp2RemoteFlowController.FlowState state, int initialWindowSize)
  {
    super.windowSize(state, initialWindowSize);
    try
    {
      checkStateWritability(state);
    }
    catch (Http2Exception e)
    {
      throw new RuntimeException("Caught unexpected exception from window", e);
    }
  }
  
  void incrementWindowSize(DefaultHttp2RemoteFlowController.FlowState state, int delta)
    throws Http2Exception
  {
    super.incrementWindowSize(state, delta);
    checkStateWritability(state);
  }
  
  void initialWindowSize(int newWindowSize)
    throws Http2Exception
  {
    super.initialWindowSize(newWindowSize);
    if (isWritableConnection()) {
      checkAllWritabilityChanged();
    }
  }
  
  void enqueueFrame(DefaultHttp2RemoteFlowController.FlowState state, Http2RemoteFlowController.FlowControlled frame)
    throws Http2Exception
  {
    super.enqueueFrame(state, frame);
    checkConnectionThenStreamWritabilityChanged(state);
  }
  
  void stateCancelled(DefaultHttp2RemoteFlowController.FlowState state)
  {
    try
    {
      checkConnectionThenStreamWritabilityChanged(state);
    }
    catch (Http2Exception e)
    {
      throw new RuntimeException("Caught unexpected exception from checkAllWritabilityChanged", e);
    }
  }
  
  void channelWritabilityChange()
    throws Http2Exception
  {
    if (DefaultHttp2RemoteFlowController.access$800(this$0).markedWritability() != DefaultHttp2RemoteFlowController.access$1200(this$0)) {
      checkAllWritabilityChanged();
    }
  }
  
  private void checkStateWritability(DefaultHttp2RemoteFlowController.FlowState state)
    throws Http2Exception
  {
    if (isWritable(state) != state.markedWritability()) {
      if (state == DefaultHttp2RemoteFlowController.access$800(this$0)) {
        checkAllWritabilityChanged();
      } else {
        notifyWritabilityChanged(state);
      }
    }
  }
  
  private void notifyWritabilityChanged(DefaultHttp2RemoteFlowController.FlowState state)
  {
    state.markedWritability(!state.markedWritability());
    try
    {
      listener.writabilityChanged(DefaultHttp2RemoteFlowController.FlowState.access$1400(state));
    }
    catch (Throwable cause)
    {
      DefaultHttp2RemoteFlowController.access$1500().error("Caught Throwable from listener.writabilityChanged", cause);
    }
  }
  
  private void checkConnectionThenStreamWritabilityChanged(DefaultHttp2RemoteFlowController.FlowState state)
    throws Http2Exception
  {
    if (isWritableConnection() != DefaultHttp2RemoteFlowController.access$800(this$0).markedWritability()) {
      checkAllWritabilityChanged();
    } else if (isWritable(state) != state.markedWritability()) {
      notifyWritabilityChanged(state);
    }
  }
  
  private void checkAllWritabilityChanged()
    throws Http2Exception
  {
    DefaultHttp2RemoteFlowController.access$800(this$0).markedWritability(isWritableConnection());
    DefaultHttp2RemoteFlowController.access$1100(this$0).forEachActiveStream(checkStreamWritabilityVisitor);
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http2.DefaultHttp2RemoteFlowController.ListenerWritabilityMonitor
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */