package io.netty.util;

import io.netty.util.internal.PlatformDependent;
import io.netty.util.internal.logging.InternalLogger;
import java.util.Collections;
import java.util.HashSet;
import java.util.Queue;
import java.util.Set;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.atomic.AtomicIntegerFieldUpdater;

final class HashedWheelTimer$Worker
  implements Runnable
{
  private final Set<Timeout> unprocessedTimeouts = new HashSet();
  private long tick;
  
  private HashedWheelTimer$Worker(HashedWheelTimer paramHashedWheelTimer) {}
  
  public void run()
  {
    HashedWheelTimer.access$202(this$0, System.nanoTime());
    if (HashedWheelTimer.access$200(this$0) == 0L) {
      HashedWheelTimer.access$202(this$0, 1L);
    }
    HashedWheelTimer.access$300(this$0).countDown();
    do
    {
      long deadline = waitForNextTick();
      if (deadline > 0L)
      {
        int idx = (int)(tick & HashedWheelTimer.access$400(this$0));
        processCancelledTasks();
        HashedWheelTimer.HashedWheelBucket bucket = HashedWheelTimer.access$500(this$0)[idx];
        
        transferTimeoutsToBuckets();
        bucket.expireTimeouts(deadline);
        tick += 1L;
      }
    } while (HashedWheelTimer.access$600().get(this$0) == 1);
    for (HashedWheelTimer.HashedWheelBucket bucket : HashedWheelTimer.access$500(this$0)) {
      bucket.clearTimeouts(unprocessedTimeouts);
    }
    for (;;)
    {
      HashedWheelTimer.HashedWheelTimeout timeout = (HashedWheelTimer.HashedWheelTimeout)HashedWheelTimer.access$700(this$0).poll();
      if (timeout == null) {
        break;
      }
      if (!timeout.isCancelled()) {
        unprocessedTimeouts.add(timeout);
      }
    }
    processCancelledTasks();
  }
  
  private void transferTimeoutsToBuckets()
  {
    for (int i = 0; i < 100000; i++)
    {
      HashedWheelTimer.HashedWheelTimeout timeout = (HashedWheelTimer.HashedWheelTimeout)HashedWheelTimer.access$700(this$0).poll();
      if (timeout == null) {
        break;
      }
      if (timeout.state() != 1)
      {
        long calculated = HashedWheelTimer.HashedWheelTimeout.access$800(timeout) / HashedWheelTimer.access$900(this$0);
        remainingRounds = ((calculated - tick) / HashedWheelTimer.access$500(this$0).length);
        
        long ticks = Math.max(calculated, tick);
        int stopIndex = (int)(ticks & HashedWheelTimer.access$400(this$0));
        
        HashedWheelTimer.HashedWheelBucket bucket = HashedWheelTimer.access$500(this$0)[stopIndex];
        bucket.addTimeout(timeout);
      }
    }
  }
  
  private void processCancelledTasks()
  {
    for (;;)
    {
      HashedWheelTimer.HashedWheelTimeout timeout = (HashedWheelTimer.HashedWheelTimeout)HashedWheelTimer.access$1000(this$0).poll();
      if (timeout == null) {
        break;
      }
      try
      {
        timeout.remove();
      }
      catch (Throwable t)
      {
        if (HashedWheelTimer.logger.isWarnEnabled()) {
          HashedWheelTimer.logger.warn("An exception was thrown while process a cancellation task", t);
        }
      }
    }
  }
  
  private long waitForNextTick()
  {
    long deadline = HashedWheelTimer.access$900(this$0) * (tick + 1L);
    for (;;)
    {
      long currentTime = System.nanoTime() - HashedWheelTimer.access$200(this$0);
      long sleepTimeMs = (deadline - currentTime + 999999L) / 1000000L;
      if (sleepTimeMs <= 0L)
      {
        if (currentTime == Long.MIN_VALUE) {
          return -9223372036854775807L;
        }
        return currentTime;
      }
      if (PlatformDependent.isWindows()) {
        sleepTimeMs = sleepTimeMs / 10L * 10L;
      }
      try
      {
        Thread.sleep(sleepTimeMs);
      }
      catch (InterruptedException ignored)
      {
        if (HashedWheelTimer.access$600().get(this$0) == 2) {
          return Long.MIN_VALUE;
        }
      }
    }
  }
  
  public Set<Timeout> unprocessedTimeouts()
  {
    return Collections.unmodifiableSet(unprocessedTimeouts);
  }
}

/* Location:
 * Qualified Name:     io.netty.util.HashedWheelTimer.Worker
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */