package io.netty.util.internal;

import io.netty.util.internal.logging.InternalLogger;
import io.netty.util.internal.logging.InternalLoggerFactory;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.nio.Buffer;
import java.nio.ByteBuffer;
import java.security.AccessController;
import java.security.PrivilegedAction;
import java.util.concurrent.atomic.AtomicIntegerFieldUpdater;
import java.util.concurrent.atomic.AtomicLongFieldUpdater;
import java.util.concurrent.atomic.AtomicReferenceFieldUpdater;
import sun.misc.Unsafe;

final class PlatformDependent0
{
  private static final InternalLogger logger = InternalLoggerFactory.getInstance(PlatformDependent0.class);
  static final Unsafe UNSAFE;
  private static final long ADDRESS_FIELD_OFFSET;
  private static final long BYTE_ARRAY_BASE_OFFSET;
  private static final Constructor<?> DIRECT_BUFFER_CONSTRUCTOR;
  static final int HASH_CODE_ASCII_SEED = -1028477387;
  static final int HASH_CODE_C1 = 461845907;
  static final int HASH_CODE_C2 = 461845907;
  private static final long UNSAFE_COPY_THRESHOLD = 1048576L;
  private static final boolean UNALIGNED;
  
  static
  {
    ByteBuffer direct = ByteBuffer.allocateDirect(1);
    
    Object maybeAddressField = AccessController.doPrivileged(new PrivilegedAction()
    {
      public Object run()
      {
        try
        {
          Field field = Buffer.class.getDeclaredField("address");
          field.setAccessible(true);
          if (field.getLong(val$direct) == 0L) {
            return null;
          }
          return field;
        }
        catch (IllegalAccessException e)
        {
          return e;
        }
        catch (NoSuchFieldException e)
        {
          return e;
        }
        catch (SecurityException e)
        {
          return e;
        }
      }
    });
    Field addressField;
    if ((maybeAddressField instanceof Field))
    {
      Field addressField = (Field)maybeAddressField;
      logger.debug("java.nio.Buffer.address: available");
    }
    else
    {
      logger.debug("java.nio.Buffer.address: unavailable", (Exception)maybeAddressField);
      addressField = null;
    }
    Unsafe unsafe;
    if (addressField != null)
    {
      Object maybeUnsafe = AccessController.doPrivileged(new PrivilegedAction()
      {
        public Object run()
        {
          try
          {
            Field unsafeField = Unsafe.class.getDeclaredField("theUnsafe");
            unsafeField.setAccessible(true);
            
            return unsafeField.get(null);
          }
          catch (NoSuchFieldException e)
          {
            return e;
          }
          catch (SecurityException e)
          {
            return e;
          }
          catch (IllegalAccessException e)
          {
            return e;
          }
        }
      });
      Unsafe unsafe;
      if ((maybeUnsafe instanceof Exception))
      {
        Unsafe unsafe = null;
        logger.debug("sun.misc.Unsafe.theUnsafe: unavailable", (Exception)maybeUnsafe);
      }
      else
      {
        unsafe = (Unsafe)maybeUnsafe;
        logger.debug("sun.misc.Unsafe.theUnsafe: available");
      }
      if (unsafe != null)
      {
        Unsafe finalUnsafe = unsafe;
        Object maybeException = AccessController.doPrivileged(new PrivilegedAction()
        {
          public Object run()
          {
            try
            {
              val$finalUnsafe.getClass().getDeclaredMethod("copyMemory", new Class[] { Object.class, Long.TYPE, Object.class, Long.TYPE, Long.TYPE });
              
              return null;
            }
            catch (NoSuchMethodException e)
            {
              return e;
            }
            catch (SecurityException e)
            {
              return e;
            }
          }
        });
        if (maybeException == null)
        {
          logger.debug("sun.misc.Unsafe.copyMemory: available");
        }
        else
        {
          unsafe = null;
          logger.debug("sun.misc.Unsafe.copyMemory: unavailable", (Exception)maybeException);
        }
      }
    }
    else
    {
      unsafe = null;
    }
    UNSAFE = unsafe;
    if (unsafe == null)
    {
      ADDRESS_FIELD_OFFSET = -1L;
      BYTE_ARRAY_BASE_OFFSET = -1L;
      UNALIGNED = false;
      DIRECT_BUFFER_CONSTRUCTOR = null;
    }
    else
    {
      long address = -1L;
      try
      {
        Object maybeDirectBufferConstructor = AccessController.doPrivileged(new PrivilegedAction()
        {
          public Object run()
          {
            try
            {
              Constructor constructor = val$direct.getClass().getDeclaredConstructor(new Class[] { Long.TYPE, Integer.TYPE });
              
              constructor.setAccessible(true);
              return constructor;
            }
            catch (NoSuchMethodException e)
            {
              return e;
            }
            catch (SecurityException e)
            {
              return e;
            }
          }
        });
        if ((maybeDirectBufferConstructor instanceof Constructor))
        {
          address = UNSAFE.allocateMemory(1L);
          Constructor<?> directBufferConstructor;
          try
          {
            ((Constructor)maybeDirectBufferConstructor).newInstance(new Object[] { Long.valueOf(address), Integer.valueOf(1) });
            Constructor<?> directBufferConstructor = (Constructor)maybeDirectBufferConstructor;
            logger.debug("direct buffer constructor: available");
          }
          catch (InstantiationException e)
          {
            directBufferConstructor = null;
          }
          catch (IllegalAccessException e)
          {
            Constructor<?> directBufferConstructor;
            directBufferConstructor = null;
          }
          catch (InvocationTargetException e)
          {
            Constructor<?> directBufferConstructor;
            directBufferConstructor = null;
          }
        }
        else
        {
          logger.debug("direct buffer constructor: unavailable", (Exception)maybeDirectBufferConstructor);
          
          directBufferConstructor = null;
        }
      }
      finally
      {
        Constructor<?> directBufferConstructor;
        if (address != -1L) {
          UNSAFE.freeMemory(address);
        }
      }
      Constructor<?> directBufferConstructor;
      DIRECT_BUFFER_CONSTRUCTOR = directBufferConstructor;
      
      ADDRESS_FIELD_OFFSET = objectFieldOffset(addressField);
      BYTE_ARRAY_BASE_OFFSET = UNSAFE.arrayBaseOffset(byte[].class);
      
      Object maybeUnaligned = AccessController.doPrivileged(new PrivilegedAction()
      {
        public Object run()
        {
          try
          {
            Class<?> bitsClass = Class.forName("java.nio.Bits", false, PlatformDependent.getSystemClassLoader());
            
            Method unalignedMethod = bitsClass.getDeclaredMethod("unaligned", new Class[0]);
            unalignedMethod.setAccessible(true);
            return unalignedMethod.invoke(null, new Object[0]);
          }
          catch (ClassNotFoundException e)
          {
            return e;
          }
          catch (NoSuchMethodException e)
          {
            return e;
          }
          catch (InvocationTargetException e)
          {
            return e;
          }
          catch (IllegalAccessException e)
          {
            return e;
          }
          catch (SecurityException e)
          {
            return e;
          }
        }
      });
      boolean unaligned;
      if ((maybeUnaligned instanceof Boolean))
      {
        boolean unaligned = ((Boolean)maybeUnaligned).booleanValue();
        logger.debug("java.nio.Bits.unaligned: available, {}", Boolean.valueOf(unaligned));
      }
      else
      {
        String arch = SystemPropertyUtil.get("os.arch", "");
        
        unaligned = arch.matches("^(i[3-6]86|x86(_64)?|x64|amd64)$");
        Exception e = (Exception)maybeUnaligned;
        logger.debug("java.nio.Bits.unaligned: unavailable, " + unaligned, e);
      }
      UNALIGNED = unaligned;
    }
    logger.debug("java.nio.DirectByteBuffer.<init>(long, int): {}", DIRECT_BUFFER_CONSTRUCTOR != null ? "available" : "unavailable");
    
    freeDirectBuffer(direct);
  }
  
  static boolean isUnaligned()
  {
    return UNALIGNED;
  }
  
  static boolean hasUnsafe()
  {
    return UNSAFE != null;
  }
  
  static boolean unalignedAccess()
  {
    return UNALIGNED;
  }
  
  static void throwException(Throwable cause)
  {
    UNSAFE.throwException((Throwable)ObjectUtil.checkNotNull(cause, "cause"));
  }
  
  static boolean hasDirectBufferNoCleanerConstructor()
  {
    return DIRECT_BUFFER_CONSTRUCTOR != null;
  }
  
  static ByteBuffer reallocateDirectNoCleaner(ByteBuffer buffer, int capacity)
  {
    return newDirectBuffer(UNSAFE.reallocateMemory(directBufferAddress(buffer), capacity), capacity);
  }
  
  static ByteBuffer allocateDirectNoCleaner(int capacity)
  {
    return newDirectBuffer(UNSAFE.allocateMemory(capacity), capacity);
  }
  
  static ByteBuffer newDirectBuffer(long address, int capacity)
  {
    ObjectUtil.checkPositiveOrZero(address, "address");
    ObjectUtil.checkPositiveOrZero(capacity, "capacity");
    try
    {
      return (ByteBuffer)DIRECT_BUFFER_CONSTRUCTOR.newInstance(new Object[] { Long.valueOf(address), Integer.valueOf(capacity) });
    }
    catch (Throwable cause)
    {
      if ((cause instanceof Error)) {
        throw ((Error)cause);
      }
      throw new Error(cause);
    }
  }
  
  static void freeDirectBuffer(ByteBuffer buffer)
  {
    Cleaner0.freeDirectBuffer(buffer);
  }
  
  static long directBufferAddress(ByteBuffer buffer)
  {
    return getLong(buffer, ADDRESS_FIELD_OFFSET);
  }
  
  static long byteArrayBaseOffset()
  {
    return BYTE_ARRAY_BASE_OFFSET;
  }
  
  static Object getObject(Object object, long fieldOffset)
  {
    return UNSAFE.getObject(object, fieldOffset);
  }
  
  static Object getObjectVolatile(Object object, long fieldOffset)
  {
    return UNSAFE.getObjectVolatile(object, fieldOffset);
  }
  
  static int getInt(Object object, long fieldOffset)
  {
    return UNSAFE.getInt(object, fieldOffset);
  }
  
  private static long getLong(Object object, long fieldOffset)
  {
    return UNSAFE.getLong(object, fieldOffset);
  }
  
  static long objectFieldOffset(Field field)
  {
    return UNSAFE.objectFieldOffset(field);
  }
  
  static byte getByte(long address)
  {
    return UNSAFE.getByte(address);
  }
  
  static short getShort(long address)
  {
    return UNSAFE.getShort(address);
  }
  
  static int getInt(long address)
  {
    return UNSAFE.getInt(address);
  }
  
  static long getLong(long address)
  {
    return UNSAFE.getLong(address);
  }
  
  static byte getByte(byte[] data, int index)
  {
    return UNSAFE.getByte(data, BYTE_ARRAY_BASE_OFFSET + index);
  }
  
  static short getShort(byte[] data, int index)
  {
    return UNSAFE.getShort(data, BYTE_ARRAY_BASE_OFFSET + index);
  }
  
  static int getInt(byte[] data, int index)
  {
    return UNSAFE.getInt(data, BYTE_ARRAY_BASE_OFFSET + index);
  }
  
  static long getLong(byte[] data, int index)
  {
    return UNSAFE.getLong(data, BYTE_ARRAY_BASE_OFFSET + index);
  }
  
  static void putOrderedObject(Object object, long address, Object value)
  {
    UNSAFE.putOrderedObject(object, address, value);
  }
  
  static void putByte(long address, byte value)
  {
    UNSAFE.putByte(address, value);
  }
  
  static void putShort(long address, short value)
  {
    UNSAFE.putShort(address, value);
  }
  
  static void putInt(long address, int value)
  {
    UNSAFE.putInt(address, value);
  }
  
  static void putLong(long address, long value)
  {
    UNSAFE.putLong(address, value);
  }
  
  static void putByte(byte[] data, int index, byte value)
  {
    UNSAFE.putByte(data, BYTE_ARRAY_BASE_OFFSET + index, value);
  }
  
  static void putShort(byte[] data, int index, short value)
  {
    UNSAFE.putShort(data, BYTE_ARRAY_BASE_OFFSET + index, value);
  }
  
  static void putInt(byte[] data, int index, int value)
  {
    UNSAFE.putInt(data, BYTE_ARRAY_BASE_OFFSET + index, value);
  }
  
  static void putLong(byte[] data, int index, long value)
  {
    UNSAFE.putLong(data, BYTE_ARRAY_BASE_OFFSET + index, value);
  }
  
  static void copyMemory(long srcAddr, long dstAddr, long length)
  {
    while (length > 0L)
    {
      long size = Math.min(length, 1048576L);
      UNSAFE.copyMemory(srcAddr, dstAddr, size);
      length -= size;
      srcAddr += size;
      dstAddr += size;
    }
  }
  
  static void copyMemory(Object src, long srcOffset, Object dst, long dstOffset, long length)
  {
    while (length > 0L)
    {
      long size = Math.min(length, 1048576L);
      UNSAFE.copyMemory(src, srcOffset, dst, dstOffset, size);
      length -= size;
      srcOffset += size;
      dstOffset += size;
    }
  }
  
  static void setMemory(long address, long bytes, byte value)
  {
    UNSAFE.setMemory(address, bytes, value);
  }
  
  static void setMemory(Object o, long offset, long bytes, byte value)
  {
    UNSAFE.setMemory(o, offset, bytes, value);
  }
  
  static boolean equals(byte[] bytes1, int startPos1, byte[] bytes2, int startPos2, int length)
  {
    long baseOffset1 = BYTE_ARRAY_BASE_OFFSET + startPos1;
    long baseOffset2 = BYTE_ARRAY_BASE_OFFSET + startPos2;
    int remainingBytes = length & 0x7;
    long end = baseOffset1 + remainingBytes;
    long i = baseOffset1 - 8L + length;
    for (long j = baseOffset2 - 8L + length; i >= end; j -= 8L)
    {
      if (UNSAFE.getLong(bytes1, i) != UNSAFE.getLong(bytes2, j)) {
        return false;
      }
      i -= 8L;
    }
    switch (remainingBytes)
    {
    case 7: 
      return (UNSAFE.getInt(bytes1, baseOffset1 + 3L) == UNSAFE.getInt(bytes2, baseOffset2 + 3L)) && (UNSAFE.getChar(bytes1, baseOffset1 + 1L) == UNSAFE.getChar(bytes2, baseOffset2 + 1L)) && (UNSAFE.getByte(bytes1, baseOffset1) == UNSAFE.getByte(bytes2, baseOffset2));
    case 6: 
      return (UNSAFE.getInt(bytes1, baseOffset1 + 2L) == UNSAFE.getInt(bytes2, baseOffset2 + 2L)) && (UNSAFE.getChar(bytes1, baseOffset1) == UNSAFE.getChar(bytes2, baseOffset2));
    case 5: 
      return (UNSAFE.getInt(bytes1, baseOffset1 + 1L) == UNSAFE.getInt(bytes2, baseOffset2 + 1L)) && (UNSAFE.getByte(bytes1, baseOffset1) == UNSAFE.getByte(bytes2, baseOffset2));
    case 4: 
      return UNSAFE.getInt(bytes1, baseOffset1) == UNSAFE.getInt(bytes2, baseOffset2);
    case 3: 
      return (UNSAFE.getChar(bytes1, baseOffset1 + 1L) == UNSAFE.getChar(bytes2, baseOffset2 + 1L)) && (UNSAFE.getByte(bytes1, baseOffset1) == UNSAFE.getByte(bytes2, baseOffset2));
    case 2: 
      return UNSAFE.getChar(bytes1, baseOffset1) == UNSAFE.getChar(bytes2, baseOffset2);
    case 1: 
      return UNSAFE.getByte(bytes1, baseOffset1) == UNSAFE.getByte(bytes2, baseOffset2);
    }
    return true;
  }
  
  static int equalsConstantTime(byte[] bytes1, int startPos1, byte[] bytes2, int startPos2, int length)
  {
    long result = 0L;
    long baseOffset1 = BYTE_ARRAY_BASE_OFFSET + startPos1;
    long baseOffset2 = BYTE_ARRAY_BASE_OFFSET + startPos2;
    int remainingBytes = length & 0x7;
    long end = baseOffset1 + remainingBytes;
    long i = baseOffset1 - 8L + length;
    for (long j = baseOffset2 - 8L + length; i >= end; j -= 8L)
    {
      result |= UNSAFE.getLong(bytes1, i) ^ UNSAFE.getLong(bytes2, j);i -= 8L;
    }
    switch (remainingBytes)
    {
    case 7: 
      return ConstantTimeUtils.equalsConstantTime(result | UNSAFE.getInt(bytes1, baseOffset1 + 3L) ^ UNSAFE.getInt(bytes2, baseOffset2 + 3L) | UNSAFE.getChar(bytes1, baseOffset1 + 1L) ^ UNSAFE.getChar(bytes2, baseOffset2 + 1L) | UNSAFE.getByte(bytes1, baseOffset1) ^ UNSAFE.getByte(bytes2, baseOffset2), 0L);
    case 6: 
      return ConstantTimeUtils.equalsConstantTime(result | UNSAFE.getInt(bytes1, baseOffset1 + 2L) ^ UNSAFE.getInt(bytes2, baseOffset2 + 2L) | UNSAFE.getChar(bytes1, baseOffset1) ^ UNSAFE.getChar(bytes2, baseOffset2), 0L);
    case 5: 
      return ConstantTimeUtils.equalsConstantTime(result | UNSAFE.getInt(bytes1, baseOffset1 + 1L) ^ UNSAFE.getInt(bytes2, baseOffset2 + 1L) | UNSAFE.getByte(bytes1, baseOffset1) ^ UNSAFE.getByte(bytes2, baseOffset2), 0L);
    case 4: 
      return ConstantTimeUtils.equalsConstantTime(result | UNSAFE.getInt(bytes1, baseOffset1) ^ UNSAFE.getInt(bytes2, baseOffset2), 0L);
    case 3: 
      return ConstantTimeUtils.equalsConstantTime(result | UNSAFE.getChar(bytes1, baseOffset1 + 1L) ^ UNSAFE.getChar(bytes2, baseOffset2 + 1L) | UNSAFE.getByte(bytes1, baseOffset1) ^ UNSAFE.getByte(bytes2, baseOffset2), 0L);
    case 2: 
      return ConstantTimeUtils.equalsConstantTime(result | UNSAFE.getChar(bytes1, baseOffset1) ^ UNSAFE.getChar(bytes2, baseOffset2), 0L);
    case 1: 
      return ConstantTimeUtils.equalsConstantTime(result | UNSAFE.getByte(bytes1, baseOffset1) ^ UNSAFE.getByte(bytes2, baseOffset2), 0L);
    }
    return ConstantTimeUtils.equalsConstantTime(result, 0L);
  }
  
  static int hashCodeAscii(byte[] bytes, int startPos, int length)
  {
    int hash = -1028477387;
    long baseOffset = BYTE_ARRAY_BASE_OFFSET + startPos;
    int remainingBytes = length & 0x7;
    long end = baseOffset + remainingBytes;
    for (long i = baseOffset - 8L + length; i >= end; i -= 8L) {
      hash = hashCodeAsciiCompute(UNSAFE.getLong(bytes, i), hash);
    }
    switch (remainingBytes)
    {
    case 7: 
      return ((hash * 461845907 + hashCodeAsciiSanitize(UNSAFE.getByte(bytes, baseOffset))) * 461845907 + hashCodeAsciiSanitize(UNSAFE.getShort(bytes, baseOffset + 1L))) * 461845907 + hashCodeAsciiSanitize(UNSAFE.getInt(bytes, baseOffset + 3L));
    case 6: 
      return (hash * 461845907 + hashCodeAsciiSanitize(UNSAFE.getShort(bytes, baseOffset))) * 461845907 + hashCodeAsciiSanitize(UNSAFE.getInt(bytes, baseOffset + 2L));
    case 5: 
      return (hash * 461845907 + hashCodeAsciiSanitize(UNSAFE.getByte(bytes, baseOffset))) * 461845907 + hashCodeAsciiSanitize(UNSAFE.getInt(bytes, baseOffset + 1L));
    case 4: 
      return hash * 461845907 + hashCodeAsciiSanitize(UNSAFE.getInt(bytes, baseOffset));
    case 3: 
      return (hash * 461845907 + hashCodeAsciiSanitize(UNSAFE.getByte(bytes, baseOffset))) * 461845907 + hashCodeAsciiSanitize(UNSAFE.getShort(bytes, baseOffset + 1L));
    case 2: 
      return hash * 461845907 + hashCodeAsciiSanitize(UNSAFE.getShort(bytes, baseOffset));
    case 1: 
      return hash * 461845907 + hashCodeAsciiSanitize(UNSAFE.getByte(bytes, baseOffset));
    }
    return hash;
  }
  
  static int hashCodeAsciiCompute(long value, int hash)
  {
    return hash * 461845907 + hashCodeAsciiSanitize((int)value) * 461845907 + (int)((value & 0x1F1F1F1F00000000) >>> 32);
  }
  
  static int hashCodeAsciiSanitize(int value)
  {
    return value & 0x1F1F1F1F;
  }
  
  static int hashCodeAsciiSanitize(short value)
  {
    return value & 0x1F1F;
  }
  
  static int hashCodeAsciiSanitize(byte value)
  {
    return value & 0x1F;
  }
  
  static <U, W> AtomicReferenceFieldUpdater<U, W> newAtomicReferenceFieldUpdater(Class<? super U> tclass, String fieldName)
    throws Exception
  {
    return new UnsafeAtomicReferenceFieldUpdater(UNSAFE, tclass, fieldName);
  }
  
  static <T> AtomicIntegerFieldUpdater<T> newAtomicIntegerFieldUpdater(Class<? super T> tclass, String fieldName)
    throws Exception
  {
    return new UnsafeAtomicIntegerFieldUpdater(UNSAFE, tclass, fieldName);
  }
  
  static <T> AtomicLongFieldUpdater<T> newAtomicLongFieldUpdater(Class<? super T> tclass, String fieldName)
    throws Exception
  {
    return new UnsafeAtomicLongFieldUpdater(UNSAFE, tclass, fieldName);
  }
  
  static ClassLoader getClassLoader(Class<?> clazz)
  {
    if (System.getSecurityManager() == null) {
      return clazz.getClassLoader();
    }
    (ClassLoader)AccessController.doPrivileged(new PrivilegedAction()
    {
      public ClassLoader run()
      {
        return val$clazz.getClassLoader();
      }
    });
  }
  
  static ClassLoader getContextClassLoader()
  {
    if (System.getSecurityManager() == null) {
      return Thread.currentThread().getContextClassLoader();
    }
    (ClassLoader)AccessController.doPrivileged(new PrivilegedAction()
    {
      public ClassLoader run()
      {
        return Thread.currentThread().getContextClassLoader();
      }
    });
  }
  
  static ClassLoader getSystemClassLoader()
  {
    if (System.getSecurityManager() == null) {
      return ClassLoader.getSystemClassLoader();
    }
    (ClassLoader)AccessController.doPrivileged(new PrivilegedAction()
    {
      public ClassLoader run()
      {
        return ClassLoader.getSystemClassLoader();
      }
    });
  }
  
  static int addressSize()
  {
    return UNSAFE.addressSize();
  }
  
  static long allocateMemory(long size)
  {
    return UNSAFE.allocateMemory(size);
  }
  
  static void freeMemory(long address)
  {
    UNSAFE.freeMemory(address);
  }
}

/* Location:
 * Qualified Name:     io.netty.util.internal.PlatformDependent0
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */