package io.netty.util.internal.chmv8;

import java.util.concurrent.locks.LockSupport;
import sun.misc.Unsafe;

final class ConcurrentHashMapV8$TreeBin<K, V>
  extends ConcurrentHashMapV8.Node<K, V>
{
  ConcurrentHashMapV8.TreeNode<K, V> root;
  volatile ConcurrentHashMapV8.TreeNode<K, V> first;
  volatile Thread waiter;
  volatile int lockState;
  static final int WRITER = 1;
  static final int WAITER = 2;
  static final int READER = 4;
  private static final Unsafe U;
  private static final long LOCKSTATE;
  
  ConcurrentHashMapV8$TreeBin(ConcurrentHashMapV8.TreeNode<K, V> b)
  {
    super(-2, null, null, null);
    first = b;
    ConcurrentHashMapV8.TreeNode<K, V> r = null;
    ConcurrentHashMapV8.TreeNode<K, V> next;
    for (ConcurrentHashMapV8.TreeNode<K, V> x = b; x != null; x = next)
    {
      next = (ConcurrentHashMapV8.TreeNode)next;
      left = (right = null);
      if (r == null)
      {
        parent = null;
        red = false;
        r = x;
      }
      else
      {
        Object key = key;
        int hash = hash;
        Class<?> kc = null;
        ConcurrentHashMapV8.TreeNode<K, V> p = r;
        for (;;)
        {
          int ph;
          int dir;
          int dir;
          if ((ph = hash) > hash)
          {
            dir = -1;
          }
          else
          {
            int dir;
            if (ph < hash)
            {
              dir = 1;
            }
            else
            {
              int dir;
              if ((kc != null) || ((kc = ConcurrentHashMapV8.comparableClassFor(key)) != null)) {
                dir = ConcurrentHashMapV8.compareComparables(kc, key, key);
              } else {
                dir = 0;
              }
            }
          }
          ConcurrentHashMapV8.TreeNode<K, V> xp = p;
          if ((p = dir <= 0 ? left : right) == null)
          {
            parent = xp;
            if (dir <= 0) {
              left = x;
            } else {
              right = x;
            }
            r = balanceInsertion(r, x);
            break;
          }
        }
      }
    }
    root = r;
  }
  
  private final void lockRoot()
  {
    if (!U.compareAndSwapInt(this, LOCKSTATE, 0, 1)) {
      contendedLock();
    }
  }
  
  private final void unlockRoot()
  {
    lockState = 0;
  }
  
  private final void contendedLock()
  {
    boolean waiting = false;
    for (;;)
    {
      int s;
      if (((s = lockState) & 0x1) == 0)
      {
        if (U.compareAndSwapInt(this, LOCKSTATE, s, 1)) {
          if (waiting) {
            waiter = null;
          }
        }
      }
      else if ((s & 0x2) == 0)
      {
        if (U.compareAndSwapInt(this, LOCKSTATE, s, s | 0x2))
        {
          waiting = true;
          waiter = Thread.currentThread();
        }
      }
      else if (waiting) {
        LockSupport.park(this);
      }
    }
  }
  
  final ConcurrentHashMapV8.Node<K, V> find(int h, Object k)
  {
    if (k != null) {
      for (ConcurrentHashMapV8.Node<K, V> e = first; e != null; e = next)
      {
        int s;
        if (((s = lockState) & 0x3) != 0)
        {
          K ek;
          if ((hash == h) && (((ek = key) == k) || ((ek != null) && (k.equals(ek))))) {
            return e;
          }
        }
        else if (U.compareAndSwapInt(this, LOCKSTATE, s, s + 4))
        {
          try
          {
            ConcurrentHashMapV8.TreeNode<K, V> r;
            p = (r = root) == null ? null : r.findTreeNode(h, k, null);
          }
          finally
          {
            ConcurrentHashMapV8.TreeNode<K, V> p;
            int ls;
            Thread w;
            int ls;
            while (!U.compareAndSwapInt(this, LOCKSTATE, ls = lockState, ls - 4)) {}
            Thread w;
            if ((ls == 6) && ((w = waiter) != null)) {
              LockSupport.unpark(w);
            }
          }
          ConcurrentHashMapV8.TreeNode<K, V> p;
          ConcurrentHashMapV8.TreeNode<K, V> r;
          return p;
        }
      }
    }
    return null;
  }
  
  final ConcurrentHashMapV8.TreeNode<K, V> putTreeVal(int h, K k, V v)
  {
    Class<?> kc = null;
    ConcurrentHashMapV8.TreeNode<K, V> p = root;
    for (;;)
    {
      if (p == null)
      {
        first = (root = new ConcurrentHashMapV8.TreeNode(h, k, v, null, null));
        break;
      }
      int ph;
      int dir;
      if ((ph = hash) > h)
      {
        dir = -1;
      }
      else
      {
        int dir;
        if (ph < h)
        {
          dir = 1;
        }
        else
        {
          K pk;
          if (((pk = key) == k) || ((pk != null) && (k.equals(pk)))) {
            return p;
          }
          int dir;
          if (((kc == null) && ((kc = ConcurrentHashMapV8.comparableClassFor(k)) == null)) || ((dir = ConcurrentHashMapV8.compareComparables(kc, k, pk)) == 0))
          {
            int dir;
            if (left == null)
            {
              dir = 1;
            }
            else
            {
              ConcurrentHashMapV8.TreeNode<K, V> pr;
              ConcurrentHashMapV8.TreeNode<K, V> q;
              int dir;
              if (((pr = right) == null) || ((q = pr.findTreeNode(h, k, kc)) == null))
              {
                dir = -1;
              }
              else
              {
                ConcurrentHashMapV8.TreeNode<K, V> q;
                return q;
              }
            }
          }
        }
      }
      int dir;
      ConcurrentHashMapV8.TreeNode<K, V> xp = p;
      if ((p = dir < 0 ? left : right) == null)
      {
        ConcurrentHashMapV8.TreeNode<K, V> f = first;
        ConcurrentHashMapV8.TreeNode<K, V> x;
        first = (x = new ConcurrentHashMapV8.TreeNode(h, k, v, f, xp));
        if (f != null) {
          prev = x;
        }
        if (dir < 0) {
          left = x;
        } else {
          right = x;
        }
        if (!red)
        {
          red = true; break;
        }
        lockRoot();
        try
        {
          root = balanceInsertion(root, x);
        }
        finally
        {
          unlockRoot();
        }
        break;
      }
    }
    assert (checkInvariants(root));
    return null;
  }
  
  final boolean removeTreeNode(ConcurrentHashMapV8.TreeNode<K, V> p)
  {
    ConcurrentHashMapV8.TreeNode<K, V> next = (ConcurrentHashMapV8.TreeNode)next;
    ConcurrentHashMapV8.TreeNode<K, V> pred = prev;
    if (pred == null) {
      first = next;
    } else {
      next = next;
    }
    if (next != null) {
      prev = pred;
    }
    if (first == null)
    {
      root = null;
      return true;
    }
    ConcurrentHashMapV8.TreeNode<K, V> r;
    ConcurrentHashMapV8.TreeNode<K, V> rl;
    if (((r = root) == null) || (right == null) || ((rl = left) == null) || (left == null)) {
      return true;
    }
    ConcurrentHashMapV8.TreeNode<K, V> rl;
    lockRoot();
    try
    {
      ConcurrentHashMapV8.TreeNode<K, V> pl = left;
      ConcurrentHashMapV8.TreeNode<K, V> pr = right;
      ConcurrentHashMapV8.TreeNode<K, V> replacement;
      ConcurrentHashMapV8.TreeNode<K, V> replacement;
      if ((pl != null) && (pr != null))
      {
        ConcurrentHashMapV8.TreeNode<K, V> s = pr;
        ConcurrentHashMapV8.TreeNode<K, V> sl;
        while ((sl = left) != null) {
          s = sl;
        }
        boolean c = red;red = red;red = c;
        ConcurrentHashMapV8.TreeNode<K, V> sr = right;
        ConcurrentHashMapV8.TreeNode<K, V> pp = parent;
        if (s == pr)
        {
          parent = s;
          right = p;
        }
        else
        {
          ConcurrentHashMapV8.TreeNode<K, V> sp = parent;
          if ((parent = sp) != null) {
            if (s == left) {
              left = p;
            } else {
              right = p;
            }
          }
          right = pr;
          parent = s;
        }
        left = null;
        left = pl;
        parent = s;
        if ((right = sr) != null) {
          parent = p;
        }
        if ((parent = pp) == null) {
          r = s;
        } else if (p == left) {
          left = s;
        } else {
          right = s;
        }
        ConcurrentHashMapV8.TreeNode<K, V> replacement;
        if (sr != null) {
          replacement = sr;
        } else {
          replacement = p;
        }
      }
      else
      {
        ConcurrentHashMapV8.TreeNode<K, V> replacement;
        if (pl != null)
        {
          replacement = pl;
        }
        else
        {
          ConcurrentHashMapV8.TreeNode<K, V> replacement;
          if (pr != null) {
            replacement = pr;
          } else {
            replacement = p;
          }
        }
      }
      if (replacement != p)
      {
        ConcurrentHashMapV8.TreeNode<K, V> pp = parent = parent;
        if (pp == null) {
          r = replacement;
        } else if (p == left) {
          left = replacement;
        } else {
          right = replacement;
        }
        left = (right = parent = null);
      }
      root = (red ? r : balanceDeletion(r, replacement));
      if (p == replacement)
      {
        ConcurrentHashMapV8.TreeNode<K, V> pp;
        if ((pp = parent) != null)
        {
          if (p == left) {
            left = null;
          } else if (p == right) {
            right = null;
          }
          parent = null;
        }
      }
    }
    finally
    {
      unlockRoot();
    }
    assert (checkInvariants(root));
    return false;
  }
  
  static <K, V> ConcurrentHashMapV8.TreeNode<K, V> rotateLeft(ConcurrentHashMapV8.TreeNode<K, V> root, ConcurrentHashMapV8.TreeNode<K, V> p)
  {
    ConcurrentHashMapV8.TreeNode<K, V> r;
    if ((p != null) && ((r = right) != null))
    {
      ConcurrentHashMapV8.TreeNode<K, V> rl;
      if ((rl = right = left) != null) {
        parent = p;
      }
      ConcurrentHashMapV8.TreeNode<K, V> pp;
      if ((pp = parent = parent) == null) {
        red = false;
      } else if (left == p) {
        left = r;
      } else {
        right = r;
      }
      left = p;
      parent = r;
    }
    return root;
  }
  
  static <K, V> ConcurrentHashMapV8.TreeNode<K, V> rotateRight(ConcurrentHashMapV8.TreeNode<K, V> root, ConcurrentHashMapV8.TreeNode<K, V> p)
  {
    ConcurrentHashMapV8.TreeNode<K, V> l;
    if ((p != null) && ((l = left) != null))
    {
      ConcurrentHashMapV8.TreeNode<K, V> lr;
      if ((lr = left = right) != null) {
        parent = p;
      }
      ConcurrentHashMapV8.TreeNode<K, V> pp;
      if ((pp = parent = parent) == null) {
        red = false;
      } else if (right == p) {
        right = l;
      } else {
        left = l;
      }
      right = p;
      parent = l;
    }
    return root;
  }
  
  static <K, V> ConcurrentHashMapV8.TreeNode<K, V> balanceInsertion(ConcurrentHashMapV8.TreeNode<K, V> root, ConcurrentHashMapV8.TreeNode<K, V> x)
  {
    red = true;
    for (;;)
    {
      ConcurrentHashMapV8.TreeNode<K, V> xp;
      if ((xp = parent) == null)
      {
        red = false;
        return x;
      }
      ConcurrentHashMapV8.TreeNode<K, V> xpp;
      if ((!red) || ((xpp = parent) == null)) {
        return root;
      }
      ConcurrentHashMapV8.TreeNode<K, V> xpp;
      ConcurrentHashMapV8.TreeNode<K, V> xppl;
      if (xp == (xppl = left))
      {
        ConcurrentHashMapV8.TreeNode<K, V> xppr;
        if (((xppr = right) != null) && (red))
        {
          red = false;
          red = false;
          red = true;
          x = xpp;
        }
        else
        {
          if (x == right)
          {
            root = rotateLeft(root, x = xp);
            xpp = (xp = parent) == null ? null : parent;
          }
          if (xp != null)
          {
            red = false;
            if (xpp != null)
            {
              red = true;
              root = rotateRight(root, xpp);
            }
          }
        }
      }
      else if ((xppl != null) && (red))
      {
        red = false;
        red = false;
        red = true;
        x = xpp;
      }
      else
      {
        if (x == left)
        {
          root = rotateRight(root, x = xp);
          xpp = (xp = parent) == null ? null : parent;
        }
        if (xp != null)
        {
          red = false;
          if (xpp != null)
          {
            red = true;
            root = rotateLeft(root, xpp);
          }
        }
      }
    }
  }
  
  static <K, V> ConcurrentHashMapV8.TreeNode<K, V> balanceDeletion(ConcurrentHashMapV8.TreeNode<K, V> root, ConcurrentHashMapV8.TreeNode<K, V> x)
  {
    for (;;)
    {
      if ((x == null) || (x == root)) {
        return root;
      }
      ConcurrentHashMapV8.TreeNode<K, V> xp;
      if ((xp = parent) == null)
      {
        red = false;
        return x;
      }
      if (red)
      {
        red = false;
        return root;
      }
      ConcurrentHashMapV8.TreeNode<K, V> xpl;
      if ((xpl = left) == x)
      {
        ConcurrentHashMapV8.TreeNode<K, V> xpr;
        if (((xpr = right) != null) && (red))
        {
          red = false;
          red = true;
          root = rotateLeft(root, xp);
          xpr = (xp = parent) == null ? null : right;
        }
        if (xpr == null)
        {
          x = xp;
        }
        else
        {
          ConcurrentHashMapV8.TreeNode<K, V> sl = left;ConcurrentHashMapV8.TreeNode<K, V> sr = right;
          if (((sr == null) || (!red)) && ((sl == null) || (!red)))
          {
            red = true;
            x = xp;
          }
          else
          {
            if ((sr == null) || (!red))
            {
              if (sl != null) {
                red = false;
              }
              red = true;
              root = rotateRight(root, xpr);
              xpr = (xp = parent) == null ? null : right;
            }
            if (xpr != null)
            {
              red = (xp == null ? false : red);
              if ((sr = right) != null) {
                red = false;
              }
            }
            if (xp != null)
            {
              red = false;
              root = rotateLeft(root, xp);
            }
            x = root;
          }
        }
      }
      else
      {
        if ((xpl != null) && (red))
        {
          red = false;
          red = true;
          root = rotateRight(root, xp);
          xpl = (xp = parent) == null ? null : left;
        }
        if (xpl == null)
        {
          x = xp;
        }
        else
        {
          ConcurrentHashMapV8.TreeNode<K, V> sl = left;ConcurrentHashMapV8.TreeNode<K, V> sr = right;
          if (((sl == null) || (!red)) && ((sr == null) || (!red)))
          {
            red = true;
            x = xp;
          }
          else
          {
            if ((sl == null) || (!red))
            {
              if (sr != null) {
                red = false;
              }
              red = true;
              root = rotateLeft(root, xpl);
              xpl = (xp = parent) == null ? null : left;
            }
            if (xpl != null)
            {
              red = (xp == null ? false : red);
              if ((sl = left) != null) {
                red = false;
              }
            }
            if (xp != null)
            {
              red = false;
              root = rotateRight(root, xp);
            }
            x = root;
          }
        }
      }
    }
  }
  
  static <K, V> boolean checkInvariants(ConcurrentHashMapV8.TreeNode<K, V> t)
  {
    ConcurrentHashMapV8.TreeNode<K, V> tp = parent;ConcurrentHashMapV8.TreeNode<K, V> tl = left;ConcurrentHashMapV8.TreeNode<K, V> tr = right;
    ConcurrentHashMapV8.TreeNode<K, V> tb = prev;ConcurrentHashMapV8.TreeNode<K, V> tn = (ConcurrentHashMapV8.TreeNode)next;
    if ((tb != null) && (next != t)) {
      return false;
    }
    if ((tn != null) && (prev != t)) {
      return false;
    }
    if ((tp != null) && (t != left) && (t != right)) {
      return false;
    }
    if ((tl != null) && ((parent != t) || (hash > hash))) {
      return false;
    }
    if ((tr != null) && ((parent != t) || (hash < hash))) {
      return false;
    }
    if ((red) && (tl != null) && (red) && (tr != null) && (red)) {
      return false;
    }
    if ((tl != null) && (!checkInvariants(tl))) {
      return false;
    }
    if ((tr != null) && (!checkInvariants(tr))) {
      return false;
    }
    return true;
  }
  
  static
  {
    try
    {
      U = ConcurrentHashMapV8.access$000();
      Class<?> k = TreeBin.class;
      LOCKSTATE = U.objectFieldOffset(k.getDeclaredField("lockState"));
    }
    catch (Exception e)
    {
      throw new Error(e);
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.util.internal.chmv8.ConcurrentHashMapV8.TreeBin
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */