package io.netty.util.internal.chmv8;

import java.util.concurrent.RejectedExecutionException;
import sun.misc.Unsafe;

final class ForkJoinPool$WorkQueue
{
  static final int INITIAL_QUEUE_CAPACITY = 8192;
  static final int MAXIMUM_QUEUE_CAPACITY = 67108864;
  volatile long pad00;
  volatile long pad01;
  volatile long pad02;
  volatile long pad03;
  volatile long pad04;
  volatile long pad05;
  volatile long pad06;
  volatile int eventCount;
  int nextWait;
  int nsteals;
  int hint;
  short poolIndex;
  final short mode;
  volatile int qlock;
  volatile int base;
  int top;
  ForkJoinTask<?>[] array;
  final ForkJoinPool pool;
  final ForkJoinWorkerThread owner;
  volatile Thread parker;
  volatile ForkJoinTask<?> currentJoin;
  ForkJoinTask<?> currentSteal;
  volatile Object pad10;
  volatile Object pad11;
  volatile Object pad12;
  volatile Object pad13;
  volatile Object pad14;
  volatile Object pad15;
  volatile Object pad16;
  volatile Object pad17;
  volatile Object pad18;
  volatile Object pad19;
  volatile Object pad1a;
  volatile Object pad1b;
  volatile Object pad1c;
  volatile Object pad1d;
  private static final Unsafe U;
  private static final long QBASE;
  private static final long QLOCK;
  private static final int ABASE;
  private static final int ASHIFT;
  
  ForkJoinPool$WorkQueue(ForkJoinPool pool, ForkJoinWorkerThread owner, int mode, int seed)
  {
    this.pool = pool;
    this.owner = owner;
    this.mode = ((short)mode);
    hint = seed;
    
    base = (top = '?');
  }
  
  final int queueSize()
  {
    int n = base - top;
    return n >= 0 ? 0 : -n;
  }
  
  final boolean isEmpty()
  {
    int s;
    int n = base - (s = top);
    ForkJoinTask<?>[] a;
    int m;
    return (n >= 0) || ((n == -1) && (((a = array) == null) || ((m = a.length - 1) < 0) || (U.getObject(a, ((m & s - 1) << ASHIFT) + ABASE) == null)));
  }
  
  final void push(ForkJoinTask<?> task)
  {
    int s = top;
    ForkJoinTask<?>[] a;
    if ((a = array) != null)
    {
      int m = a.length - 1;
      U.putOrderedObject(a, ((m & s) << ASHIFT) + ABASE, task);
      int n;
      if ((n = (top = s + 1) - base) <= 2)
      {
        ForkJoinPool p;
        (p = pool).signalWork(workQueues, this);
      }
      else if (n >= m)
      {
        growArray();
      }
    }
  }
  
  final ForkJoinTask<?>[] growArray()
  {
    ForkJoinTask<?>[] oldA = array;
    int size = oldA != null ? oldA.length << 1 : 8192;
    if (size > 67108864) {
      throw new RejectedExecutionException("Queue capacity exceeded");
    }
    ForkJoinTask<?>[] a = array = new ForkJoinTask[size];
    int oldMask;
    int t;
    int b;
    if ((oldA != null) && ((oldMask = oldA.length - 1) >= 0) && ((t = top) - (b = base) > 0))
    {
      int mask = size - 1;
      do
      {
        int oldj = ((b & oldMask) << ASHIFT) + ABASE;
        int j = ((b & mask) << ASHIFT) + ABASE;
        ForkJoinTask<?> x = (ForkJoinTask)U.getObjectVolatile(oldA, oldj);
        if ((x != null) && (U.compareAndSwapObject(oldA, oldj, x, null))) {
          U.putObjectVolatile(a, j, x);
        }
        b++;
      } while (b != t);
    }
    return a;
  }
  
  final ForkJoinTask<?> pop()
  {
    ForkJoinTask<?>[] a;
    int m;
    if (((a = array) != null) && ((m = a.length - 1) >= 0))
    {
      int s;
      while ((s = top - 1) - base >= 0)
      {
        long j = ((m & s) << ASHIFT) + ABASE;
        ForkJoinTask<?> t;
        if ((t = (ForkJoinTask)U.getObject(a, j)) == null) {
          break;
        }
        if (U.compareAndSwapObject(a, j, t, null))
        {
          top = s;
          return t;
        }
      }
    }
    return null;
  }
  
  final ForkJoinTask<?> pollAt(int b)
  {
    ForkJoinTask<?>[] a;
    if ((a = array) != null)
    {
      int j = ((a.length - 1 & b) << ASHIFT) + ABASE;
      ForkJoinTask<?> t;
      if (((t = (ForkJoinTask)U.getObjectVolatile(a, j)) != null) && (base == b) && (U.compareAndSwapObject(a, j, t, null)))
      {
        U.putOrderedInt(this, QBASE, b + 1);
        return t;
      }
    }
    return null;
  }
  
  final ForkJoinTask<?> poll()
  {
    int b;
    ForkJoinTask<?>[] a;
    while (((b = base) - top < 0) && ((a = array) != null))
    {
      int j = ((a.length - 1 & b) << ASHIFT) + ABASE;
      ForkJoinTask<?> t = (ForkJoinTask)U.getObjectVolatile(a, j);
      if (t != null)
      {
        if (U.compareAndSwapObject(a, j, t, null))
        {
          U.putOrderedInt(this, QBASE, b + 1);
          return t;
        }
      }
      else if (base == b)
      {
        if (b + 1 == top) {
          break;
        }
        Thread.yield();
      }
    }
    return null;
  }
  
  final ForkJoinTask<?> nextLocalTask()
  {
    return mode == 0 ? pop() : poll();
  }
  
  final ForkJoinTask<?> peek()
  {
    ForkJoinTask<?>[] a = array;
    int m;
    if ((a == null) || ((m = a.length - 1) < 0)) {
      return null;
    }
    int m;
    int i = mode == 0 ? top - 1 : base;
    int j = ((i & m) << ASHIFT) + ABASE;
    return (ForkJoinTask)U.getObjectVolatile(a, j);
  }
  
  final boolean tryUnpush(ForkJoinTask<?> t)
  {
    ForkJoinTask<?>[] a;
    int s;
    if (((a = array) != null) && ((s = top) != base) && (U.compareAndSwapObject(a, ((a.length - 1 & --s) << ASHIFT) + ABASE, t, null)))
    {
      top = s;
      return true;
    }
    return false;
  }
  
  final void cancelAll()
  {
    ForkJoinTask.cancelIgnoringExceptions(currentJoin);
    ForkJoinTask.cancelIgnoringExceptions(currentSteal);
    ForkJoinTask<?> t;
    while ((t = poll()) != null) {
      ForkJoinTask.cancelIgnoringExceptions(t);
    }
  }
  
  final void pollAndExecAll()
  {
    ForkJoinTask<?> t;
    while ((t = poll()) != null) {
      t.doExec();
    }
  }
  
  final void runTask(ForkJoinTask<?> task)
  {
    if ((currentSteal = task) != null)
    {
      task.doExec();
      ForkJoinTask<?>[] a = array;
      int md = mode;
      nsteals += 1;
      currentSteal = null;
      if (md != 0)
      {
        pollAndExecAll();
      }
      else if (a != null)
      {
        int m = a.length - 1;
        int s;
        while ((s = top - 1) - base >= 0)
        {
          long i = ((m & s) << ASHIFT) + ABASE;
          ForkJoinTask<?> t = (ForkJoinTask)U.getObject(a, i);
          if (t == null) {
            break;
          }
          if (U.compareAndSwapObject(a, i, t, null))
          {
            top = s;
            t.doExec();
          }
        }
      }
    }
  }
  
  final boolean tryRemoveAndExec(ForkJoinTask<?> task)
  {
    ForkJoinTask<?>[] a;
    int m;
    int s;
    int b;
    int n;
    boolean stat;
    if ((task != null) && ((a = array) != null) && ((m = a.length - 1) >= 0) && ((n = (s = top) - (b = base)) > 0))
    {
      boolean removed = false;boolean empty = true;
      boolean stat = true;
      for (;;)
      {
        s--;long j = ((s & m) << ASHIFT) + ABASE;
        ForkJoinTask<?> t = (ForkJoinTask)U.getObject(a, j);
        if (t == null) {
          break;
        }
        if (t == task)
        {
          if (s + 1 == top)
          {
            if (!U.compareAndSwapObject(a, j, task, null)) {
              break;
            }
            top = s;
            removed = true; break;
          }
          if (base != b) {
            break;
          }
          removed = U.compareAndSwapObject(a, j, task, new ForkJoinPool.EmptyTask()); break;
        }
        if (status >= 0)
        {
          empty = false;
        }
        else if (s + 1 == top)
        {
          if (!U.compareAndSwapObject(a, j, t, null)) {
            break;
          }
          top = s; break;
        }
        n--;
        if (n == 0)
        {
          if ((empty) || (base != b)) {
            break;
          }
          stat = false; break;
        }
      }
      if (removed) {
        task.doExec();
      }
    }
    else
    {
      stat = false;
    }
    return stat;
  }
  
  final boolean pollAndExecCC(CountedCompleter<?> root)
  {
    int b;
    ForkJoinTask<?>[] a;
    if (((b = base) - top < 0) && ((a = array) != null))
    {
      long j = ((a.length - 1 & b) << ASHIFT) + ABASE;
      Object o;
      if ((o = U.getObjectVolatile(a, j)) == null) {
        return true;
      }
      if ((o instanceof CountedCompleter))
      {
        CountedCompleter<?> t = (CountedCompleter)o;CountedCompleter<?> r = t;
        for (;;)
        {
          if (r == root)
          {
            if ((base == b) && (U.compareAndSwapObject(a, j, t, null)))
            {
              U.putOrderedInt(this, QBASE, b + 1);
              t.doExec();
            }
            return true;
          }
          if ((r = completer) == null) {
            break;
          }
        }
      }
    }
    return false;
  }
  
  final boolean externalPopAndExecCC(CountedCompleter<?> root)
  {
    int s;
    ForkJoinTask<?>[] a;
    if ((base - (s = top) < 0) && ((a = array) != null))
    {
      long j = ((a.length - 1 & s - 1) << ASHIFT) + ABASE;
      Object o;
      if (((o = U.getObject(a, j)) instanceof CountedCompleter))
      {
        CountedCompleter<?> t = (CountedCompleter)o;CountedCompleter<?> r = t;
        for (;;)
        {
          if (r == root)
          {
            if (U.compareAndSwapInt(this, QLOCK, 0, 1)) {
              if ((top == s) && (array == a) && (U.compareAndSwapObject(a, j, t, null)))
              {
                top = (s - 1);
                qlock = 0;
                t.doExec();
              }
              else
              {
                qlock = 0;
              }
            }
            return true;
          }
          if ((r = completer) == null) {
            break;
          }
        }
      }
    }
    return false;
  }
  
  final boolean internalPopAndExecCC(CountedCompleter<?> root)
  {
    int s;
    ForkJoinTask<?>[] a;
    if ((base - (s = top) < 0) && ((a = array) != null))
    {
      long j = ((a.length - 1 & s - 1) << ASHIFT) + ABASE;
      Object o;
      if (((o = U.getObject(a, j)) instanceof CountedCompleter))
      {
        CountedCompleter<?> t = (CountedCompleter)o;CountedCompleter<?> r = t;
        for (;;)
        {
          if (r == root)
          {
            if (U.compareAndSwapObject(a, j, t, null))
            {
              top = (s - 1);
              t.doExec();
            }
            return true;
          }
          if ((r = completer) == null) {
            break;
          }
        }
      }
    }
    return false;
  }
  
  final boolean isApparentlyUnblocked()
  {
    Thread wt;
    Thread.State s;
    return (eventCount >= 0) && ((wt = owner) != null) && ((s = wt.getState()) != Thread.State.BLOCKED) && (s != Thread.State.WAITING) && (s != Thread.State.TIMED_WAITING);
  }
  
  static
  {
    try
    {
      U = ForkJoinPool.access$000();
      Class<?> k = WorkQueue.class;
      Class<?> ak = ForkJoinTask[].class;
      QBASE = U.objectFieldOffset(k.getDeclaredField("base"));
      
      QLOCK = U.objectFieldOffset(k.getDeclaredField("qlock"));
      
      ABASE = U.arrayBaseOffset(ak);
      int scale = U.arrayIndexScale(ak);
      if ((scale & scale - 1) != 0) {
        throw new Error("data type scale not a power of two");
      }
      ASHIFT = 31 - Integer.numberOfLeadingZeros(scale);
    }
    catch (Exception e)
    {
      throw new Error(e);
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.util.internal.chmv8.ForkJoinPool.WorkQueue
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */