package io.netty.buffer;

final class PoolArena$HeapArena
  extends PoolArena<byte[]>
{
  PoolArena$HeapArena(PooledByteBufAllocator parent, int pageSize, int maxOrder, int pageShifts, int chunkSize)
  {
    super(parent, pageSize, maxOrder, pageShifts, chunkSize);
  }
  
  boolean isDirect()
  {
    return false;
  }
  
  protected PoolChunk<byte[]> newChunk(int pageSize, int maxOrder, int pageShifts, int chunkSize)
  {
    return new PoolChunk(this, new byte[chunkSize], pageSize, maxOrder, pageShifts, chunkSize);
  }
  
  protected PoolChunk<byte[]> newUnpooledChunk(int capacity)
  {
    return new PoolChunk(this, new byte[capacity], capacity);
  }
  
  protected void destroyChunk(PoolChunk<byte[]> chunk) {}
  
  protected PooledByteBuf<byte[]> newByteBuf(int maxCapacity)
  {
    return HAS_UNSAFE ? PooledUnsafeHeapByteBuf.newUnsafeInstance(maxCapacity) : PooledHeapByteBuf.newInstance(maxCapacity);
  }
  
  protected void memoryCopy(byte[] src, int srcOffset, byte[] dst, int dstOffset, int length)
  {
    if (length == 0) {
      return;
    }
    System.arraycopy(src, srcOffset, dst, dstOffset, length);
  }
}

/* Location:
 * Qualified Name:     io.netty.buffer.PoolArena.HeapArena
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */