package io.netty.buffer;

import io.netty.util.concurrent.FastThreadLocal;
import java.nio.ByteBuffer;
import java.util.concurrent.atomic.AtomicInteger;

final class PooledByteBufAllocator$PoolThreadLocalCache
  extends FastThreadLocal<PoolThreadCache>
{
  PooledByteBufAllocator$PoolThreadLocalCache(PooledByteBufAllocator paramPooledByteBufAllocator) {}
  
  protected synchronized PoolThreadCache initialValue()
  {
    PoolArena<byte[]> heapArena = leastUsedArena(PooledByteBufAllocator.access$000(this$0));
    PoolArena<ByteBuffer> directArena = leastUsedArena(PooledByteBufAllocator.access$100(this$0));
    
    return new PoolThreadCache(heapArena, directArena, PooledByteBufAllocator.access$200(this$0), PooledByteBufAllocator.access$300(this$0), PooledByteBufAllocator.access$400(this$0), PooledByteBufAllocator.access$500(), PooledByteBufAllocator.access$600());
  }
  
  protected void onRemoval(PoolThreadCache threadCache)
  {
    threadCache.free();
  }
  
  private <T> PoolArena<T> leastUsedArena(PoolArena<T>[] arenas)
  {
    if ((arenas == null) || (arenas.length == 0)) {
      return null;
    }
    PoolArena<T> minArena = arenas[0];
    for (int i = 1; i < arenas.length; i++)
    {
      PoolArena<T> arena = arenas[i];
      if (numThreadCaches.get() < numThreadCaches.get()) {
        minArena = arena;
      }
    }
    return minArena;
  }
}

/* Location:
 * Qualified Name:     io.netty.buffer.PooledByteBufAllocator.PoolThreadLocalCache
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */