package io.netty.channel;

import io.netty.util.Recycler.Handle;
import io.netty.util.internal.SystemPropertyUtil;

abstract class AbstractChannelHandlerContext$AbstractWriteTask
  implements Runnable
{
  private static final boolean ESTIMATE_TASK_SIZE_ON_SUBMIT = SystemPropertyUtil.getBoolean("io.netty.transport.estimateSizeOnSubmit", true);
  private static final int WRITE_TASK_OVERHEAD = SystemPropertyUtil.getInt("io.netty.transport.writeTaskSizeOverhead", 48);
  private final Recycler.Handle<AbstractWriteTask> handle;
  private AbstractChannelHandlerContext ctx;
  private Object msg;
  private ChannelPromise promise;
  private int size;
  
  private AbstractChannelHandlerContext$AbstractWriteTask(Recycler.Handle<? extends AbstractWriteTask> handle)
  {
    this.handle = handle;
  }
  
  protected static void init(AbstractWriteTask task, AbstractChannelHandlerContext ctx, Object msg, ChannelPromise promise)
  {
    task.ctx = ctx;
    task.msg = msg;
    task.promise = promise;
    if (ESTIMATE_TASK_SIZE_ON_SUBMIT)
    {
      ChannelOutboundBuffer buffer = ctx.channel().unsafe().outboundBuffer();
      if (buffer != null)
      {
        size = (AbstractChannelHandlerContext.access$1800(ctx).estimatorHandle().size(msg) + WRITE_TASK_OVERHEAD);
        buffer.incrementPendingOutboundBytes(size);
      }
      else
      {
        size = 0;
      }
    }
    else
    {
      size = 0;
    }
  }
  
  public final void run()
  {
    try
    {
      ChannelOutboundBuffer buffer = ctx.channel().unsafe().outboundBuffer();
      if ((ESTIMATE_TASK_SIZE_ON_SUBMIT) && (buffer != null)) {
        buffer.decrementPendingOutboundBytes(size);
      }
      write(ctx, msg, promise);
    }
    finally
    {
      ctx = null;
      msg = null;
      promise = null;
      handle.recycle(this);
    }
  }
  
  protected void write(AbstractChannelHandlerContext ctx, Object msg, ChannelPromise promise)
  {
    AbstractChannelHandlerContext.access$1900(ctx, msg, promise);
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.AbstractChannelHandlerContext.AbstractWriteTask
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */