package io.netty.channel;

public final class ChannelMetadata
{
  private final boolean hasDisconnect;
  private final int defaultMaxMessagesPerRead;
  
  public ChannelMetadata(boolean hasDisconnect)
  {
    this(hasDisconnect, 1);
  }
  
  public ChannelMetadata(boolean hasDisconnect, int defaultMaxMessagesPerRead)
  {
    if (defaultMaxMessagesPerRead <= 0) {
      throw new IllegalArgumentException("defaultMaxMessagesPerRead: " + defaultMaxMessagesPerRead + " (expected > 0)");
    }
    this.hasDisconnect = hasDisconnect;
    this.defaultMaxMessagesPerRead = defaultMaxMessagesPerRead;
  }
  
  public boolean hasDisconnect()
  {
    return hasDisconnect;
  }
  
  public int defaultMaxMessagesPerRead()
  {
    return defaultMaxMessagesPerRead;
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.ChannelMetadata
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */