package io.netty.channel;

import io.netty.util.concurrent.EventExecutor;

final class DefaultChannelHandlerContext
  extends AbstractChannelHandlerContext
{
  private final ChannelHandler handler;
  
  DefaultChannelHandlerContext(DefaultChannelPipeline pipeline, EventExecutor executor, String name, ChannelHandler handler)
  {
    super(pipeline, executor, name, isInbound(handler), isOutbound(handler));
    if (handler == null) {
      throw new NullPointerException("handler");
    }
    this.handler = handler;
  }
  
  public ChannelHandler handler()
  {
    return handler;
  }
  
  private static boolean isInbound(ChannelHandler handler)
  {
    return handler instanceof ChannelInboundHandler;
  }
  
  private static boolean isOutbound(ChannelHandler handler)
  {
    return handler instanceof ChannelOutboundHandler;
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.DefaultChannelHandlerContext
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */