package io.netty.channel;

import java.net.SocketAddress;

final class DefaultChannelPipeline$HeadContext
  extends AbstractChannelHandlerContext
  implements ChannelOutboundHandler, ChannelInboundHandler
{
  private final Channel.Unsafe unsafe;
  
  DefaultChannelPipeline$HeadContext(DefaultChannelPipeline paramDefaultChannelPipeline1, DefaultChannelPipeline pipeline)
  {
    super(pipeline, null, DefaultChannelPipeline.access$500(), false, true);
    unsafe = pipeline.channel().unsafe();
    setAddComplete();
  }
  
  public ChannelHandler handler()
  {
    return this;
  }
  
  public void handlerAdded(ChannelHandlerContext ctx)
    throws Exception
  {}
  
  public void handlerRemoved(ChannelHandlerContext ctx)
    throws Exception
  {}
  
  public void bind(ChannelHandlerContext ctx, SocketAddress localAddress, ChannelPromise promise)
    throws Exception
  {
    unsafe.bind(localAddress, promise);
  }
  
  public void connect(ChannelHandlerContext ctx, SocketAddress remoteAddress, SocketAddress localAddress, ChannelPromise promise)
    throws Exception
  {
    unsafe.connect(remoteAddress, localAddress, promise);
  }
  
  public void disconnect(ChannelHandlerContext ctx, ChannelPromise promise)
    throws Exception
  {
    unsafe.disconnect(promise);
  }
  
  public void close(ChannelHandlerContext ctx, ChannelPromise promise)
    throws Exception
  {
    unsafe.close(promise);
  }
  
  public void deregister(ChannelHandlerContext ctx, ChannelPromise promise)
    throws Exception
  {
    unsafe.deregister(promise);
  }
  
  public void read(ChannelHandlerContext ctx)
  {
    unsafe.beginRead();
  }
  
  public void write(ChannelHandlerContext ctx, Object msg, ChannelPromise promise)
    throws Exception
  {
    unsafe.write(msg, promise);
  }
  
  public void flush(ChannelHandlerContext ctx)
    throws Exception
  {
    unsafe.flush();
  }
  
  public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause)
    throws Exception
  {
    ctx.fireExceptionCaught(cause);
  }
  
  public void channelRegistered(ChannelHandlerContext ctx)
    throws Exception
  {
    this$0.invokeHandlerAddedIfNeeded();
    ctx.fireChannelRegistered();
  }
  
  public void channelUnregistered(ChannelHandlerContext ctx)
    throws Exception
  {
    ctx.fireChannelUnregistered();
    if (!DefaultChannelPipeline.access$600(this$0).isOpen()) {
      DefaultChannelPipeline.access$700(this$0);
    }
  }
  
  public void channelActive(ChannelHandlerContext ctx)
    throws Exception
  {
    ctx.fireChannelActive();
    
    readIfIsAutoRead();
  }
  
  public void channelInactive(ChannelHandlerContext ctx)
    throws Exception
  {
    ctx.fireChannelInactive();
  }
  
  public void channelRead(ChannelHandlerContext ctx, Object msg)
    throws Exception
  {
    ctx.fireChannelRead(msg);
  }
  
  public void channelReadComplete(ChannelHandlerContext ctx)
    throws Exception
  {
    ctx.fireChannelReadComplete();
    
    readIfIsAutoRead();
  }
  
  private void readIfIsAutoRead()
  {
    if (DefaultChannelPipeline.access$600(this$0).config().isAutoRead()) {
      DefaultChannelPipeline.access$600(this$0).read();
    }
  }
  
  public void userEventTriggered(ChannelHandlerContext ctx, Object evt)
    throws Exception
  {
    ctx.fireUserEventTriggered(evt);
  }
  
  public void channelWritabilityChanged(ChannelHandlerContext ctx)
    throws Exception
  {
    ctx.fireChannelWritabilityChanged();
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.DefaultChannelPipeline.HeadContext
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */