package io.netty.channel;

import io.netty.buffer.ByteBuf;
import io.netty.buffer.ByteBufAllocator;

final class DefaultMaxBytesRecvByteBufAllocator$HandleImpl
  implements RecvByteBufAllocator.Handle
{
  private int individualReadMax;
  private int bytesToRead;
  private int lastBytesRead;
  private int attemptBytesRead;
  
  private DefaultMaxBytesRecvByteBufAllocator$HandleImpl(DefaultMaxBytesRecvByteBufAllocator paramDefaultMaxBytesRecvByteBufAllocator) {}
  
  public ByteBuf allocate(ByteBufAllocator alloc)
  {
    return alloc.ioBuffer(guess());
  }
  
  public int guess()
  {
    return Math.min(individualReadMax, bytesToRead);
  }
  
  public void reset(ChannelConfig config)
  {
    bytesToRead = this$0.maxBytesPerRead();
    individualReadMax = this$0.maxBytesPerIndividualRead();
  }
  
  public void incMessagesRead(int amt) {}
  
  public void lastBytesRead(int bytes)
  {
    lastBytesRead = bytes;
    
    bytesToRead -= bytes;
  }
  
  public int lastBytesRead()
  {
    return lastBytesRead;
  }
  
  public boolean continueReading()
  {
    return (bytesToRead > 0) && (attemptBytesRead == lastBytesRead);
  }
  
  public void readComplete() {}
  
  public void attemptedBytesRead(int bytes)
  {
    attemptBytesRead = bytes;
  }
  
  public int attemptedBytesRead()
  {
    return attemptBytesRead;
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.DefaultMaxBytesRecvByteBufAllocator.HandleImpl
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */