package io.netty.channel;

import io.netty.util.concurrent.EventExecutor;
import io.netty.util.internal.PlatformDependent;

final class FailedChannelFuture
  extends CompleteChannelFuture
{
  private final Throwable cause;
  
  FailedChannelFuture(Channel channel, EventExecutor executor, Throwable cause)
  {
    super(channel, executor);
    if (cause == null) {
      throw new NullPointerException("cause");
    }
    this.cause = cause;
  }
  
  public Throwable cause()
  {
    return cause;
  }
  
  public boolean isSuccess()
  {
    return false;
  }
  
  public ChannelFuture sync()
  {
    PlatformDependent.throwException(cause);
    return this;
  }
  
  public ChannelFuture syncUninterruptibly()
  {
    PlatformDependent.throwException(cause);
    return this;
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.FailedChannelFuture
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */