package io.netty.channel;

public class FixedRecvByteBufAllocator
  extends DefaultMaxMessagesRecvByteBufAllocator
{
  private final int bufferSize;
  
  private final class HandleImpl
    extends DefaultMaxMessagesRecvByteBufAllocator.MaxMessageHandle
  {
    private final int bufferSize;
    
    public HandleImpl(int bufferSize)
    {
      super();
      this.bufferSize = bufferSize;
    }
    
    public int guess()
    {
      return bufferSize;
    }
  }
  
  public FixedRecvByteBufAllocator(int bufferSize)
  {
    if (bufferSize <= 0) {
      throw new IllegalArgumentException("bufferSize must greater than 0: " + bufferSize);
    }
    this.bufferSize = bufferSize;
  }
  
  public RecvByteBufAllocator.Handle newHandle()
  {
    return new HandleImpl(bufferSize);
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.FixedRecvByteBufAllocator
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */