package io.netty.channel.epoll;

import io.netty.channel.ChannelConfig;
import io.netty.channel.ChannelPipeline;
import io.netty.channel.ChannelPromise;
import io.netty.channel.EventLoop;
import io.netty.channel.unix.Socket;
import java.net.SocketAddress;

final class AbstractEpollServerChannel$EpollServerSocketUnsafe
  extends AbstractEpollChannel.AbstractEpollUnsafe
{
  AbstractEpollServerChannel$EpollServerSocketUnsafe(AbstractEpollServerChannel paramAbstractEpollServerChannel)
  {
    super(paramAbstractEpollServerChannel);
  }
  
  private final byte[] acceptedAddress = new byte[26];
  
  public void connect(SocketAddress socketAddress, SocketAddress socketAddress2, ChannelPromise channelPromise)
  {
    channelPromise.setFailure(new UnsupportedOperationException());
  }
  
  void epollInReady()
  {
    assert (this$0.eventLoop().inEventLoop());
    if (this$0.fd().isInputShutdown())
    {
      clearEpollIn0();
      return;
    }
    ChannelConfig config = this$0.config();
    EpollRecvByteAllocatorHandle allocHandle = recvBufAllocHandle();
    allocHandle.edgeTriggered(this$0.isFlagSet(Native.EPOLLET));
    
    ChannelPipeline pipeline = this$0.pipeline();
    allocHandle.reset(config);
    epollInBefore();
    
    Throwable exception = null;
    try
    {
      try
      {
        do
        {
          allocHandle.lastBytesRead(this$0.fd().accept(acceptedAddress));
          if (allocHandle.lastBytesRead() == -1) {
            break;
          }
          allocHandle.incMessagesRead(1);
          
          int len = acceptedAddress[0];
          readPending = false;
          pipeline.fireChannelRead(this$0.newChildChannel(allocHandle.lastBytesRead(), acceptedAddress, 1, len));
        } while (allocHandle.continueReading());
      }
      catch (Throwable t)
      {
        exception = t;
      }
      allocHandle.readComplete();
      pipeline.fireChannelReadComplete();
      if (exception != null) {
        pipeline.fireExceptionCaught(exception);
      }
    }
    finally
    {
      epollInFinally(config);
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.epoll.AbstractEpollServerChannel.EpollServerSocketUnsafe
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */