package io.netty.channel.epoll;

import io.netty.channel.ChannelPromise;
import io.netty.channel.EventLoop;
import io.netty.channel.RecvByteBufAllocator.Handle;
import io.netty.channel.unix.FileDescriptor;

final class AbstractEpollStreamChannel$SpliceFdTask
  extends AbstractEpollStreamChannel.SpliceInTask
{
  private final FileDescriptor fd;
  private final ChannelPromise promise;
  private final int offset;
  
  AbstractEpollStreamChannel$SpliceFdTask(AbstractEpollStreamChannel paramAbstractEpollStreamChannel, FileDescriptor fd, int offset, int len, ChannelPromise promise)
  {
    super(paramAbstractEpollStreamChannel, len, promise);
    this.fd = fd;
    this.promise = promise;
    this.offset = offset;
  }
  
  public boolean spliceIn(RecvByteBufAllocator.Handle handle)
  {
    assert (this$0.eventLoop().inEventLoop());
    if (len == 0)
    {
      promise.setSuccess();
      return true;
    }
    try
    {
      FileDescriptor[] pipe = FileDescriptor.pipe();
      FileDescriptor pipeIn = pipe[0];
      FileDescriptor pipeOut = pipe[1];
      try
      {
        int splicedIn = spliceIn(pipeOut, handle);
        int splicedOut;
        if (splicedIn > 0)
        {
          if (len != Integer.MAX_VALUE) {
            len -= splicedIn;
          }
          do
          {
            splicedOut = Native.splice(pipeIn.intValue(), -1L, fd.intValue(), offset, splicedIn);
            splicedIn -= splicedOut;
          } while (splicedIn > 0);
          if (len == 0)
          {
            promise.setSuccess();
            return 1;
          }
        }
        return 0;
      }
      finally
      {
        AbstractEpollStreamChannel.access$1100(pipeIn);
        AbstractEpollStreamChannel.access$1100(pipeOut);
      }
      return true;
    }
    catch (Throwable cause)
    {
      promise.setFailure(cause);
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.epoll.AbstractEpollStreamChannel.SpliceFdTask
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */