package io.netty.channel.epoll;

import io.netty.channel.Channel.Unsafe;
import io.netty.channel.ChannelFuture;
import io.netty.channel.ChannelFutureListener;
import io.netty.channel.ChannelPromise;
import io.netty.channel.EventLoop;
import io.netty.channel.RecvByteBufAllocator.Handle;
import io.netty.channel.unix.FileDescriptor;

final class AbstractEpollStreamChannel$SpliceInChannelTask
  extends AbstractEpollStreamChannel.SpliceInTask
  implements ChannelFutureListener
{
  private final AbstractEpollStreamChannel ch;
  
  AbstractEpollStreamChannel$SpliceInChannelTask(AbstractEpollStreamChannel paramAbstractEpollStreamChannel1, AbstractEpollStreamChannel ch, int len, ChannelPromise promise)
  {
    super(paramAbstractEpollStreamChannel1, len, promise);
    this.ch = ch;
  }
  
  public void operationComplete(ChannelFuture future)
    throws Exception
  {
    if (!future.isSuccess()) {
      promise.setFailure(future.cause());
    }
  }
  
  public boolean spliceIn(RecvByteBufAllocator.Handle handle)
  {
    assert (ch.eventLoop().inEventLoop());
    if (len == 0)
    {
      promise.setSuccess();
      return true;
    }
    try
    {
      FileDescriptor pipeOut = AbstractEpollStreamChannel.access$900(ch);
      if (pipeOut == null)
      {
        FileDescriptor[] pipe = FileDescriptor.pipe();
        AbstractEpollStreamChannel.access$1002(ch, pipe[0]);
        pipeOut = AbstractEpollStreamChannel.access$902(ch, pipe[1]);
      }
      int splicedIn = spliceIn(pipeOut, handle);
      if (splicedIn > 0)
      {
        if (len != Integer.MAX_VALUE) {
          len -= splicedIn;
        }
        ChannelPromise splicePromise;
        ChannelPromise splicePromise;
        if (len == 0) {
          splicePromise = promise;
        } else {
          splicePromise = ch.newPromise().addListener(this);
        }
        boolean autoRead = this$0.config().isAutoRead();
        
        ch.unsafe().write(new AbstractEpollStreamChannel.SpliceOutTask(this$0, ch, splicedIn, autoRead), splicePromise);
        ch.unsafe().flush();
        if ((autoRead) && (!splicePromise.isDone())) {
          this$0.config().setAutoRead(false);
        }
      }
      return len == 0;
    }
    catch (Throwable cause)
    {
      promise.setFailure(cause);
    }
    return true;
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.epoll.AbstractEpollStreamChannel.SpliceInChannelTask
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */