package io.netty.channel.epoll;

import io.netty.channel.ChannelPromise;
import io.netty.channel.RecvByteBufAllocator.Handle;
import io.netty.channel.unix.FileDescriptor;
import io.netty.channel.unix.Socket;
import java.io.IOException;

public abstract class AbstractEpollStreamChannel$SpliceInTask
{
  final ChannelPromise promise;
  int len;
  
  protected AbstractEpollStreamChannel$SpliceInTask(AbstractEpollStreamChannel paramAbstractEpollStreamChannel, int len, ChannelPromise promise)
  {
    this.promise = promise;
    this.len = len;
  }
  
  abstract boolean spliceIn(RecvByteBufAllocator.Handle paramHandle);
  
  protected final int spliceIn(FileDescriptor pipeOut, RecvByteBufAllocator.Handle handle)
    throws IOException
  {
    int length = Math.min(handle.guess(), len);
    int splicedIn = 0;
    for (;;)
    {
      int localSplicedIn = Native.splice(this$0.fd().intValue(), -1L, pipeOut.intValue(), -1L, length);
      if (localSplicedIn == 0) {
        break;
      }
      splicedIn += localSplicedIn;
      length -= localSplicedIn;
    }
    return splicedIn;
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.epoll.AbstractEpollStreamChannel.SpliceInTask
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */