package io.netty.channel.epoll;

import io.netty.channel.unix.FileDescriptor;
import io.netty.util.internal.PlatformDependent;

public final class Epoll
{
  private static final Throwable UNAVAILABILITY_CAUSE;
  
  static
  {
    Throwable cause = null;
    FileDescriptor epollFd = null;
    FileDescriptor eventFd = null;
    try
    {
      epollFd = Native.newEpollCreate();
      eventFd = Native.newEventFd();
      if (epollFd != null) {
        try
        {
          epollFd.close();
        }
        catch (Exception localException) {}
      }
      if (eventFd != null) {
        try
        {
          eventFd.close();
        }
        catch (Exception localException1) {}
      }
      if (cause == null) {
        break label113;
      }
    }
    catch (Throwable t)
    {
      cause = t;
    }
    finally
    {
      if (epollFd != null) {
        try
        {
          epollFd.close();
        }
        catch (Exception localException4) {}
      }
      if (eventFd != null) {
        try
        {
          eventFd.close();
        }
        catch (Exception localException5) {}
      }
    }
    UNAVAILABILITY_CAUSE = cause; return;
    label113:
    UNAVAILABILITY_CAUSE = PlatformDependent.hasUnsafe() ? null : new IllegalStateException("sun.misc.Unsafe not available");
  }
  
  public static boolean isAvailable()
  {
    return UNAVAILABILITY_CAUSE == null;
  }
  
  public static void ensureAvailability()
  {
    if (UNAVAILABILITY_CAUSE != null) {
      throw ((Error)new UnsatisfiedLinkError("failed to load the required native library").initCause(UNAVAILABILITY_CAUSE));
    }
  }
  
  public static Throwable unavailabilityCause()
  {
    return UNAVAILABILITY_CAUSE;
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.epoll.Epoll
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */