package io.netty.channel.epoll;

import io.netty.buffer.ByteBuf;
import io.netty.channel.unix.NativeInetAddress;
import java.net.Inet6Address;
import java.net.InetAddress;
import java.net.InetSocketAddress;

final class NativeDatagramPacketArray$NativeDatagramPacket
{
  private final IovArray array = new IovArray();
  private long memoryAddress;
  private int count;
  private byte[] addr;
  private int scopeId;
  private int port;
  
  private void release()
  {
    array.release();
  }
  
  private boolean init(ByteBuf buf, InetSocketAddress recipient)
  {
    array.clear();
    if (!array.add(buf)) {
      return false;
    }
    memoryAddress = array.memoryAddress(0);
    count = array.count();
    
    InetAddress address = recipient.getAddress();
    if ((address instanceof Inet6Address))
    {
      addr = address.getAddress();
      scopeId = ((Inet6Address)address).getScopeId();
    }
    else
    {
      addr = NativeInetAddress.ipv4MappedIpv6Address(address.getAddress());
      scopeId = 0;
    }
    port = recipient.getPort();
    return true;
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.epoll.NativeDatagramPacketArray.NativeDatagramPacket
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */