package io.netty.channel.group;

import io.netty.channel.Channel;
import io.netty.channel.ChannelException;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.Map.Entry;

public class ChannelGroupException
  extends ChannelException
  implements Iterable<Map.Entry<Channel, Throwable>>
{
  private static final long serialVersionUID = -4093064295562629453L;
  private final Collection<Map.Entry<Channel, Throwable>> failed;
  
  public ChannelGroupException(Collection<Map.Entry<Channel, Throwable>> causes)
  {
    if (causes == null) {
      throw new NullPointerException("causes");
    }
    if (causes.isEmpty()) {
      throw new IllegalArgumentException("causes must be non empty");
    }
    failed = Collections.unmodifiableCollection(causes);
  }
  
  public Iterator<Map.Entry<Channel, Throwable>> iterator()
  {
    return failed.iterator();
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.group.ChannelGroupException
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */