package io.netty.channel.local;

import io.netty.channel.AbstractChannel.AbstractUnsafe;
import io.netty.channel.Channel;
import io.netty.channel.ChannelPipeline;
import io.netty.channel.ChannelPromise;
import java.net.ConnectException;
import java.net.SocketAddress;
import java.nio.channels.AlreadyConnectedException;
import java.nio.channels.ConnectionPendingException;

class LocalChannel$LocalUnsafe
  extends AbstractChannel.AbstractUnsafe
{
  private LocalChannel$LocalUnsafe(LocalChannel paramLocalChannel)
  {
    super(paramLocalChannel);
  }
  
  public void connect(SocketAddress remoteAddress, SocketAddress localAddress, ChannelPromise promise)
  {
    if ((!promise.setUncancellable()) || (!ensureOpen(promise))) {
      return;
    }
    if (LocalChannel.access$600(this$0) == LocalChannel.State.CONNECTED)
    {
      Exception cause = new AlreadyConnectedException();
      safeSetFailure(promise, cause);
      this$0.pipeline().fireExceptionCaught(cause);
      return;
    }
    if (LocalChannel.access$300(this$0) != null) {
      throw new ConnectionPendingException();
    }
    LocalChannel.access$302(this$0, promise);
    if (LocalChannel.access$600(this$0) != LocalChannel.State.BOUND) {
      if (localAddress == null) {
        localAddress = new LocalAddress(this$0);
      }
    }
    if (localAddress != null) {
      try
      {
        this$0.doBind(localAddress);
      }
      catch (Throwable t)
      {
        safeSetFailure(promise, t);
        close(voidPromise());
        return;
      }
    }
    Channel boundChannel = LocalChannelRegistry.get(remoteAddress);
    if (!(boundChannel instanceof LocalServerChannel))
    {
      Exception cause = new ConnectException("connection refused: " + remoteAddress);
      safeSetFailure(promise, cause);
      close(voidPromise());
      return;
    }
    LocalServerChannel serverChannel = (LocalServerChannel)boundChannel;
    LocalChannel.access$702(this$0, serverChannel.serve(this$0));
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.local.LocalChannel.LocalUnsafe
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */