package io.netty.channel.local;

import io.netty.channel.Channel;
import io.netty.channel.ChannelException;
import io.netty.util.internal.PlatformDependent;
import io.netty.util.internal.StringUtil;
import java.net.SocketAddress;
import java.util.concurrent.ConcurrentMap;

final class LocalChannelRegistry
{
  private static final ConcurrentMap<LocalAddress, Channel> boundChannels = ;
  
  static LocalAddress register(Channel channel, LocalAddress oldLocalAddress, SocketAddress localAddress)
  {
    if (oldLocalAddress != null) {
      throw new ChannelException("already bound");
    }
    if (!(localAddress instanceof LocalAddress)) {
      throw new ChannelException("unsupported address type: " + StringUtil.simpleClassName(localAddress));
    }
    LocalAddress addr = (LocalAddress)localAddress;
    if (LocalAddress.ANY.equals(addr)) {
      addr = new LocalAddress(channel);
    }
    Channel boundChannel = (Channel)boundChannels.putIfAbsent(addr, channel);
    if (boundChannel != null) {
      throw new ChannelException("address already in use by: " + boundChannel);
    }
    return addr;
  }
  
  static Channel get(SocketAddress localAddress)
  {
    return (Channel)boundChannels.get(localAddress);
  }
  
  static void unregister(LocalAddress localAddress)
  {
    boundChannels.remove(localAddress);
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.local.LocalChannelRegistry
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */