package io.netty.channel.nio;

import io.netty.buffer.ByteBuf;
import io.netty.buffer.ByteBufAllocator;
import io.netty.channel.ChannelConfig;
import io.netty.channel.ChannelOption;
import io.netty.channel.ChannelPipeline;
import io.netty.channel.RecvByteBufAllocator.Handle;
import io.netty.channel.socket.ChannelInputShutdownEvent;
import java.io.IOException;
import java.nio.channels.SelectionKey;

public class AbstractNioByteChannel$NioByteUnsafe
  extends AbstractNioChannel.AbstractNioUnsafe
{
  protected AbstractNioByteChannel$NioByteUnsafe(AbstractNioByteChannel paramAbstractNioByteChannel)
  {
    super(paramAbstractNioByteChannel);
  }
  
  private void closeOnRead(ChannelPipeline pipeline)
  {
    if (this$0.isOpen()) {
      if (Boolean.TRUE.equals(this$0.config().getOption(ChannelOption.ALLOW_HALF_CLOSURE)))
      {
        this$0.shutdownInput();
        SelectionKey key = this$0.selectionKey();
        key.interestOps(key.interestOps() & (this$0.readInterestOp ^ 0xFFFFFFFF));
        pipeline.fireUserEventTriggered(ChannelInputShutdownEvent.INSTANCE);
      }
      else
      {
        close(voidPromise());
      }
    }
  }
  
  private void handleReadException(ChannelPipeline pipeline, ByteBuf byteBuf, Throwable cause, boolean close, RecvByteBufAllocator.Handle allocHandle)
  {
    if (byteBuf != null) {
      if (byteBuf.isReadable())
      {
        this$0.readPending = false;
        pipeline.fireChannelRead(byteBuf);
      }
      else
      {
        byteBuf.release();
      }
    }
    allocHandle.readComplete();
    pipeline.fireChannelReadComplete();
    pipeline.fireExceptionCaught(cause);
    if ((close) || ((cause instanceof IOException))) {
      closeOnRead(pipeline);
    }
  }
  
  public final void read()
  {
    ChannelConfig config = this$0.config();
    ChannelPipeline pipeline = this$0.pipeline();
    ByteBufAllocator allocator = config.getAllocator();
    RecvByteBufAllocator.Handle allocHandle = recvBufAllocHandle();
    allocHandle.reset(config);
    
    ByteBuf byteBuf = null;
    boolean close = false;
    try
    {
      do
      {
        byteBuf = allocHandle.allocate(allocator);
        allocHandle.lastBytesRead(this$0.doReadBytes(byteBuf));
        if (allocHandle.lastBytesRead() <= 0)
        {
          byteBuf.release();
          byteBuf = null;
          close = allocHandle.lastBytesRead() < 0;
          break;
        }
        allocHandle.incMessagesRead(1);
        this$0.readPending = false;
        pipeline.fireChannelRead(byteBuf);
        byteBuf = null;
      } while (allocHandle.continueReading());
      allocHandle.readComplete();
      pipeline.fireChannelReadComplete();
      if (close) {
        closeOnRead(pipeline);
      }
    }
    catch (Throwable t)
    {
      handleReadException(pipeline, byteBuf, t, close, allocHandle);
    }
    finally
    {
      if ((!this$0.readPending) && (!config.isAutoRead())) {
        removeReadOp();
      }
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.nio.AbstractNioByteChannel.NioByteUnsafe
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */