package io.netty.channel.nio;

import io.netty.channel.ChannelConfig;
import io.netty.channel.ChannelPipeline;
import io.netty.channel.RecvByteBufAllocator.Handle;
import io.netty.channel.ServerChannel;
import java.io.IOException;
import java.net.PortUnreachableException;
import java.util.ArrayList;
import java.util.List;

final class AbstractNioMessageChannel$NioMessageUnsafe
  extends AbstractNioChannel.AbstractNioUnsafe
{
  private AbstractNioMessageChannel$NioMessageUnsafe(AbstractNioMessageChannel paramAbstractNioMessageChannel)
  {
    super(paramAbstractNioMessageChannel);
  }
  
  private final List<Object> readBuf = new ArrayList();
  
  public void read()
  {
    assert (this$0.eventLoop().inEventLoop());
    ChannelConfig config = this$0.config();
    ChannelPipeline pipeline = this$0.pipeline();
    RecvByteBufAllocator.Handle allocHandle = this$0.unsafe().recvBufAllocHandle();
    allocHandle.reset(config);
    
    boolean closed = false;
    Throwable exception = null;
    try
    {
      try
      {
        do
        {
          int localRead = this$0.doReadMessages(readBuf);
          if (localRead == 0) {
            break;
          }
          if (localRead < 0)
          {
            closed = true;
            break;
          }
          allocHandle.incMessagesRead(localRead);
        } while (allocHandle.continueReading());
      }
      catch (Throwable t)
      {
        exception = t;
      }
      int size = readBuf.size();
      for (int i = 0; i < size; i++)
      {
        this$0.readPending = false;
        pipeline.fireChannelRead(readBuf.get(i));
      }
      readBuf.clear();
      allocHandle.readComplete();
      pipeline.fireChannelReadComplete();
      if (exception != null)
      {
        if (((exception instanceof IOException)) && (!(exception instanceof PortUnreachableException))) {
          closed = !(this$0 instanceof ServerChannel);
        }
        pipeline.fireExceptionCaught(exception);
      }
      if (closed)
      {
        this$0.inputShutdown = true;
        if (this$0.isOpen()) {
          close(voidPromise());
        }
      }
    }
    finally
    {
      if ((!this$0.readPending) && (!config.isAutoRead())) {
        removeReadOp();
      }
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.nio.AbstractNioMessageChannel.NioMessageUnsafe
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */