package io.netty.channel.rxtx;

import io.netty.channel.AbstractChannel.AbstractUnsafe;
import io.netty.channel.ChannelPipeline;
import io.netty.channel.ChannelPromise;
import io.netty.channel.EventLoop;
import java.net.SocketAddress;
import java.util.concurrent.TimeUnit;

final class RxtxChannel$RxtxUnsafe
  extends AbstractChannel.AbstractUnsafe
{
  private RxtxChannel$RxtxUnsafe(RxtxChannel paramRxtxChannel)
  {
    super(paramRxtxChannel);
  }
  
  public void connect(SocketAddress remoteAddress, SocketAddress localAddress, final ChannelPromise promise)
  {
    if ((!promise.setUncancellable()) || (!ensureOpen(promise))) {
      return;
    }
    try
    {
      final boolean wasActive = this$0.isActive();
      this$0.doConnect(remoteAddress, localAddress);
      
      int waitTime = ((Integer)this$0.config().getOption(RxtxChannelOption.WAIT_TIME)).intValue();
      if (waitTime > 0)
      {
        this$0.eventLoop().schedule(new Runnable()
        {
          public void run()
          {
            try
            {
              this$0.doInit();
              safeSetSuccess(promise);
              if ((!wasActive) && (this$0.isActive())) {
                this$0.pipeline().fireChannelActive();
              }
            }
            catch (Throwable t)
            {
              safeSetFailure(promise, t);
              closeIfClosed();
            }
          }
        }, waitTime, TimeUnit.MILLISECONDS);
      }
      else
      {
        this$0.doInit();
        safeSetSuccess(promise);
        if ((!wasActive) && (this$0.isActive())) {
          this$0.pipeline().fireChannelActive();
        }
      }
    }
    catch (Throwable t)
    {
      safeSetFailure(promise, t);
      closeIfClosed();
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.channel.rxtx.RxtxChannel.RxtxUnsafe
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */