package io.netty.handler.codec;

import io.netty.util.concurrent.FastThreadLocal;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Locale;
import java.util.TimeZone;

public final class DefaultHeaders$HeaderDateFormat
{
  private static final FastThreadLocal<HeaderDateFormat> dateFormatThreadLocal = new FastThreadLocal()
  {
    protected DefaultHeaders.HeaderDateFormat initialValue()
    {
      return new DefaultHeaders.HeaderDateFormat(null);
    }
  };
  
  static HeaderDateFormat get()
  {
    return (HeaderDateFormat)dateFormatThreadLocal.get();
  }
  
  private final DateFormat dateFormat1 = new SimpleDateFormat("E, dd MMM yyyy HH:mm:ss z", Locale.ENGLISH);
  private final DateFormat dateFormat2 = new SimpleDateFormat("E, dd-MMM-yy HH:mm:ss z", Locale.ENGLISH);
  private final DateFormat dateFormat3 = new SimpleDateFormat("E MMM d HH:mm:ss yyyy", Locale.ENGLISH);
  
  private DefaultHeaders$HeaderDateFormat()
  {
    TimeZone tz = TimeZone.getTimeZone("GMT");
    dateFormat1.setTimeZone(tz);
    dateFormat2.setTimeZone(tz);
    dateFormat3.setTimeZone(tz);
  }
  
  long parse(String text)
    throws ParseException
  {
    Date date = dateFormat1.parse(text);
    if (date == null) {
      date = dateFormat2.parse(text);
    }
    if (date == null) {
      date = dateFormat3.parse(text);
    }
    if (date == null) {
      throw new ParseException(text, 0);
    }
    return date.getTime();
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.DefaultHeaders.HeaderDateFormat
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */