package io.netty.handler.codec;

import io.netty.util.internal.ObjectUtil;
import java.util.Map.Entry;

public class DefaultHeaders$HeaderEntry<K, V>
  implements Map.Entry<K, V>
{
  protected final int hash;
  protected final K key;
  protected V value;
  protected HeaderEntry<K, V> next;
  protected HeaderEntry<K, V> before;
  protected HeaderEntry<K, V> after;
  
  protected DefaultHeaders$HeaderEntry(int hash, K key)
  {
    this.hash = hash;
    this.key = key;
  }
  
  DefaultHeaders$HeaderEntry(int hash, K key, V value, HeaderEntry<K, V> next, HeaderEntry<K, V> head)
  {
    this.hash = hash;
    this.key = key;
    this.value = value;
    this.next = next;
    
    after = head;
    before = before;
    pointNeighborsToThis();
  }
  
  DefaultHeaders$HeaderEntry()
  {
    hash = -1;
    key = null;
    after = this;before = this;
  }
  
  protected final void pointNeighborsToThis()
  {
    before.after = this;
    after.before = this;
  }
  
  public final HeaderEntry<K, V> before()
  {
    return before;
  }
  
  public final HeaderEntry<K, V> after()
  {
    return after;
  }
  
  protected void remove()
  {
    before.after = after;
    after.before = before;
  }
  
  public final K getKey()
  {
    return (K)key;
  }
  
  public final V getValue()
  {
    return (V)value;
  }
  
  public final V setValue(V value)
  {
    ObjectUtil.checkNotNull(value, "value");
    V oldValue = this.value;
    this.value = value;
    return oldValue;
  }
  
  public final String toString()
  {
    return key.toString() + '=' + value.toString();
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.DefaultHeaders.HeaderEntry
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */