package io.netty.handler.codec;

import io.netty.util.internal.ObjectUtil;
import java.util.Collection;
import java.util.Iterator;
import java.util.Set;

abstract class HeadersUtils$DelegatingStringSet<T>
  implements Set<String>
{
  protected final Set<T> allNames;
  
  public HeadersUtils$DelegatingStringSet(Set<T> allNames)
  {
    this.allNames = ((Set)ObjectUtil.checkNotNull(allNames, "allNames"));
  }
  
  public int size()
  {
    return allNames.size();
  }
  
  public boolean isEmpty()
  {
    return allNames.isEmpty();
  }
  
  public boolean contains(Object o)
  {
    return allNames.contains(o.toString());
  }
  
  public Iterator<String> iterator()
  {
    return new HeadersUtils.StringIterator(allNames.iterator());
  }
  
  public Object[] toArray()
  {
    Object[] arr = new Object[size()];
    fillArray(arr);
    return arr;
  }
  
  public <X> X[] toArray(X[] a)
  {
    if ((a == null) || (a.length < size()))
    {
      X[] arr = (Object[])new Object[size()];
      fillArray(arr);
      return arr;
    }
    fillArray(a);
    return a;
  }
  
  private void fillArray(Object[] arr)
  {
    Iterator<T> itr = allNames.iterator();
    for (int i = 0; i < size(); i++) {
      arr[i] = itr.next();
    }
  }
  
  public boolean remove(Object o)
  {
    return allNames.remove(o);
  }
  
  public boolean containsAll(Collection<?> c)
  {
    for (Object o : c) {
      if (!contains(o)) {
        return false;
      }
    }
    return true;
  }
  
  public boolean removeAll(Collection<?> c)
  {
    boolean modified = false;
    for (Object o : c) {
      if (remove(o)) {
        modified = true;
      }
    }
    return modified;
  }
  
  public boolean retainAll(Collection<?> c)
  {
    boolean modified = false;
    Iterator<String> it = iterator();
    while (it.hasNext()) {
      if (!c.contains(it.next()))
      {
        it.remove();
        modified = true;
      }
    }
    return modified;
  }
  
  public void clear()
  {
    allNames.clear();
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.HeadersUtils.DelegatingStringSet
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */