package io.netty.handler.codec.compression;

import io.netty.buffer.ByteBuf;
import java.lang.reflect.Method;
import java.util.zip.Checksum;

final class ByteBufChecksum$ReflectiveByteBufChecksum
  extends ByteBufChecksum.SlowByteBufChecksum
{
  private final Method method;
  
  ByteBufChecksum$ReflectiveByteBufChecksum(Checksum checksum, Method method)
  {
    super(checksum);
    this.method = method;
  }
  
  public void update(ByteBuf b, int off, int len)
  {
    if (b.hasArray()) {
      update(b.array(), b.arrayOffset() + off, len);
    } else {
      try
      {
        method.invoke(checksum, new Object[] { CompressionUtil.safeNioBuffer(b) });
      }
      catch (Throwable cause)
      {
        throw new Error();
      }
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.compression.ByteBufChecksum.ReflectiveByteBufChecksum
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */