package io.netty.handler.codec.haproxy;

public enum HAProxyProxiedProtocol$AddressFamily
{
  AF_UNSPEC((byte)0),  AF_IPv4((byte)16),  AF_IPv6((byte)32),  AF_UNIX((byte)48);
  
  private static final byte FAMILY_MASK = -16;
  private final byte byteValue;
  
  private HAProxyProxiedProtocol$AddressFamily(byte byteValue)
  {
    this.byteValue = byteValue;
  }
  
  public static AddressFamily valueOf(byte tpafByte)
  {
    int addressFamily = tpafByte & 0xFFFFFFF0;
    switch ((byte)addressFamily)
    {
    case 16: 
      return AF_IPv4;
    case 32: 
      return AF_IPv6;
    case 0: 
      return AF_UNSPEC;
    case 48: 
      return AF_UNIX;
    }
    throw new IllegalArgumentException("unknown address family: " + addressFamily);
  }
  
  public byte byteValue()
  {
    return byteValue;
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.haproxy.HAProxyProxiedProtocol.AddressFamily
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */