package io.netty.handler.codec.http;

final class DefaultHttpHeaders$HeaderValueConverterAndValidator
  extends DefaultHttpHeaders.HeaderValueConverter
{
  private DefaultHttpHeaders$HeaderValueConverterAndValidator()
  {
    super(null);
  }
  
  static final HeaderValueConverterAndValidator INSTANCE = new HeaderValueConverterAndValidator();
  
  public CharSequence convertObject(Object value)
  {
    CharSequence seq = super.convertObject(value);
    int state = 0;
    for (int index = 0; index < seq.length(); index++) {
      state = validateValueChar(seq, state, seq.charAt(index));
    }
    if (state != 0) {
      throw new IllegalArgumentException("a header value must not end with '\\r' or '\\n':" + seq);
    }
    return seq;
  }
  
  private static int validateValueChar(CharSequence seq, int state, char character)
  {
    if ((character & 0xFFFFFFF0) == 0) {
      switch (character)
      {
      case '\000': 
        throw new IllegalArgumentException("a header value contains a prohibited character '\000': " + seq);
      case '\013': 
        throw new IllegalArgumentException("a header value contains a prohibited character '\\v': " + seq);
      case '\f': 
        throw new IllegalArgumentException("a header value contains a prohibited character '\\f': " + seq);
      }
    }
    switch (state)
    {
    case 0: 
      switch (character)
      {
      case '\r': 
        return 1;
      case '\n': 
        return 2;
      }
      break;
    case 1: 
      switch (character)
      {
      case '\n': 
        return 2;
      }
      throw new IllegalArgumentException("only '\\n' is allowed after '\\r': " + seq);
    case 2: 
      switch (character)
      {
      case '\t': 
      case ' ': 
        return 0;
      }
      throw new IllegalArgumentException("only ' ' and '\\t' are allowed after '\\n': " + seq);
    }
    return state;
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http.DefaultHttpHeaders.HeaderValueConverterAndValidator
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */