package io.netty.handler.codec.http;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.PrematureChannelClosureException;
import java.util.List;
import java.util.Queue;
import java.util.concurrent.atomic.AtomicLong;

final class HttpClientCodec$Decoder
  extends HttpResponseDecoder
{
  HttpClientCodec$Decoder(HttpClientCodec paramHttpClientCodec, int maxInitialLineLength, int maxHeaderSize, int maxChunkSize, boolean validateHeaders)
  {
    super(maxInitialLineLength, maxHeaderSize, maxChunkSize, validateHeaders);
  }
  
  HttpClientCodec$Decoder(HttpClientCodec paramHttpClientCodec, int maxInitialLineLength, int maxHeaderSize, int maxChunkSize, boolean validateHeaders, int initialBufferSize)
  {
    super(maxInitialLineLength, maxHeaderSize, maxChunkSize, validateHeaders, initialBufferSize);
  }
  
  protected void decode(ChannelHandlerContext ctx, ByteBuf buffer, List<Object> out)
    throws Exception
  {
    if (HttpClientCodec.access$100(this$0))
    {
      int readable = actualReadableBytes();
      if (readable == 0) {
        return;
      }
      out.add(buffer.readBytes(readable));
    }
    else
    {
      int oldSize = out.size();
      super.decode(ctx, buffer, out);
      if (HttpClientCodec.access$300(this$0))
      {
        int size = out.size();
        for (int i = oldSize; i < size; i++) {
          decrement(out.get(i));
        }
      }
    }
  }
  
  private void decrement(Object msg)
  {
    if (msg == null) {
      return;
    }
    if ((msg instanceof LastHttpContent)) {
      HttpClientCodec.access$400(this$0).decrementAndGet();
    }
  }
  
  protected boolean isContentAlwaysEmpty(HttpMessage msg)
  {
    int statusCode = ((HttpResponse)msg).status().code();
    if (statusCode == 100) {
      return true;
    }
    HttpMethod method = (HttpMethod)HttpClientCodec.access$200(this$0).poll();
    
    char firstChar = method.name().charAt(0);
    switch (firstChar)
    {
    case 'H': 
      if (HttpMethod.HEAD.equals(method)) {
        return true;
      }
      break;
    case 'C': 
      if ((statusCode == 200) && 
        (HttpMethod.CONNECT.equals(method)))
      {
        HttpClientCodec.access$102(this$0, true);
        HttpClientCodec.access$200(this$0).clear();
        return true;
      }
      break;
    }
    return super.isContentAlwaysEmpty(msg);
  }
  
  public void channelInactive(ChannelHandlerContext ctx)
    throws Exception
  {
    super.channelInactive(ctx);
    if (HttpClientCodec.access$300(this$0))
    {
      long missingResponses = HttpClientCodec.access$400(this$0).get();
      if (missingResponses > 0L) {
        ctx.fireExceptionCaught(new PrematureChannelClosureException("channel gone inactive with " + missingResponses + " missing response(s)"));
      }
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http.HttpClientCodec.Decoder
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */