package io.netty.handler.codec.http;

import io.netty.buffer.ByteBuf;
import io.netty.handler.codec.DecoderResult;

abstract class HttpObjectAggregator$AggregatedFullHttpMessage
  implements FullHttpMessage
{
  protected final HttpMessage message;
  private final ByteBuf content;
  private HttpHeaders trailingHeaders;
  
  HttpObjectAggregator$AggregatedFullHttpMessage(HttpMessage message, ByteBuf content, HttpHeaders trailingHeaders)
  {
    this.message = message;
    this.content = content;
    this.trailingHeaders = trailingHeaders;
  }
  
  public HttpHeaders trailingHeaders()
  {
    HttpHeaders trailingHeaders = this.trailingHeaders;
    if (trailingHeaders == null) {
      return EmptyHttpHeaders.INSTANCE;
    }
    return trailingHeaders;
  }
  
  void setTrailingHeaders(HttpHeaders trailingHeaders)
  {
    this.trailingHeaders = trailingHeaders;
  }
  
  public HttpVersion getProtocolVersion()
  {
    return message.protocolVersion();
  }
  
  public HttpVersion protocolVersion()
  {
    return message.protocolVersion();
  }
  
  public FullHttpMessage setProtocolVersion(HttpVersion version)
  {
    message.setProtocolVersion(version);
    return this;
  }
  
  public HttpHeaders headers()
  {
    return message.headers();
  }
  
  public DecoderResult decoderResult()
  {
    return message.decoderResult();
  }
  
  public DecoderResult getDecoderResult()
  {
    return message.decoderResult();
  }
  
  public void setDecoderResult(DecoderResult result)
  {
    message.setDecoderResult(result);
  }
  
  public ByteBuf content()
  {
    return content;
  }
  
  public int refCnt()
  {
    return content.refCnt();
  }
  
  public FullHttpMessage retain()
  {
    content.retain();
    return this;
  }
  
  public FullHttpMessage retain(int increment)
  {
    content.retain(increment);
    return this;
  }
  
  public FullHttpMessage touch(Object hint)
  {
    content.touch(hint);
    return this;
  }
  
  public FullHttpMessage touch()
  {
    content.touch();
    return this;
  }
  
  public boolean release()
  {
    return content.release();
  }
  
  public boolean release(int decrement)
  {
    return content.release(decrement);
  }
  
  public abstract FullHttpMessage copy();
  
  public abstract FullHttpMessage duplicate();
  
  public abstract FullHttpMessage retainedDuplicate();
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http.HttpObjectAggregator.AggregatedFullHttpMessage
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */