package io.netty.handler.codec.http;

import io.netty.buffer.ByteBuf;

final class HttpObjectAggregator$AggregatedFullHttpRequest
  extends HttpObjectAggregator.AggregatedFullHttpMessage
  implements FullHttpRequest
{
  HttpObjectAggregator$AggregatedFullHttpRequest(HttpRequest request, ByteBuf content, HttpHeaders trailingHeaders)
  {
    super(request, content, trailingHeaders);
  }
  
  public FullHttpRequest copy()
  {
    return replace(content().copy());
  }
  
  public FullHttpRequest duplicate()
  {
    return replace(content().duplicate());
  }
  
  public FullHttpRequest retainedDuplicate()
  {
    return replace(content().retainedDuplicate());
  }
  
  public FullHttpRequest replace(ByteBuf content)
  {
    DefaultFullHttpRequest dup = new DefaultFullHttpRequest(protocolVersion(), method(), uri(), content);
    dup.headers().set(headers());
    dup.trailingHeaders().set(trailingHeaders());
    return dup;
  }
  
  public FullHttpRequest retain(int increment)
  {
    super.retain(increment);
    return this;
  }
  
  public FullHttpRequest retain()
  {
    super.retain();
    return this;
  }
  
  public FullHttpRequest touch()
  {
    super.touch();
    return this;
  }
  
  public FullHttpRequest touch(Object hint)
  {
    super.touch(hint);
    return this;
  }
  
  public FullHttpRequest setMethod(HttpMethod method)
  {
    ((HttpRequest)message).setMethod(method);
    return this;
  }
  
  public FullHttpRequest setUri(String uri)
  {
    ((HttpRequest)message).setUri(uri);
    return this;
  }
  
  public HttpMethod getMethod()
  {
    return ((HttpRequest)message).method();
  }
  
  public String getUri()
  {
    return ((HttpRequest)message).uri();
  }
  
  public HttpMethod method()
  {
    return getMethod();
  }
  
  public String uri()
  {
    return getUri();
  }
  
  public FullHttpRequest setProtocolVersion(HttpVersion version)
  {
    super.setProtocolVersion(version);
    return this;
  }
  
  public String toString()
  {
    return HttpMessageUtil.appendFullRequest(new StringBuilder(256), this).toString();
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http.HttpObjectAggregator.AggregatedFullHttpRequest
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */