package io.netty.handler.codec.http;

import io.netty.buffer.ByteBuf;

final class HttpObjectAggregator$AggregatedFullHttpResponse
  extends HttpObjectAggregator.AggregatedFullHttpMessage
  implements FullHttpResponse
{
  HttpObjectAggregator$AggregatedFullHttpResponse(HttpResponse message, ByteBuf content, HttpHeaders trailingHeaders)
  {
    super(message, content, trailingHeaders);
  }
  
  public FullHttpResponse copy()
  {
    return replace(content().copy());
  }
  
  public FullHttpResponse duplicate()
  {
    return replace(content().duplicate());
  }
  
  public FullHttpResponse retainedDuplicate()
  {
    return replace(content().retainedDuplicate());
  }
  
  public FullHttpResponse replace(ByteBuf content)
  {
    DefaultFullHttpResponse dup = new DefaultFullHttpResponse(getProtocolVersion(), getStatus(), content);
    dup.headers().set(headers());
    dup.trailingHeaders().set(trailingHeaders());
    return dup;
  }
  
  public FullHttpResponse setStatus(HttpResponseStatus status)
  {
    ((HttpResponse)message).setStatus(status);
    return this;
  }
  
  public HttpResponseStatus getStatus()
  {
    return ((HttpResponse)message).status();
  }
  
  public HttpResponseStatus status()
  {
    return getStatus();
  }
  
  public FullHttpResponse setProtocolVersion(HttpVersion version)
  {
    super.setProtocolVersion(version);
    return this;
  }
  
  public FullHttpResponse retain(int increment)
  {
    super.retain(increment);
    return this;
  }
  
  public FullHttpResponse retain()
  {
    super.retain();
    return this;
  }
  
  public FullHttpResponse touch(Object hint)
  {
    super.touch(hint);
    return this;
  }
  
  public FullHttpResponse touch()
  {
    super.touch();
    return this;
  }
  
  public String toString()
  {
    return HttpMessageUtil.appendFullResponse(new StringBuilder(256), this).toString();
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http.HttpObjectAggregator.AggregatedFullHttpResponse
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */