package io.netty.handler.codec.http;

import io.netty.buffer.ByteBuf;
import io.netty.buffer.ByteBufUtil;
import io.netty.util.AsciiString;
import io.netty.util.CharsetUtil;

public class HttpRequestEncoder
  extends HttpObjectEncoder<HttpRequest>
{
  private static final char SLASH = '/';
  private static final char QUESTION_MARK = '?';
  
  public boolean acceptOutboundMessage(Object msg)
    throws Exception
  {
    return (super.acceptOutboundMessage(msg)) && (!(msg instanceof HttpResponse));
  }
  
  protected void encodeInitialLine(ByteBuf buf, HttpRequest request)
    throws Exception
  {
    AsciiString method = request.method().asciiName();
    ByteBufUtil.copy(method, method.arrayOffset(), buf, method.length());
    buf.writeByte(32);
    
    String uri = request.uri();
    if (uri.length() == 0)
    {
      uri = uri + '/';
    }
    else
    {
      int start = uri.indexOf("://");
      if ((start != -1) && (uri.charAt(0) != '/'))
      {
        int startIndex = start + 3;
        
        int index = uri.indexOf('?', startIndex);
        if (index == -1)
        {
          if (uri.lastIndexOf('/') <= startIndex) {
            uri = uri + '/';
          }
        }
        else if (uri.lastIndexOf('/', index) <= startIndex)
        {
          int len = uri.length();
          StringBuilder sb = new StringBuilder(len + 1);
          sb.append(uri, 0, index).append('/').append(uri, index, len);
          
          uri = sb.toString();
        }
      }
    }
    buf.writeBytes(uri.getBytes(CharsetUtil.UTF_8));
    
    buf.writeByte(32);
    request.protocolVersion().encode(buf);
    buf.writeBytes(CRLF);
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http.HttpRequestEncoder
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */