package io.netty.handler.codec.http;

import io.netty.util.AsciiString;
import io.netty.util.ByteProcessor;

final class HttpResponseStatus$HttpStatusLineProcessor
  implements ByteProcessor
{
  private static final byte ASCII_SPACE = 32;
  private final AsciiString string;
  private int i;
  private int state;
  private HttpResponseStatus status;
  
  public HttpResponseStatus$HttpStatusLineProcessor(AsciiString string)
  {
    this.string = string;
  }
  
  public boolean process(byte value)
  {
    switch (state)
    {
    case 0: 
      if (value == 32) {
        state = 1;
      }
      break;
    case 1: 
      parseStatus(i);
      state = 2;
      return false;
    }
    i += 1;
    return true;
  }
  
  private void parseStatus(int codeEnd)
  {
    int code = string.parseInt(0, codeEnd);
    status = HttpResponseStatus.valueOf(code);
    if (codeEnd < string.length())
    {
      String actualReason = string.toString(codeEnd + 1, string.length());
      if (!status.reasonPhrase().contentEquals(actualReason)) {
        status = new HttpResponseStatus(code, actualReason);
      }
    }
  }
  
  public HttpResponseStatus status()
  {
    if (state <= 1)
    {
      parseStatus(string.length());
      state = 3;
    }
    return status;
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http.HttpResponseStatus.HttpStatusLineProcessor
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */