package io.netty.handler.codec.http;

import io.netty.util.ReferenceCounted;

public final class HttpServerUpgradeHandler$UpgradeEvent
  implements ReferenceCounted
{
  private final CharSequence protocol;
  private final FullHttpRequest upgradeRequest;
  
  HttpServerUpgradeHandler$UpgradeEvent(CharSequence protocol, FullHttpRequest upgradeRequest)
  {
    this.protocol = protocol;
    this.upgradeRequest = upgradeRequest;
  }
  
  public CharSequence protocol()
  {
    return protocol;
  }
  
  public FullHttpRequest upgradeRequest()
  {
    return upgradeRequest;
  }
  
  public int refCnt()
  {
    return upgradeRequest.refCnt();
  }
  
  public UpgradeEvent retain()
  {
    upgradeRequest.retain();
    return this;
  }
  
  public UpgradeEvent retain(int increment)
  {
    upgradeRequest.retain(increment);
    return this;
  }
  
  public UpgradeEvent touch()
  {
    upgradeRequest.touch();
    return this;
  }
  
  public UpgradeEvent touch(Object hint)
  {
    upgradeRequest.touch(hint);
    return this;
  }
  
  public boolean release()
  {
    return upgradeRequest.release();
  }
  
  public boolean release(int decrement)
  {
    return upgradeRequest.release(decrement);
  }
  
  public String toString()
  {
    return "UpgradeEvent [protocol=" + protocol + ", upgradeRequest=" + upgradeRequest + ']';
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http.HttpServerUpgradeHandler.UpgradeEvent
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */