package io.netty.handler.codec.http.websocketx.extensions;

import java.util.Collections;
import java.util.Map;

public final class WebSocketExtensionData
{
  private final String name;
  private final Map<String, String> parameters;
  
  public WebSocketExtensionData(String name, Map<String, String> parameters)
  {
    if (name == null) {
      throw new NullPointerException("name");
    }
    if (parameters == null) {
      throw new NullPointerException("parameters");
    }
    this.name = name;
    this.parameters = Collections.unmodifiableMap(parameters);
  }
  
  public String name()
  {
    return name;
  }
  
  public Map<String, String> parameters()
  {
    return parameters;
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http.websocketx.extensions.WebSocketExtensionData
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */