package io.netty.handler.codec.http.websocketx.extensions.compression;

import io.netty.handler.codec.http.websocketx.extensions.WebSocketExtensionData;
import io.netty.handler.codec.http.websocketx.extensions.WebSocketExtensionDecoder;
import io.netty.handler.codec.http.websocketx.extensions.WebSocketExtensionEncoder;
import io.netty.handler.codec.http.websocketx.extensions.WebSocketServerExtension;
import java.util.Collections;

class DeflateFrameServerExtensionHandshaker$DeflateFrameServerExtension
  implements WebSocketServerExtension
{
  private final String extensionName;
  private final int compressionLevel;
  
  public DeflateFrameServerExtensionHandshaker$DeflateFrameServerExtension(int compressionLevel, String extensionName)
  {
    this.extensionName = extensionName;
    this.compressionLevel = compressionLevel;
  }
  
  public int rsv()
  {
    return 4;
  }
  
  public WebSocketExtensionEncoder newExtensionEncoder()
  {
    return new PerFrameDeflateEncoder(compressionLevel, 15, false);
  }
  
  public WebSocketExtensionDecoder newExtensionDecoder()
  {
    return new PerFrameDeflateDecoder(false);
  }
  
  public WebSocketExtensionData newReponseData()
  {
    return new WebSocketExtensionData(extensionName, Collections.emptyMap());
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http.websocketx.extensions.compression.DeflateFrameServerExtensionHandshaker.DeflateFrameServerExtension
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */