package io.netty.handler.codec.http.websocketx.extensions.compression;

import io.netty.handler.codec.http.websocketx.extensions.WebSocketExtensionData;
import io.netty.handler.codec.http.websocketx.extensions.WebSocketExtensionDecoder;
import io.netty.handler.codec.http.websocketx.extensions.WebSocketExtensionEncoder;
import io.netty.handler.codec.http.websocketx.extensions.WebSocketServerExtension;
import java.util.HashMap;

class PerMessageDeflateServerExtensionHandshaker$PermessageDeflateExtension
  implements WebSocketServerExtension
{
  private final int compressionLevel;
  private final boolean serverNoContext;
  private final int serverWindowSize;
  private final boolean clientNoContext;
  private final int clientWindowSize;
  
  public PerMessageDeflateServerExtensionHandshaker$PermessageDeflateExtension(int compressionLevel, boolean serverNoContext, int serverWindowSize, boolean clientNoContext, int clientWindowSize)
  {
    this.compressionLevel = compressionLevel;
    this.serverNoContext = serverNoContext;
    this.serverWindowSize = serverWindowSize;
    this.clientNoContext = clientNoContext;
    this.clientWindowSize = clientWindowSize;
  }
  
  public int rsv()
  {
    return 4;
  }
  
  public WebSocketExtensionEncoder newExtensionEncoder()
  {
    return new PerMessageDeflateEncoder(compressionLevel, clientWindowSize, clientNoContext);
  }
  
  public WebSocketExtensionDecoder newExtensionDecoder()
  {
    return new PerMessageDeflateDecoder(serverNoContext);
  }
  
  public WebSocketExtensionData newReponseData()
  {
    HashMap<String, String> parameters = new HashMap(4);
    if (serverNoContext) {
      parameters.put("server_no_context_takeover", null);
    }
    if (clientNoContext) {
      parameters.put("client_no_context_takeover", null);
    }
    if (serverWindowSize != 15) {
      parameters.put("server_max_window_bits", Integer.toString(serverWindowSize));
    }
    if (clientWindowSize != 15) {
      parameters.put("client_max_window_bits", Integer.toString(clientWindowSize));
    }
    return new WebSocketExtensionData("permessage-deflate", parameters);
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http.websocketx.extensions.compression.PerMessageDeflateServerExtensionHandshaker.PermessageDeflateExtension
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */