package io.netty.handler.codec.http2;

import io.netty.channel.ChannelFuture;
import io.netty.channel.ChannelFutureListener;
import io.netty.channel.ChannelPromise;

public abstract class DefaultHttp2ConnectionEncoder$FlowControlledBase
  implements Http2RemoteFlowController.FlowControlled, ChannelFutureListener
{
  protected final Http2Stream stream;
  protected ChannelPromise promise;
  protected boolean endOfStream;
  protected int padding;
  
  protected DefaultHttp2ConnectionEncoder$FlowControlledBase(DefaultHttp2ConnectionEncoder paramDefaultHttp2ConnectionEncoder, Http2Stream stream, int padding, boolean endOfStream, ChannelPromise promise)
  {
    if (padding < 0) {
      throw new IllegalArgumentException("padding must be >= 0");
    }
    this.padding = padding;
    this.endOfStream = endOfStream;
    this.stream = stream;
    this.promise = promise;
  }
  
  public void writeComplete()
  {
    if (endOfStream) {
      DefaultHttp2ConnectionEncoder.access$000(this$0).closeStreamLocal(stream, promise);
    }
  }
  
  public void operationComplete(ChannelFuture future)
    throws Exception
  {
    if (!future.isSuccess()) {
      error(this$0.flowController().channelHandlerContext(), future.cause());
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http2.DefaultHttp2ConnectionEncoder.FlowControlledBase
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */