package io.netty.handler.codec.http2;

import io.netty.buffer.ByteBuf;
import io.netty.buffer.ByteBufAllocator;

public class DefaultHttp2FrameReader$HeadersBlockBuilder
{
  private ByteBuf headerBlock;
  
  protected DefaultHttp2FrameReader$HeadersBlockBuilder(DefaultHttp2FrameReader paramDefaultHttp2FrameReader) {}
  
  private void headerSizeExceeded()
    throws Http2Exception
  {
    close();
    throw Http2Exception.connectionError(Http2Error.ENHANCE_YOUR_CALM, "Header size exceeded max allowed size (%d)", new Object[] { Integer.valueOf(DefaultHttp2FrameReader.access$100(this$0).configuration().maxHeaderSize()) });
  }
  
  final void addFragment(ByteBuf fragment, ByteBufAllocator alloc, boolean endOfHeaders)
    throws Http2Exception
  {
    if (headerBlock == null)
    {
      if (fragment.readableBytes() > DefaultHttp2FrameReader.access$100(this$0).configuration().maxHeaderSize()) {
        headerSizeExceeded();
      }
      if (endOfHeaders)
      {
        headerBlock = fragment.retain();
      }
      else
      {
        headerBlock = alloc.buffer(fragment.readableBytes());
        headerBlock.writeBytes(fragment);
      }
      return;
    }
    if (DefaultHttp2FrameReader.access$100(this$0).configuration().maxHeaderSize() - fragment.readableBytes() < headerBlock.readableBytes()) {
      headerSizeExceeded();
    }
    if (headerBlock.isWritable(fragment.readableBytes()))
    {
      headerBlock.writeBytes(fragment);
    }
    else
    {
      ByteBuf buf = alloc.buffer(headerBlock.readableBytes() + fragment.readableBytes());
      buf.writeBytes(headerBlock);
      buf.writeBytes(fragment);
      headerBlock.release();
      headerBlock = buf;
    }
  }
  
  Http2Headers headers()
    throws Http2Exception
  {
    try
    {
      return DefaultHttp2FrameReader.access$100(this$0).decodeHeaders(headerBlock);
    }
    finally
    {
      close();
    }
  }
  
  void close()
  {
    if (headerBlock != null)
    {
      headerBlock.release();
      headerBlock = null;
    }
    DefaultHttp2FrameReader.access$202(this$0, null);
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http2.DefaultHttp2FrameReader.HeadersBlockBuilder
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */