package io.netty.handler.codec.http2;

import io.netty.buffer.ByteBuf;
import io.netty.buffer.ByteBufAllocator;
import io.netty.channel.ChannelHandlerContext;

final class DefaultHttp2FrameWriter$DataFrameHeader
{
  private final int streamId;
  private final ByteBuf buffer;
  private final Http2Flags flags = new Http2Flags();
  private int prevData;
  private int prevPadding;
  private ByteBuf frameHeader;
  
  DefaultHttp2FrameWriter$DataFrameHeader(ChannelHandlerContext ctx, int streamId)
  {
    buffer = ctx.alloc().buffer(30);
    this.streamId = streamId;
  }
  
  ByteBuf slice(int data, int padding, boolean endOfStream)
  {
    if ((data != prevData) || (padding != prevPadding) || (endOfStream != flags.endOfStream()) || (frameHeader == null))
    {
      prevData = data;
      prevPadding = padding;
      flags.paddingPresent(padding > 0);
      flags.endOfStream(endOfStream);
      frameHeader = buffer.readSlice(10).writerIndex(0);
      
      int payloadLength = data + padding;
      Http2CodecUtil.writeFrameHeaderInternal(frameHeader, payloadLength, (byte)0, flags, streamId);
      DefaultHttp2FrameWriter.access$000(frameHeader, padding);
    }
    return frameHeader.slice();
  }
  
  void release()
  {
    buffer.release();
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http2.DefaultHttp2FrameWriter.DataFrameHeader
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */