package io.netty.handler.codec.http2;

import io.netty.handler.codec.DefaultHeaders.NameValidator;
import io.netty.util.AsciiString;
import io.netty.util.internal.PlatformDependent;

final class DefaultHttp2Headers$2
  implements DefaultHeaders.NameValidator<CharSequence>
{
  public void validateName(CharSequence name)
  {
    if ((name == null) || (name.length() == 0)) {
      PlatformDependent.throwException(Http2Exception.connectionError(Http2Error.PROTOCOL_ERROR, "empty headers are not allowed [%s]", new Object[] { name }));
    }
    if ((name instanceof AsciiString))
    {
      try
      {
        index = ((AsciiString)name).forEachByte(DefaultHttp2Headers.access$000());
      }
      catch (Http2Exception e)
      {
        int index;
        PlatformDependent.throwException(e);
        return;
      }
      catch (Throwable t)
      {
        PlatformDependent.throwException(Http2Exception.connectionError(Http2Error.PROTOCOL_ERROR, t, "unexpected error. invalid header name [%s]", new Object[] { name })); return;
      }
      int index;
      if (index != -1) {
        PlatformDependent.throwException(Http2Exception.connectionError(Http2Error.PROTOCOL_ERROR, "invalid header name [%s]", new Object[] { name }));
      }
    }
    else
    {
      for (int i = 0; i < name.length(); i++) {
        if (AsciiString.isUpperCase(name.charAt(i))) {
          PlatformDependent.throwException(Http2Exception.connectionError(Http2Error.PROTOCOL_ERROR, "invalid header name [%s]", new Object[] { name }));
        }
      }
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http2.DefaultHttp2Headers.2
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */