package io.netty.handler.codec.http2;

final class DefaultHttp2LocalFlowController$WindowUpdateVisitor
  implements Http2StreamVisitor
{
  private Http2Exception.CompositeStreamException compositeException;
  private final int delta;
  
  public DefaultHttp2LocalFlowController$WindowUpdateVisitor(DefaultHttp2LocalFlowController paramDefaultHttp2LocalFlowController, int delta)
  {
    this.delta = delta;
  }
  
  public boolean visit(Http2Stream stream)
    throws Http2Exception
  {
    try
    {
      DefaultHttp2LocalFlowController.FlowState state = DefaultHttp2LocalFlowController.access$300(this$0, stream);
      state.incrementFlowControlWindows(delta);
      state.incrementInitialStreamWindow(delta);
    }
    catch (Http2Exception.StreamException e)
    {
      if (compositeException == null) {
        compositeException = new Http2Exception.CompositeStreamException(e.error(), 4);
      }
      compositeException.add(e);
    }
    return true;
  }
  
  public void throwIfError()
    throws Http2Exception.CompositeStreamException
  {
    if (compositeException != null) {
      throw compositeException;
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http2.DefaultHttp2LocalFlowController.WindowUpdateVisitor
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */