package io.netty.handler.codec.http2;

class DefaultHttp2RemoteFlowController$WritabilityMonitor
{
  private boolean inWritePendingBytes;
  private long totalPendingBytes;
  private final StreamByteDistributor.Writer writer = new StreamByteDistributor.Writer()
  {
    public void write(Http2Stream stream, int numBytes)
    {
      DefaultHttp2RemoteFlowController.access$100(this$0, stream).writeAllocatedBytes(numBytes);
    }
  };
  
  private DefaultHttp2RemoteFlowController$WritabilityMonitor(DefaultHttp2RemoteFlowController paramDefaultHttp2RemoteFlowController) {}
  
  void channelWritabilityChange()
    throws Http2Exception
  {}
  
  void stateCancelled(DefaultHttp2RemoteFlowController.FlowState state) {}
  
  void windowSize(DefaultHttp2RemoteFlowController.FlowState state, int initialWindowSize)
  {
    state.windowSize(initialWindowSize);
  }
  
  void incrementWindowSize(DefaultHttp2RemoteFlowController.FlowState state, int delta)
    throws Http2Exception
  {
    state.incrementStreamWindow(delta);
  }
  
  void enqueueFrame(DefaultHttp2RemoteFlowController.FlowState state, Http2RemoteFlowController.FlowControlled frame)
    throws Http2Exception
  {
    state.enqueueFrame(frame);
  }
  
  final void incrementPendingBytes(int delta)
  {
    totalPendingBytes += delta;
  }
  
  final boolean isWritable(DefaultHttp2RemoteFlowController.FlowState state)
  {
    return (isWritableConnection()) && (state.isWritable());
  }
  
  final void writePendingBytes()
    throws Http2Exception
  {
    if (inWritePendingBytes) {
      return;
    }
    inWritePendingBytes = true;
    try
    {
      int bytesToWrite = DefaultHttp2RemoteFlowController.access$900(this$0);
      while ((DefaultHttp2RemoteFlowController.access$600(this$0).distribute(bytesToWrite, writer)) && ((bytesToWrite = DefaultHttp2RemoteFlowController.access$900(this$0)) > 0)) {
        if (!DefaultHttp2RemoteFlowController.access$1000(this$0)) {
          break;
        }
      }
    }
    finally
    {
      inWritePendingBytes = false;
    }
  }
  
  void initialWindowSize(int newWindowSize)
    throws Http2Exception
  {
    if (newWindowSize < 0) {
      throw new IllegalArgumentException("Invalid initial window size: " + newWindowSize);
    }
    final int delta = newWindowSize - DefaultHttp2RemoteFlowController.access$200(this$0);
    DefaultHttp2RemoteFlowController.access$202(this$0, newWindowSize);
    DefaultHttp2RemoteFlowController.access$1100(this$0).forEachActiveStream(new Http2StreamVisitor()
    {
      public boolean visit(Http2Stream stream)
        throws Http2Exception
      {
        DefaultHttp2RemoteFlowController.access$100(this$0, stream).incrementStreamWindow(delta);
        return true;
      }
    });
    if ((delta > 0) && (DefaultHttp2RemoteFlowController.access$1200(this$0))) {
      writePendingBytes();
    }
  }
  
  final boolean isWritableConnection()
  {
    return (DefaultHttp2RemoteFlowController.access$800(this$0).windowSize() - totalPendingBytes > 0L) && (DefaultHttp2RemoteFlowController.access$1200(this$0));
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http2.DefaultHttp2RemoteFlowController.WritabilityMonitor
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */