package io.netty.handler.codec.http2;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.util.internal.ObjectUtil;

final class DelegatingDecompressorFrameListener$ConsumedBytesConverter
  implements Http2LocalFlowController
{
  private final Http2LocalFlowController flowController;
  
  DelegatingDecompressorFrameListener$ConsumedBytesConverter(DelegatingDecompressorFrameListener paramDelegatingDecompressorFrameListener, Http2LocalFlowController flowController)
  {
    this.flowController = ((Http2LocalFlowController)ObjectUtil.checkNotNull(flowController, "flowController"));
  }
  
  public Http2LocalFlowController frameWriter(Http2FrameWriter frameWriter)
  {
    return flowController.frameWriter(frameWriter);
  }
  
  public void channelHandlerContext(ChannelHandlerContext ctx)
    throws Http2Exception
  {
    flowController.channelHandlerContext(ctx);
  }
  
  public void initialWindowSize(int newWindowSize)
    throws Http2Exception
  {
    flowController.initialWindowSize(newWindowSize);
  }
  
  public int initialWindowSize()
  {
    return flowController.initialWindowSize();
  }
  
  public int windowSize(Http2Stream stream)
  {
    return flowController.windowSize(stream);
  }
  
  public void incrementWindowSize(Http2Stream stream, int delta)
    throws Http2Exception
  {
    flowController.incrementWindowSize(stream, delta);
  }
  
  public void receiveFlowControlledFrame(Http2Stream stream, ByteBuf data, int padding, boolean endOfStream)
    throws Http2Exception
  {
    flowController.receiveFlowControlledFrame(stream, data, padding, endOfStream);
  }
  
  public boolean consumeBytes(Http2Stream stream, int numBytes)
    throws Http2Exception
  {
    DelegatingDecompressorFrameListener.Http2Decompressor decompressor = this$0.decompressor(stream);
    if (decompressor != null) {
      numBytes = decompressor.consumeBytes(stream.id(), numBytes);
    }
    try
    {
      return flowController.consumeBytes(stream, numBytes);
    }
    catch (Http2Exception e)
    {
      throw e;
    }
    catch (Throwable t)
    {
      throw Http2Exception.streamError(stream.id(), Http2Error.INTERNAL_ERROR, t, "Error while returning bytes to flow control window", new Object[0]);
    }
  }
  
  public int unconsumedBytes(Http2Stream stream)
  {
    return flowController.unconsumedBytes(stream);
  }
  
  public int initialWindowSize(Http2Stream stream)
  {
    return flowController.initialWindowSize(stream);
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http2.DelegatingDecompressorFrameListener.ConsumedBytesConverter
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */