package io.netty.handler.codec.http2;

import io.netty.channel.ChannelFuture;
import io.netty.channel.ChannelFutureListener;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelPromise;
import io.netty.util.concurrent.EventExecutor;
import io.netty.util.concurrent.ScheduledFuture;
import java.util.concurrent.TimeUnit;

final class Http2ConnectionHandler$ClosingChannelFutureListener
  implements ChannelFutureListener
{
  private final ChannelHandlerContext ctx;
  private final ChannelPromise promise;
  private final ScheduledFuture<?> timeoutTask;
  
  Http2ConnectionHandler$ClosingChannelFutureListener(ChannelHandlerContext ctx, ChannelPromise promise)
  {
    this.ctx = ctx;
    this.promise = promise;
    timeoutTask = null;
  }
  
  Http2ConnectionHandler$ClosingChannelFutureListener(final ChannelHandlerContext ctx, final ChannelPromise promise, long timeout, TimeUnit unit)
  {
    this.ctx = ctx;
    this.promise = promise;
    timeoutTask = ctx.executor().schedule(new Runnable()
    {
      public void run()
      {
        ctx.close(promise);
      }
    }, timeout, unit);
  }
  
  public void operationComplete(ChannelFuture sentGoAwayFuture)
    throws Exception
  {
    if (timeoutTask != null) {
      timeoutTask.cancel(false);
    }
    ctx.close(promise);
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http2.Http2ConnectionHandler.ClosingChannelFutureListener
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */