package io.netty.handler.codec.http2;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;

final class Http2FrameCodec$FrameListener
  extends Http2FrameAdapter
{
  private Http2FrameCodec$FrameListener(Http2FrameCodec paramHttp2FrameCodec) {}
  
  public void onRstStreamRead(ChannelHandlerContext ctx, int streamId, long errorCode)
  {
    Http2ResetFrame rstFrame = new DefaultHttp2ResetFrame(errorCode);
    rstFrame.setStreamId(streamId);
    ctx.fireChannelRead(rstFrame);
  }
  
  public void onHeadersRead(ChannelHandlerContext ctx, int streamId, Http2Headers headers, int streamDependency, short weight, boolean exclusive, int padding, boolean endStream)
  {
    onHeadersRead(ctx, streamId, headers, padding, endStream);
  }
  
  public void onHeadersRead(ChannelHandlerContext ctx, int streamId, Http2Headers headers, int padding, boolean endOfStream)
  {
    Http2HeadersFrame headersFrame = new DefaultHttp2HeadersFrame(headers, endOfStream, padding);
    headersFrame.setStreamId(streamId);
    ctx.fireChannelRead(headersFrame);
  }
  
  public int onDataRead(ChannelHandlerContext ctx, int streamId, ByteBuf data, int padding, boolean endOfStream)
  {
    Http2DataFrame dataFrame = new DefaultHttp2DataFrame(data.retain(), endOfStream, padding);
    dataFrame.setStreamId(streamId);
    ctx.fireChannelRead(dataFrame);
    
    return 0;
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http2.Http2FrameCodec.FrameListener
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */