package io.netty.handler.codec.http2;

import io.netty.util.AsciiString;

public enum Http2Headers$PseudoHeaderName
{
  METHOD(":method"),  SCHEME(":scheme"),  AUTHORITY(":authority"),  PATH(":path"),  STATUS(":status");
  
  private final AsciiString value;
  private static final CharSequenceMap<AsciiString> PSEUDO_HEADERS;
  
  static
  {
    PSEUDO_HEADERS = new CharSequenceMap();
    for (PseudoHeaderName pseudoHeader : values()) {
      PSEUDO_HEADERS.add(pseudoHeader.value(), AsciiString.EMPTY_STRING);
    }
  }
  
  private Http2Headers$PseudoHeaderName(String value)
  {
    this.value = new AsciiString(value);
  }
  
  public AsciiString value()
  {
    return value;
  }
  
  public static boolean isPseudoHeader(CharSequence header)
  {
    return PSEUDO_HEADERS.contains(header);
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http2.Http2Headers.PseudoHeaderName
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */