package io.netty.handler.codec.http2;

import io.netty.channel.ChannelHandlerContext;
import io.netty.util.ReferenceCountUtil;
import io.netty.util.concurrent.EventExecutor;

final class Http2MultiplexCodec$Http2StreamChannel
  extends AbstractHttp2StreamChannel
{
  private final int streamId;
  boolean onStreamClosedFired;
  boolean inStreamsToFireChildReadComplete;
  
  Http2MultiplexCodec$Http2StreamChannel(Http2MultiplexCodec paramHttp2MultiplexCodec, int streamId)
  {
    super(Http2MultiplexCodec.access$100(paramHttp2MultiplexCodec).channel());
    this.streamId = streamId;
  }
  
  protected void doClose()
    throws Exception
  {
    if (!onStreamClosedFired)
    {
      Http2StreamFrame resetFrame = new DefaultHttp2ResetFrame(Http2Error.CANCEL).setStreamId(streamId);
      this$0.writeFromStreamChannel(resetFrame, true);
    }
    super.doClose();
  }
  
  protected void doWrite(Object msg)
  {
    if (!(msg instanceof Http2StreamFrame))
    {
      ReferenceCountUtil.release(msg);
      throw new IllegalArgumentException("Message must be an Http2StreamFrame: " + msg);
    }
    Http2StreamFrame frame = (Http2StreamFrame)msg;
    if (frame.streamId() != -1)
    {
      ReferenceCountUtil.release(frame);
      throw new IllegalArgumentException("Stream must not be set on the frame");
    }
    frame.setStreamId(streamId);
    
    this$0.writeFromStreamChannel(msg, false);
  }
  
  protected void doWriteComplete()
  {
    this$0.flushFromStreamChannel();
  }
  
  protected EventExecutor preferredEventExecutor()
  {
    return Http2MultiplexCodec.access$100(this$0).executor();
  }
  
  protected void bytesConsumed(int bytes)
  {
    Http2MultiplexCodec.access$100(this$0).write(new DefaultHttp2WindowUpdateFrame(bytes).setStreamId(streamId));
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http2.Http2MultiplexCodec.Http2StreamChannel
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */