package io.netty.handler.codec.http2;

import io.netty.buffer.Unpooled;
import io.netty.handler.codec.http.FullHttpMessage;
import io.netty.handler.codec.http.FullHttpRequest;
import io.netty.handler.codec.http.FullHttpResponse;
import io.netty.handler.codec.http.HttpHeaderNames;
import io.netty.handler.codec.http.HttpHeaders;
import io.netty.handler.codec.http.HttpResponseStatus;
import io.netty.handler.codec.http.HttpStatusClass;

final class InboundHttp2ToHttpAdapter$1
  implements InboundHttp2ToHttpAdapter.ImmediateSendDetector
{
  public boolean mustSendImmediately(FullHttpMessage msg)
  {
    if ((msg instanceof FullHttpResponse)) {
      return ((FullHttpResponse)msg).status().codeClass() == HttpStatusClass.INFORMATIONAL;
    }
    if ((msg instanceof FullHttpRequest)) {
      return msg.headers().contains(HttpHeaderNames.EXPECT);
    }
    return false;
  }
  
  public FullHttpMessage copyIfNeeded(FullHttpMessage msg)
  {
    if ((msg instanceof FullHttpRequest))
    {
      FullHttpRequest copy = ((FullHttpRequest)msg).replace(Unpooled.buffer(0));
      copy.headers().remove(HttpHeaderNames.EXPECT);
      return copy;
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http2.InboundHttp2ToHttpAdapter.1
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */