package io.netty.handler.codec.http2;

import java.util.Deque;

final class UniformStreamByteDistributor$State
{
  final Http2Stream stream;
  int streamableBytes;
  boolean windowNegative;
  boolean enqueued;
  boolean writing;
  
  UniformStreamByteDistributor$State(UniformStreamByteDistributor paramUniformStreamByteDistributor, Http2Stream stream)
  {
    this.stream = stream;
  }
  
  void updateStreamableBytes(int newStreamableBytes, boolean hasFrame, int windowSize)
  {
    assert ((hasFrame) || (newStreamableBytes == 0)) : ("hasFrame: " + hasFrame + " newStreamableBytes: " + newStreamableBytes);
    
    int delta = newStreamableBytes - streamableBytes;
    if (delta != 0)
    {
      streamableBytes = newStreamableBytes;
      UniformStreamByteDistributor.access$214(this$0, delta);
    }
    windowNegative = (windowSize < 0);
    if ((hasFrame) && ((windowSize > 0) || ((windowSize == 0) && (!writing)))) {
      addToQueue();
    }
  }
  
  void write(int numBytes, StreamByteDistributor.Writer writer)
    throws Http2Exception
  {
    writing = true;
    try
    {
      writer.write(stream, numBytes);
    }
    catch (Throwable t)
    {
      throw Http2Exception.connectionError(Http2Error.INTERNAL_ERROR, t, "byte distribution write error", new Object[0]);
    }
    finally
    {
      writing = false;
    }
  }
  
  void addToQueue()
  {
    if (!enqueued)
    {
      enqueued = true;
      UniformStreamByteDistributor.access$300(this$0).addLast(this);
    }
  }
  
  void removeFromQueue()
  {
    if (enqueued)
    {
      enqueued = false;
      UniformStreamByteDistributor.access$300(this$0).remove(this);
    }
  }
  
  void close()
  {
    removeFromQueue();
    
    updateStreamableBytes(0, false, 0);
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http2.UniformStreamByteDistributor.State
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */