package io.netty.handler.codec.http2.internal.hpack;

import io.netty.buffer.ByteBuf;
import io.netty.util.ByteProcessor;

final class HuffmanEncoder$EncodeProcessor
  implements ByteProcessor
{
  ByteBuf out;
  private long current;
  private int n;
  
  private HuffmanEncoder$EncodeProcessor(HuffmanEncoder paramHuffmanEncoder) {}
  
  public boolean process(byte value)
  {
    int b = value & 0xFF;
    int nbits = HuffmanEncoder.access$200(this$0)[b];
    
    current <<= nbits;
    current |= HuffmanEncoder.access$300(this$0)[b];
    n += nbits;
    while (n >= 8)
    {
      n -= 8;
      out.writeByte((int)(current >> n));
    }
    return true;
  }
  
  void end()
  {
    try
    {
      if (n > 0)
      {
        current <<= 8 - n;
        current |= 255 >>> n;
        out.writeByte((int)current);
      }
    }
    finally
    {
      out = null;
      current = 0L;
      n = 0;
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.http2.internal.hpack.HuffmanEncoder.EncodeProcessor
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */