package io.netty.handler.codec.memcache.binary;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.PrematureChannelClosureException;
import io.netty.handler.codec.memcache.LastMemcacheContent;
import java.util.List;
import java.util.concurrent.atomic.AtomicLong;

final class BinaryMemcacheClientCodec$Decoder
  extends BinaryMemcacheResponseDecoder
{
  BinaryMemcacheClientCodec$Decoder(BinaryMemcacheClientCodec paramBinaryMemcacheClientCodec, int chunkSize)
  {
    super(chunkSize);
  }
  
  protected void decode(ChannelHandlerContext ctx, ByteBuf in, List<Object> out)
    throws Exception
  {
    int oldSize = out.size();
    super.decode(ctx, in, out);
    if (BinaryMemcacheClientCodec.access$100(this$0))
    {
      int size = out.size();
      for (int i = oldSize; i < size; i++)
      {
        Object msg = out.get(i);
        if ((msg instanceof LastMemcacheContent)) {
          BinaryMemcacheClientCodec.access$200(this$0).decrementAndGet();
        }
      }
    }
  }
  
  public void channelInactive(ChannelHandlerContext ctx)
    throws Exception
  {
    super.channelInactive(ctx);
    if (BinaryMemcacheClientCodec.access$100(this$0))
    {
      long missingResponses = BinaryMemcacheClientCodec.access$200(this$0).get();
      if (missingResponses > 0L) {
        ctx.fireExceptionCaught(new PrematureChannelClosureException("channel gone inactive with " + missingResponses + " missing response(s)"));
      }
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.memcache.binary.BinaryMemcacheClientCodec.Decoder
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */