package io.netty.handler.codec.mqtt;

import io.netty.util.internal.StringUtil;

public final class MqttMessageIdVariableHeader
{
  private final int messageId;
  
  public static MqttMessageIdVariableHeader from(int messageId)
  {
    if ((messageId < 1) || (messageId > 65535)) {
      throw new IllegalArgumentException("messageId: " + messageId + " (expected: 1 ~ 65535)");
    }
    return new MqttMessageIdVariableHeader(messageId);
  }
  
  private MqttMessageIdVariableHeader(int messageId)
  {
    this.messageId = messageId;
  }
  
  public int messageId()
  {
    return messageId;
  }
  
  public String toString()
  {
    return StringUtil.simpleClassName(this) + '[' + "messageId=" + messageId + ']';
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.mqtt.MqttMessageIdVariableHeader
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */