package io.netty.handler.codec.protobuf;

import com.google.protobuf.MessageLite;
import com.google.protobuf.MessageLite.Builder;
import com.google.protobuf.MessageLiteOrBuilder;
import io.netty.buffer.Unpooled;
import io.netty.channel.ChannelHandler.Sharable;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.MessageToMessageEncoder;
import java.util.List;

@ChannelHandler.Sharable
public class ProtobufEncoder
  extends MessageToMessageEncoder<MessageLiteOrBuilder>
{
  protected void encode(ChannelHandlerContext ctx, MessageLiteOrBuilder msg, List<Object> out)
    throws Exception
  {
    if ((msg instanceof MessageLite))
    {
      out.add(Unpooled.wrappedBuffer(((MessageLite)msg).toByteArray()));
      return;
    }
    if ((msg instanceof MessageLite.Builder)) {
      out.add(Unpooled.wrappedBuffer(((MessageLite.Builder)msg).build().toByteArray()));
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.protobuf.ProtobufEncoder
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */