package io.netty.handler.codec.serialization;

class ClassLoaderClassResolver
  implements ClassResolver
{
  private final ClassLoader classLoader;
  
  ClassLoaderClassResolver(ClassLoader classLoader)
  {
    this.classLoader = classLoader;
  }
  
  public Class<?> resolve(String className)
    throws ClassNotFoundException
  {
    try
    {
      return classLoader.loadClass(className);
    }
    catch (ClassNotFoundException ignored) {}
    return Class.forName(className, false, classLoader);
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.serialization.ClassLoaderClassResolver
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */