package io.netty.handler.codec.socks;

import io.netty.buffer.ByteBuf;
import java.util.Collections;
import java.util.List;

public final class SocksInitRequest
  extends SocksRequest
{
  private final List<SocksAuthScheme> authSchemes;
  
  public SocksInitRequest(List<SocksAuthScheme> authSchemes)
  {
    super(SocksRequestType.INIT);
    if (authSchemes == null) {
      throw new NullPointerException("authSchemes");
    }
    this.authSchemes = authSchemes;
  }
  
  public List<SocksAuthScheme> authSchemes()
  {
    return Collections.unmodifiableList(authSchemes);
  }
  
  public void encodeAsByteBuf(ByteBuf byteBuf)
  {
    byteBuf.writeByte(protocolVersion().byteValue());
    byteBuf.writeByte(authSchemes.size());
    for (SocksAuthScheme authScheme : authSchemes) {
      byteBuf.writeByte(authScheme.byteValue());
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.socks.SocksInitRequest
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */