package io.netty.handler.codec.socks;

import io.netty.buffer.ByteBuf;

public final class SocksInitResponse
  extends SocksResponse
{
  private final SocksAuthScheme authScheme;
  
  public SocksInitResponse(SocksAuthScheme authScheme)
  {
    super(SocksResponseType.INIT);
    if (authScheme == null) {
      throw new NullPointerException("authScheme");
    }
    this.authScheme = authScheme;
  }
  
  public SocksAuthScheme authScheme()
  {
    return authScheme;
  }
  
  public void encodeAsByteBuf(ByteBuf byteBuf)
  {
    byteBuf.writeByte(protocolVersion().byteValue());
    byteBuf.writeByte(authScheme.byteValue());
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.socks.SocksInitResponse
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */