package io.netty.handler.codec.socks;

import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelPipeline;
import io.netty.handler.codec.ReplayingDecoder;
import java.util.List;

public class SocksInitResponseDecoder
  extends ReplayingDecoder<State>
{
  private SocksProtocolVersion version;
  private SocksAuthScheme authScheme;
  private SocksResponse msg = SocksCommonUtils.UNKNOWN_SOCKS_RESPONSE;
  
  public SocksInitResponseDecoder()
  {
    super(State.CHECK_PROTOCOL_VERSION);
  }
  
  protected void decode(ChannelHandlerContext ctx, ByteBuf byteBuf, List<Object> out)
    throws Exception
  {
    switch ((State)state())
    {
    case CHECK_PROTOCOL_VERSION: 
      version = SocksProtocolVersion.valueOf(byteBuf.readByte());
      if (version == SocksProtocolVersion.SOCKS5) {
        checkpoint(State.READ_PREFFERED_AUTH_TYPE);
      }
      break;
    case READ_PREFFERED_AUTH_TYPE: 
      authScheme = SocksAuthScheme.valueOf(byteBuf.readByte());
      msg = new SocksInitResponse(authScheme);
    }
    ctx.pipeline().remove(this);
    out.add(msg);
  }
  
  static enum State
  {
    CHECK_PROTOCOL_VERSION,  READ_PREFFERED_AUTH_TYPE;
    
    private State() {}
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.socks.SocksInitResponseDecoder
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */