package io.netty.handler.codec.socksx.v5;

import io.netty.handler.codec.DecoderResult;
import io.netty.util.internal.StringUtil;

public class DefaultSocks5PasswordAuthResponse
  extends AbstractSocks5Message
  implements Socks5PasswordAuthResponse
{
  private final Socks5PasswordAuthStatus status;
  
  public DefaultSocks5PasswordAuthResponse(Socks5PasswordAuthStatus status)
  {
    if (status == null) {
      throw new NullPointerException("status");
    }
    this.status = status;
  }
  
  public Socks5PasswordAuthStatus status()
  {
    return status;
  }
  
  public String toString()
  {
    StringBuilder buf = new StringBuilder(StringUtil.simpleClassName(this));
    
    DecoderResult decoderResult = decoderResult();
    if (!decoderResult.isSuccess())
    {
      buf.append("(decoderResult: ");
      buf.append(decoderResult);
      buf.append(", status: ");
    }
    else
    {
      buf.append("(status: ");
    }
    buf.append(status());
    buf.append(')');
    
    return buf.toString();
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.socksx.v5.DefaultSocks5PasswordAuthResponse
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */