package io.netty.handler.codec.socksx.v5;

public class Socks5CommandType
  implements Comparable<Socks5CommandType>
{
  public static final Socks5CommandType CONNECT = new Socks5CommandType(1, "CONNECT");
  public static final Socks5CommandType BIND = new Socks5CommandType(2, "BIND");
  public static final Socks5CommandType UDP_ASSOCIATE = new Socks5CommandType(3, "UDP_ASSOCIATE");
  private final byte byteValue;
  private final String name;
  private String text;
  
  public static Socks5CommandType valueOf(byte b)
  {
    switch (b)
    {
    case 1: 
      return CONNECT;
    case 2: 
      return BIND;
    case 3: 
      return UDP_ASSOCIATE;
    }
    return new Socks5CommandType(b);
  }
  
  public Socks5CommandType(int byteValue)
  {
    this(byteValue, "UNKNOWN");
  }
  
  public Socks5CommandType(int byteValue, String name)
  {
    if (name == null) {
      throw new NullPointerException("name");
    }
    this.byteValue = ((byte)byteValue);
    this.name = name;
  }
  
  public byte byteValue()
  {
    return byteValue;
  }
  
  public int hashCode()
  {
    return byteValue;
  }
  
  public boolean equals(Object obj)
  {
    if (!(obj instanceof Socks5CommandType)) {
      return false;
    }
    return byteValue == byteValue;
  }
  
  public int compareTo(Socks5CommandType o)
  {
    return byteValue - byteValue;
  }
  
  public String toString()
  {
    String text = this.text;
    if (text == null) {
      this.text = (text = name + '(' + (byteValue & 0xFF) + ')');
    }
    return text;
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.socksx.v5.Socks5CommandType
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */