package io.netty.handler.codec.socksx.v5;

public class Socks5PasswordAuthStatus
  implements Comparable<Socks5PasswordAuthStatus>
{
  public static final Socks5PasswordAuthStatus SUCCESS = new Socks5PasswordAuthStatus(0, "SUCCESS");
  public static final Socks5PasswordAuthStatus FAILURE = new Socks5PasswordAuthStatus(255, "FAILURE");
  private final byte byteValue;
  private final String name;
  private String text;
  
  public static Socks5PasswordAuthStatus valueOf(byte b)
  {
    switch (b)
    {
    case 0: 
      return SUCCESS;
    case -1: 
      return FAILURE;
    }
    return new Socks5PasswordAuthStatus(b);
  }
  
  public Socks5PasswordAuthStatus(int byteValue)
  {
    this(byteValue, "UNKNOWN");
  }
  
  public Socks5PasswordAuthStatus(int byteValue, String name)
  {
    if (name == null) {
      throw new NullPointerException("name");
    }
    this.byteValue = ((byte)byteValue);
    this.name = name;
  }
  
  public byte byteValue()
  {
    return byteValue;
  }
  
  public boolean isSuccess()
  {
    return byteValue == 0;
  }
  
  public int hashCode()
  {
    return byteValue;
  }
  
  public boolean equals(Object obj)
  {
    if (!(obj instanceof Socks5PasswordAuthStatus)) {
      return false;
    }
    return byteValue == byteValue;
  }
  
  public int compareTo(Socks5PasswordAuthStatus o)
  {
    return byteValue - byteValue;
  }
  
  public String toString()
  {
    String text = this.text;
    if (text == null) {
      this.text = (text = name + '(' + (byteValue & 0xFF) + ')');
    }
    return text;
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.socksx.v5.Socks5PasswordAuthStatus
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */