package io.netty.handler.codec.spdy;

import io.netty.util.internal.StringUtil;

public class DefaultSpdyRstStreamFrame
  extends DefaultSpdyStreamFrame
  implements SpdyRstStreamFrame
{
  private SpdyStreamStatus status;
  
  public DefaultSpdyRstStreamFrame(int streamId, int statusCode)
  {
    this(streamId, SpdyStreamStatus.valueOf(statusCode));
  }
  
  public DefaultSpdyRstStreamFrame(int streamId, SpdyStreamStatus status)
  {
    super(streamId);
    setStatus(status);
  }
  
  public SpdyRstStreamFrame setStreamId(int streamId)
  {
    super.setStreamId(streamId);
    return this;
  }
  
  public SpdyRstStreamFrame setLast(boolean last)
  {
    super.setLast(last);
    return this;
  }
  
  public SpdyStreamStatus status()
  {
    return status;
  }
  
  public SpdyRstStreamFrame setStatus(SpdyStreamStatus status)
  {
    this.status = status;
    return this;
  }
  
  public String toString()
  {
    return StringUtil.simpleClassName(this) + StringUtil.NEWLINE + "--> Stream-ID = " + streamId() + StringUtil.NEWLINE + "--> Status: " + status();
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.spdy.DefaultSpdyRstStreamFrame
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */