package io.netty.handler.codec.stomp;

import io.netty.handler.codec.CharSequenceValueConverter;
import io.netty.handler.codec.DefaultHeaders;
import io.netty.handler.codec.HeadersUtils;
import io.netty.util.AsciiString;
import java.util.Iterator;
import java.util.List;
import java.util.Map.Entry;

public class DefaultStompHeaders
  extends DefaultHeaders<CharSequence, CharSequence, StompHeaders>
  implements StompHeaders
{
  public DefaultStompHeaders()
  {
    super(AsciiString.CASE_SENSITIVE_HASHER, CharSequenceValueConverter.INSTANCE);
  }
  
  public String getAsString(CharSequence name)
  {
    return HeadersUtils.getAsString(this, name);
  }
  
  public List<String> getAllAsString(CharSequence name)
  {
    return HeadersUtils.getAllAsString(this, name);
  }
  
  public Iterator<Map.Entry<String, String>> iteratorAsString()
  {
    return HeadersUtils.iteratorAsString(this);
  }
  
  public boolean contains(CharSequence name, CharSequence value)
  {
    return contains(name, value, false);
  }
  
  public boolean contains(CharSequence name, CharSequence value, boolean ignoreCase)
  {
    return contains(name, value, ignoreCase ? AsciiString.CASE_INSENSITIVE_HASHER : AsciiString.CASE_SENSITIVE_HASHER);
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.codec.stomp.DefaultStompHeaders
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */