package io.netty.handler.ipfilter;

import io.netty.channel.ChannelHandler.Sharable;
import io.netty.channel.ChannelHandlerContext;
import java.net.InetSocketAddress;

@ChannelHandler.Sharable
public class RuleBasedIpFilter
  extends AbstractRemoteAddressFilter<InetSocketAddress>
{
  private final IpFilterRule[] rules;
  
  public RuleBasedIpFilter(IpFilterRule... rules)
  {
    if (rules == null) {
      throw new NullPointerException("rules");
    }
    this.rules = rules;
  }
  
  protected boolean accept(ChannelHandlerContext ctx, InetSocketAddress remoteAddress)
    throws Exception
  {
    for (IpFilterRule rule : rules)
    {
      if (rule == null) {
        break;
      }
      if (rule.matches(remoteAddress)) {
        return rule.ruleType() == IpFilterRuleType.ACCEPT;
      }
    }
    return true;
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.ipfilter.RuleBasedIpFilter
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */