package io.netty.handler.ssl;

import java.util.List;
import java.util.Set;

public class JdkBaseApplicationProtocolNegotiator$NoFailProtocolSelector
  implements JdkApplicationProtocolNegotiator.ProtocolSelector
{
  private final JdkSslEngine jettyWrapper;
  private final Set<String> supportedProtocols;
  
  public JdkBaseApplicationProtocolNegotiator$NoFailProtocolSelector(JdkSslEngine jettyWrapper, Set<String> supportedProtocols)
  {
    this.jettyWrapper = jettyWrapper;
    this.supportedProtocols = supportedProtocols;
  }
  
  public void unsupported()
  {
    jettyWrapper.getSession().setApplicationProtocol(null);
  }
  
  public String select(List<String> protocols)
    throws Exception
  {
    for (String p : supportedProtocols) {
      if (protocols.contains(p))
      {
        jettyWrapper.getSession().setApplicationProtocol(p);
        return p;
      }
    }
    return noSelectMatchFound();
  }
  
  public String noSelectMatchFound()
    throws Exception
  {
    jettyWrapper.getSession().setApplicationProtocol(null);
    return null;
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.ssl.JdkBaseApplicationProtocolNegotiator.NoFailProtocolSelector
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */