package io.netty.handler.ssl;

import org.apache.tomcat.jni.SSLContext;

public final class OpenSslSessionStats
{
  private final ReferenceCountedOpenSslContext context;
  
  OpenSslSessionStats(ReferenceCountedOpenSslContext context)
  {
    this.context = context;
  }
  
  public long number()
  {
    return SSLContext.sessionNumber(context.ctx);
  }
  
  public long connect()
  {
    return SSLContext.sessionConnect(context.ctx);
  }
  
  public long connectGood()
  {
    return SSLContext.sessionConnectGood(context.ctx);
  }
  
  public long connectRenegotiate()
  {
    return SSLContext.sessionConnectRenegotiate(context.ctx);
  }
  
  public long accept()
  {
    return SSLContext.sessionAccept(context.ctx);
  }
  
  public long acceptGood()
  {
    return SSLContext.sessionAcceptGood(context.ctx);
  }
  
  public long acceptRenegotiate()
  {
    return SSLContext.sessionAcceptRenegotiate(context.ctx);
  }
  
  public long hits()
  {
    return SSLContext.sessionHits(context.ctx);
  }
  
  public long cbHits()
  {
    return SSLContext.sessionCbHits(context.ctx);
  }
  
  public long misses()
  {
    return SSLContext.sessionMisses(context.ctx);
  }
  
  public long timeouts()
  {
    return SSLContext.sessionTimeouts(context.ctx);
  }
  
  public long cacheFull()
  {
    return SSLContext.sessionCacheFull(context.ctx);
  }
  
  public long ticketKeyFail()
  {
    return SSLContext.sessionTicketKeyFail(context.ctx);
  }
  
  public long ticketKeyNew()
  {
    return SSLContext.sessionTicketKeyNew(context.ctx);
  }
  
  public long ticketKeyRenew()
  {
    return SSLContext.sessionTicketKeyRenew(context.ctx);
  }
  
  public long ticketKeyResume()
  {
    return SSLContext.sessionTicketKeyResume(context.ctx);
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.ssl.OpenSslSessionStats
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */