package io.netty.handler.ssl;

import io.netty.util.internal.PlatformDependent;
import io.netty.util.internal.logging.InternalLogger;
import java.security.cert.CertificateExpiredException;
import java.security.cert.CertificateNotYetValidException;
import java.security.cert.CertificateRevokedException;
import java.security.cert.X509Certificate;
import javax.net.ssl.SSLHandshakeException;
import org.apache.tomcat.jni.CertificateVerifier;

abstract class ReferenceCountedOpenSslContext$AbstractCertificateVerifier
  implements CertificateVerifier
{
  private final OpenSslEngineMap engineMap;
  
  ReferenceCountedOpenSslContext$AbstractCertificateVerifier(OpenSslEngineMap engineMap)
  {
    this.engineMap = engineMap;
  }
  
  public final int verify(long ssl, byte[][] chain, String auth)
  {
    X509Certificate[] peerCerts = ReferenceCountedOpenSslContext.certificates(chain);
    ReferenceCountedOpenSslEngine engine = engineMap.get(ssl);
    try
    {
      verify(engine, peerCerts, auth);
      return 0;
    }
    catch (Throwable cause)
    {
      ReferenceCountedOpenSslContext.access$200().debug("verification of certificate failed", cause);
      SSLHandshakeException e = new SSLHandshakeException("General OpenSslEngine problem");
      e.initCause(cause);
      handshakeException = e;
      if ((cause instanceof OpenSslCertificateException)) {
        return ((OpenSslCertificateException)cause).errorCode();
      }
      if ((cause instanceof CertificateExpiredException)) {
        return 10;
      }
      if ((cause instanceof CertificateNotYetValidException)) {
        return 9;
      }
      if ((PlatformDependent.javaVersion() >= 7) && ((cause instanceof CertificateRevokedException))) {
        return 23;
      }
    }
    return 1;
  }
  
  abstract void verify(ReferenceCountedOpenSslEngine paramReferenceCountedOpenSslEngine, X509Certificate[] paramArrayOfX509Certificate, String paramString)
    throws Exception;
}

/* Location:
 * Qualified Name:     io.netty.handler.ssl.ReferenceCountedOpenSslContext.AbstractCertificateVerifier
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */