package io.netty.handler.ssl;

import io.netty.util.AsyncMapping;
import io.netty.util.Mapping;
import io.netty.util.concurrent.Future;
import io.netty.util.concurrent.Promise;
import io.netty.util.internal.ObjectUtil;

final class SniHandler$AsyncMappingAdapter
  implements AsyncMapping<String, SslContext>
{
  private final Mapping<? super String, ? extends SslContext> mapping;
  
  private SniHandler$AsyncMappingAdapter(Mapping<? super String, ? extends SslContext> mapping)
  {
    this.mapping = ((Mapping)ObjectUtil.checkNotNull(mapping, "mapping"));
  }
  
  public Future<SslContext> map(String input, Promise<SslContext> promise)
  {
    try
    {
      context = (SslContext)mapping.map(input);
    }
    catch (Throwable cause)
    {
      SslContext context;
      return promise.setFailure(cause);
    }
    SslContext context;
    return promise.setSuccess(context);
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.ssl.SniHandler.AsyncMappingAdapter
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */