package io.netty.handler.ssl.util;

import io.netty.util.concurrent.FastThreadLocal;
import io.netty.util.internal.EmptyArrays;
import java.security.MessageDigest;
import java.security.cert.CertificateEncodingException;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;
import java.util.Arrays;
import javax.net.ssl.X509TrustManager;

class FingerprintTrustManagerFactory$2
  implements X509TrustManager
{
  FingerprintTrustManagerFactory$2(FingerprintTrustManagerFactory paramFingerprintTrustManagerFactory) {}
  
  public void checkClientTrusted(X509Certificate[] chain, String s)
    throws CertificateException
  {
    checkTrusted("client", chain);
  }
  
  public void checkServerTrusted(X509Certificate[] chain, String s)
    throws CertificateException
  {
    checkTrusted("server", chain);
  }
  
  private void checkTrusted(String type, X509Certificate[] chain)
    throws CertificateException
  {
    X509Certificate cert = chain[0];
    byte[] fingerprint = fingerprint(cert);
    boolean found = false;
    for (byte[] allowedFingerprint : FingerprintTrustManagerFactory.access$000(this$0)) {
      if (Arrays.equals(fingerprint, allowedFingerprint))
      {
        found = true;
        break;
      }
    }
    if (!found) {
      throw new CertificateException(type + " certificate with unknown fingerprint: " + cert.getSubjectDN());
    }
  }
  
  private byte[] fingerprint(X509Certificate cert)
    throws CertificateEncodingException
  {
    MessageDigest md = (MessageDigest)FingerprintTrustManagerFactory.access$100().get();
    md.reset();
    return md.digest(cert.getEncoded());
  }
  
  public X509Certificate[] getAcceptedIssuers()
  {
    return EmptyArrays.EMPTY_X509_CERTIFICATES;
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.ssl.util.FingerprintTrustManagerFactory.2
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */