package io.netty.handler.stream;

import io.netty.channel.ChannelProgressivePromise;
import io.netty.channel.ChannelPromise;
import io.netty.util.ReferenceCountUtil;

final class ChunkedWriteHandler$PendingWrite
{
  final Object msg;
  final ChannelPromise promise;
  
  ChunkedWriteHandler$PendingWrite(Object msg, ChannelPromise promise)
  {
    this.msg = msg;
    this.promise = promise;
  }
  
  void fail(Throwable cause)
  {
    ReferenceCountUtil.release(msg);
    promise.tryFailure(cause);
  }
  
  void success(long total)
  {
    if (promise.isDone()) {
      return;
    }
    if ((promise instanceof ChannelProgressivePromise)) {
      ((ChannelProgressivePromise)promise).tryProgress(total, total);
    }
    promise.trySuccess();
  }
  
  void progress(long progress, long total)
  {
    if ((promise instanceof ChannelProgressivePromise)) {
      ((ChannelProgressivePromise)promise).tryProgress(progress, total);
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.stream.ChunkedWriteHandler.PendingWrite
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */