package io.netty.handler.timeout;

import io.netty.util.internal.ObjectUtil;

public class IdleStateEvent
{
  public static final IdleStateEvent FIRST_READER_IDLE_STATE_EVENT = new IdleStateEvent(IdleState.READER_IDLE, true);
  public static final IdleStateEvent READER_IDLE_STATE_EVENT = new IdleStateEvent(IdleState.READER_IDLE, false);
  public static final IdleStateEvent FIRST_WRITER_IDLE_STATE_EVENT = new IdleStateEvent(IdleState.WRITER_IDLE, true);
  public static final IdleStateEvent WRITER_IDLE_STATE_EVENT = new IdleStateEvent(IdleState.WRITER_IDLE, false);
  public static final IdleStateEvent FIRST_ALL_IDLE_STATE_EVENT = new IdleStateEvent(IdleState.ALL_IDLE, true);
  public static final IdleStateEvent ALL_IDLE_STATE_EVENT = new IdleStateEvent(IdleState.ALL_IDLE, false);
  private final IdleState state;
  private final boolean first;
  
  protected IdleStateEvent(IdleState state, boolean first)
  {
    this.state = ((IdleState)ObjectUtil.checkNotNull(state, "state"));
    this.first = first;
  }
  
  public IdleState state()
  {
    return state;
  }
  
  public boolean isFirst()
  {
    return first;
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.timeout.IdleStateEvent
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */