package io.netty.handler.timeout;

import io.netty.channel.Channel;
import io.netty.channel.ChannelHandlerContext;
import io.netty.util.concurrent.EventExecutor;
import java.util.concurrent.TimeUnit;

final class IdleStateHandler$AllIdleTimeoutTask
  implements Runnable
{
  private final ChannelHandlerContext ctx;
  
  IdleStateHandler$AllIdleTimeoutTask(IdleStateHandler paramIdleStateHandler, ChannelHandlerContext ctx)
  {
    this.ctx = ctx;
  }
  
  public void run()
  {
    if (!ctx.channel().isOpen()) {
      return;
    }
    long nextDelay = IdleStateHandler.access$600(this$0);
    if (!IdleStateHandler.access$300(this$0)) {
      nextDelay -= System.nanoTime() - Math.max(this$0.lastReadTime, this$0.lastWriteTime);
    }
    if (nextDelay <= 0L)
    {
      this$0.allIdleTimeout = ctx.executor().schedule(this, IdleStateHandler.access$600(this$0), TimeUnit.NANOSECONDS);
      try
      {
        IdleStateEvent event = this$0.newIdleStateEvent(IdleState.ALL_IDLE, IdleStateHandler.access$100(this$0));
        if (IdleStateHandler.access$100(this$0)) {
          IdleStateHandler.access$102(this$0, false);
        }
        this$0.channelIdle(ctx, event);
      }
      catch (Throwable t)
      {
        ctx.fireExceptionCaught(t);
      }
    }
    else
    {
      this$0.allIdleTimeout = ctx.executor().schedule(this, nextDelay, TimeUnit.NANOSECONDS);
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.timeout.IdleStateHandler.AllIdleTimeoutTask
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */