package io.netty.handler.timeout;

import io.netty.channel.Channel;
import io.netty.channel.ChannelHandlerContext;
import io.netty.util.concurrent.EventExecutor;
import java.util.concurrent.TimeUnit;

final class IdleStateHandler$ReaderIdleTimeoutTask
  implements Runnable
{
  private final ChannelHandlerContext ctx;
  
  IdleStateHandler$ReaderIdleTimeoutTask(IdleStateHandler paramIdleStateHandler, ChannelHandlerContext ctx)
  {
    this.ctx = ctx;
  }
  
  public void run()
  {
    if (!ctx.channel().isOpen()) {
      return;
    }
    long nextDelay = IdleStateHandler.access$200(this$0);
    if (!IdleStateHandler.access$300(this$0)) {
      nextDelay -= System.nanoTime() - this$0.lastReadTime;
    }
    if (nextDelay <= 0L)
    {
      this$0.readerIdleTimeout = ctx.executor().schedule(this, IdleStateHandler.access$200(this$0), TimeUnit.NANOSECONDS);
      try
      {
        IdleStateEvent event = this$0.newIdleStateEvent(IdleState.READER_IDLE, IdleStateHandler.access$400(this$0));
        if (IdleStateHandler.access$400(this$0)) {
          IdleStateHandler.access$402(this$0, false);
        }
        this$0.channelIdle(ctx, event);
      }
      catch (Throwable t)
      {
        ctx.fireExceptionCaught(t);
      }
    }
    else
    {
      this$0.readerIdleTimeout = ctx.executor().schedule(this, nextDelay, TimeUnit.NANOSECONDS);
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.timeout.IdleStateHandler.ReaderIdleTimeoutTask
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */