package io.netty.handler.timeout;

import io.netty.channel.Channel;
import io.netty.channel.ChannelHandlerContext;
import io.netty.util.concurrent.EventExecutor;
import java.util.concurrent.TimeUnit;

final class IdleStateHandler$WriterIdleTimeoutTask
  implements Runnable
{
  private final ChannelHandlerContext ctx;
  
  IdleStateHandler$WriterIdleTimeoutTask(IdleStateHandler paramIdleStateHandler, ChannelHandlerContext ctx)
  {
    this.ctx = ctx;
  }
  
  public void run()
  {
    if (!ctx.channel().isOpen()) {
      return;
    }
    long lastWriteTime = this$0.lastWriteTime;
    long nextDelay = IdleStateHandler.access$500(this$0) - (System.nanoTime() - lastWriteTime);
    if (nextDelay <= 0L)
    {
      this$0.writerIdleTimeout = ctx.executor().schedule(this, IdleStateHandler.access$500(this$0), TimeUnit.NANOSECONDS);
      try
      {
        IdleStateEvent event = this$0.newIdleStateEvent(IdleState.WRITER_IDLE, IdleStateHandler.access$000(this$0));
        if (IdleStateHandler.access$000(this$0)) {
          IdleStateHandler.access$002(this$0, false);
        }
        this$0.channelIdle(ctx, event);
      }
      catch (Throwable t)
      {
        ctx.fireExceptionCaught(t);
      }
    }
    else
    {
      this$0.writerIdleTimeout = ctx.executor().schedule(this, nextDelay, TimeUnit.NANOSECONDS);
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.timeout.IdleStateHandler.WriterIdleTimeoutTask
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */