package io.netty.handler.traffic;

import java.util.concurrent.ConcurrentMap;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicLong;

class GlobalChannelTrafficCounter$MixedTrafficMonitoringTask
  implements Runnable
{
  private final GlobalChannelTrafficShapingHandler trafficShapingHandler1;
  private final TrafficCounter counter;
  
  GlobalChannelTrafficCounter$MixedTrafficMonitoringTask(GlobalChannelTrafficShapingHandler trafficShapingHandler, TrafficCounter counter)
  {
    trafficShapingHandler1 = trafficShapingHandler;
    this.counter = counter;
  }
  
  public void run()
  {
    if (!counter.monitorActive) {
      return;
    }
    long newLastTime = TrafficCounter.milliSecondFromNano();
    counter.resetAccounting(newLastTime);
    for (GlobalChannelTrafficShapingHandler.PerChannel perChannel : trafficShapingHandler1.channelQueues.values()) {
      channelTrafficCounter.resetAccounting(newLastTime);
    }
    trafficShapingHandler1.doAccounting(counter);
    counter.scheduledFuture = counter.executor.schedule(this, counter.checkInterval.get(), TimeUnit.MILLISECONDS);
  }
}

/* Location:
 * Qualified Name:     io.netty.handler.traffic.GlobalChannelTrafficCounter.MixedTrafficMonitoringTask
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */