package io.netty.resolver.dns;

import io.netty.channel.Channel;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelInboundHandlerAdapter;
import io.netty.handler.codec.dns.DatagramDnsResponse;
import io.netty.util.ReferenceCountUtil;
import io.netty.util.concurrent.Promise;
import io.netty.util.internal.logging.InternalLogger;

final class DnsNameResolver$DnsResponseHandler
  extends ChannelInboundHandlerAdapter
{
  private final Promise<Channel> channelActivePromise;
  
  DnsNameResolver$DnsResponseHandler(Promise<Channel> arg1)
  {
    this.channelActivePromise = channelActivePromise;
  }
  
  public void channelRead(ChannelHandlerContext ctx, Object msg)
    throws Exception
  {
    try
    {
      DatagramDnsResponse res = (DatagramDnsResponse)msg;
      int queryId = res.id();
      if (DnsNameResolver.access$400().isDebugEnabled()) {
        DnsNameResolver.access$400().debug("{} RECEIVED: [{}: {}], {}", new Object[] { this$0.ch, Integer.valueOf(queryId), res.sender(), res });
      }
      DnsQueryContext qCtx = this$0.queryContextManager.get(res.sender(), queryId);
      if (qCtx == null) {
        DnsNameResolver.access$400().warn("{} Received a DNS response with an unknown ID: {}", this$0.ch, Integer.valueOf(queryId));
      } else {
        qCtx.finish(res);
      }
    }
    finally
    {
      ReferenceCountUtil.safeRelease(msg);
    }
  }
  
  public void channelActive(ChannelHandlerContext ctx)
    throws Exception
  {
    super.channelActive(ctx);
    channelActivePromise.setSuccess(ctx.channel());
  }
  
  public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause)
    throws Exception
  {
    DnsNameResolver.access$400().warn("{} Unexpected exception: ", this$0.ch, cause);
  }
}

/* Location:
 * Qualified Name:     io.netty.resolver.dns.DnsNameResolver.DnsResponseHandler
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */