package io.netty.resolver.dns;

import io.netty.util.concurrent.Promise;
import java.net.InetAddress;
import java.util.ArrayList;
import java.util.List;

final class DnsNameResolver$ListResolverContext
  extends DnsNameResolverContext<List<InetAddress>>
{
  DnsNameResolver$ListResolverContext(DnsNameResolver paramDnsNameResolver1, DnsNameResolver parent, String hostname, DnsCache resolveCache)
  {
    super(parent, hostname, resolveCache);
  }
  
  DnsNameResolverContext<List<InetAddress>> newResolverContext(DnsNameResolver parent, String hostname, DnsCache resolveCache)
  {
    return new ListResolverContext(this$0, parent, hostname, resolveCache);
  }
  
  boolean finishResolve(Class<? extends InetAddress> addressType, List<DnsCacheEntry> resolvedEntries, Promise<List<InetAddress>> promise)
  {
    List<InetAddress> result = null;
    int numEntries = resolvedEntries.size();
    for (int i = 0; i < numEntries; i++)
    {
      InetAddress a = ((DnsCacheEntry)resolvedEntries.get(i)).address();
      if (addressType.isInstance(a))
      {
        if (result == null) {
          result = new ArrayList(numEntries);
        }
        result.add(a);
      }
    }
    if (result != null)
    {
      promise.trySuccess(result);
      return true;
    }
    return false;
  }
}

/* Location:
 * Qualified Name:     io.netty.resolver.dns.DnsNameResolver.ListResolverContext
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */