package io.netty.resolver.dns;

import java.net.InetSocketAddress;

final class SingletonDnsServerAddresses
  extends DnsServerAddresses
{
  private final InetSocketAddress address;
  private final String strVal;
  private final DnsServerAddressStream stream = new DnsServerAddressStream()
  {
    public InetSocketAddress next()
    {
      return address;
    }
    
    public String toString()
    {
      return SingletonDnsServerAddresses.this.toString();
    }
  };
  
  SingletonDnsServerAddresses(InetSocketAddress address)
  {
    this.address = address;
    strVal = (32 + "singleton(" + address + ')');
  }
  
  public DnsServerAddressStream stream()
  {
    return stream;
  }
  
  public String toString()
  {
    return strVal;
  }
}

/* Location:
 * Qualified Name:     io.netty.resolver.dns.SingletonDnsServerAddresses
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */