package io.netty.util;

import java.util.concurrent.atomic.AtomicReference;

final class DefaultAttributeMap$DefaultAttribute<T>
  extends AtomicReference<T>
  implements Attribute<T>
{
  private static final long serialVersionUID = -2661411462200283011L;
  private final DefaultAttribute<?> head;
  private final AttributeKey<T> key;
  private DefaultAttribute<?> prev;
  private DefaultAttribute<?> next;
  private volatile boolean removed;
  
  DefaultAttributeMap$DefaultAttribute(DefaultAttribute<?> head, AttributeKey<T> key)
  {
    this.head = head;
    this.key = key;
  }
  
  DefaultAttributeMap$DefaultAttribute()
  {
    head = this;
    key = null;
  }
  
  public AttributeKey<T> key()
  {
    return key;
  }
  
  public T setIfAbsent(T value)
  {
    while (!compareAndSet(null, value))
    {
      T old = get();
      if (old != null) {
        return old;
      }
    }
    return null;
  }
  
  public T getAndRemove()
  {
    removed = true;
    T oldValue = getAndSet(null);
    remove0();
    return oldValue;
  }
  
  public void remove()
  {
    removed = true;
    set(null);
    remove0();
  }
  
  private void remove0()
  {
    synchronized (head)
    {
      assert (head != null);
      if (prev == null) {
        return;
      }
      prev.next = next;
      if (next != null) {
        next.prev = prev;
      }
      prev = null;
      next = null;
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.util.DefaultAttributeMap.DefaultAttribute
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */