package io.netty.util;

import java.util.Set;

final class HashedWheelTimer$HashedWheelBucket
{
  private HashedWheelTimer.HashedWheelTimeout head;
  private HashedWheelTimer.HashedWheelTimeout tail;
  
  public void addTimeout(HashedWheelTimer.HashedWheelTimeout timeout)
  {
    assert (bucket == null);
    bucket = this;
    if (head == null)
    {
      head = (tail = timeout);
    }
    else
    {
      tail.next = timeout;
      prev = tail;
      tail = timeout;
    }
  }
  
  public void expireTimeouts(long deadline)
  {
    HashedWheelTimer.HashedWheelTimeout timeout = head;
    while (timeout != null)
    {
      boolean remove = false;
      if (remainingRounds <= 0L)
      {
        if (HashedWheelTimer.HashedWheelTimeout.access$800(timeout) <= deadline) {
          timeout.expire();
        } else {
          throw new IllegalStateException(String.format("timeout.deadline (%d) > deadline (%d)", new Object[] { Long.valueOf(HashedWheelTimer.HashedWheelTimeout.access$800(timeout)), Long.valueOf(deadline) }));
        }
        remove = true;
      }
      else if (timeout.isCancelled())
      {
        remove = true;
      }
      else
      {
        remainingRounds -= 1L;
      }
      HashedWheelTimer.HashedWheelTimeout next = next;
      if (remove) {
        remove(timeout);
      }
      timeout = next;
    }
  }
  
  public void remove(HashedWheelTimer.HashedWheelTimeout timeout)
  {
    HashedWheelTimer.HashedWheelTimeout next = next;
    if (prev != null) {
      prev.next = next;
    }
    if (next != null) {
      next.prev = prev;
    }
    if (timeout == head)
    {
      if (timeout == tail)
      {
        tail = null;
        head = null;
      }
      else
      {
        head = next;
      }
    }
    else if (timeout == tail) {
      tail = prev;
    }
    prev = null;
    next = null;
    bucket = null;
  }
  
  public void clearTimeouts(Set<Timeout> set)
  {
    for (;;)
    {
      HashedWheelTimer.HashedWheelTimeout timeout = pollTimeout();
      if (timeout == null) {
        return;
      }
      if ((!timeout.isExpired()) && (!timeout.isCancelled())) {
        set.add(timeout);
      }
    }
  }
  
  private HashedWheelTimer.HashedWheelTimeout pollTimeout()
  {
    HashedWheelTimer.HashedWheelTimeout head = this.head;
    if (head == null) {
      return null;
    }
    HashedWheelTimer.HashedWheelTimeout next = next;
    if (next == null)
    {
      tail = (this.head = null);
    }
    else
    {
      this.head = next;
      prev = null;
    }
    next = null;
    prev = null;
    bucket = null;
    return head;
  }
}

/* Location:
 * Qualified Name:     io.netty.util.HashedWheelTimer.HashedWheelBucket
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */