package io.netty.util.concurrent;

import io.netty.util.internal.PlatformDependent;

public final class FailedFuture<V>
  extends CompleteFuture<V>
{
  private final Throwable cause;
  
  public FailedFuture(EventExecutor executor, Throwable cause)
  {
    super(executor);
    if (cause == null) {
      throw new NullPointerException("cause");
    }
    this.cause = cause;
  }
  
  public Throwable cause()
  {
    return cause;
  }
  
  public boolean isSuccess()
  {
    return false;
  }
  
  public Future<V> sync()
  {
    PlatformDependent.throwException(cause);
    return this;
  }
  
  public Future<V> syncUninterruptibly()
  {
    PlatformDependent.throwException(cause);
    return this;
  }
  
  public V getNow()
  {
    return null;
  }
}

/* Location:
 * Qualified Name:     io.netty.util.concurrent.FailedFuture
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */