package io.netty.util.concurrent;

import io.netty.util.internal.logging.InternalLogger;
import java.util.concurrent.Callable;
import java.util.concurrent.Delayed;
import java.util.concurrent.RunnableScheduledFuture;
import java.util.concurrent.TimeUnit;

final class UnorderedThreadPoolEventExecutor$RunnableScheduledFutureTask<V>
  extends PromiseTask<V>
  implements RunnableScheduledFuture<V>, ScheduledFuture<V>
{
  private final RunnableScheduledFuture<V> future;
  
  UnorderedThreadPoolEventExecutor$RunnableScheduledFutureTask(EventExecutor executor, Runnable runnable, RunnableScheduledFuture<V> future)
  {
    super(executor, runnable, null);
    this.future = future;
  }
  
  UnorderedThreadPoolEventExecutor$RunnableScheduledFutureTask(EventExecutor executor, Callable<V> callable, RunnableScheduledFuture<V> future)
  {
    super(executor, callable);
    this.future = future;
  }
  
  public void run()
  {
    if (!isPeriodic()) {
      super.run();
    } else if (!isDone()) {
      try
      {
        task.call();
      }
      catch (Throwable cause)
      {
        if (!tryFailureInternal(cause)) {
          UnorderedThreadPoolEventExecutor.access$000().warn("Failure during execution of task", cause);
        }
      }
    }
  }
  
  public boolean isPeriodic()
  {
    return future.isPeriodic();
  }
  
  public long getDelay(TimeUnit unit)
  {
    return future.getDelay(unit);
  }
  
  public int compareTo(Delayed o)
  {
    return future.compareTo(o);
  }
}

/* Location:
 * Qualified Name:     io.netty.util.concurrent.UnorderedThreadPoolEventExecutor.RunnableScheduledFutureTask
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */