package io.netty.util.internal;

public final class MathUtil
{
  public static int findNextPositivePowerOfTwo(int value)
  {
    assert ((value > Integer.MIN_VALUE) && (value < 1073741824));
    return 1 << 32 - Integer.numberOfLeadingZeros(value - 1);
  }
  
  public static int safeFindNextPositivePowerOfTwo(int value)
  {
    return value >= 1073741824 ? 1073741824 : value <= 0 ? 1 : findNextPositivePowerOfTwo(value);
  }
  
  public static boolean isOutOfBounds(int index, int length, int capacity)
  {
    return (index | length | index + length | capacity - (index + length)) < 0;
  }
  
  public static int compare(long x, long y)
  {
    return x > y ? 1 : x < y ? -1 : 0;
  }
}

/* Location:
 * Qualified Name:     io.netty.util.internal.MathUtil
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */