package io.netty.util.internal;

import java.util.Iterator;

public final class ReadOnlyIterator<T>
  implements Iterator<T>
{
  private final Iterator<? extends T> iterator;
  
  public ReadOnlyIterator(Iterator<? extends T> iterator)
  {
    if (iterator == null) {
      throw new NullPointerException("iterator");
    }
    this.iterator = iterator;
  }
  
  public boolean hasNext()
  {
    return iterator.hasNext();
  }
  
  public T next()
  {
    return (T)iterator.next();
  }
  
  public void remove()
  {
    throw new UnsupportedOperationException("read-only");
  }
}

/* Location:
 * Qualified Name:     io.netty.util.internal.ReadOnlyIterator
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */