package io.netty.util.internal.chmv8;

import java.io.Serializable;
import java.lang.reflect.Array;
import java.util.Arrays;
import java.util.Collection;
import java.util.Iterator;

abstract class ConcurrentHashMapV8$CollectionView<K, V, E>
  implements Collection<E>, Serializable
{
  private static final long serialVersionUID = 7249069246763182397L;
  final ConcurrentHashMapV8<K, V> map;
  private static final String oomeMsg = "Required array size too large";
  
  ConcurrentHashMapV8$CollectionView(ConcurrentHashMapV8<K, V> map)
  {
    this.map = map;
  }
  
  public ConcurrentHashMapV8<K, V> getMap()
  {
    return map;
  }
  
  public final void clear()
  {
    map.clear();
  }
  
  public final int size()
  {
    return map.size();
  }
  
  public final boolean isEmpty()
  {
    return map.isEmpty();
  }
  
  public abstract Iterator<E> iterator();
  
  public abstract boolean contains(Object paramObject);
  
  public abstract boolean remove(Object paramObject);
  
  public final Object[] toArray()
  {
    long sz = map.mappingCount();
    if (sz > 2147483639L) {
      throw new OutOfMemoryError("Required array size too large");
    }
    int n = (int)sz;
    Object[] r = new Object[n];
    int i = 0;
    for (E e : this)
    {
      if (i == n)
      {
        if (n >= 2147483639) {
          throw new OutOfMemoryError("Required array size too large");
        }
        if (n >= 1073741819) {
          n = 2147483639;
        } else {
          n += (n >>> 1) + 1;
        }
        r = Arrays.copyOf(r, n);
      }
      r[(i++)] = e;
    }
    return i == n ? r : Arrays.copyOf(r, i);
  }
  
  public final <T> T[] toArray(T[] a)
  {
    long sz = map.mappingCount();
    if (sz > 2147483639L) {
      throw new OutOfMemoryError("Required array size too large");
    }
    int m = (int)sz;
    T[] r = a.length >= m ? a : (Object[])Array.newInstance(a.getClass().getComponentType(), m);
    
    int n = r.length;
    int i = 0;
    for (E e : this)
    {
      if (i == n)
      {
        if (n >= 2147483639) {
          throw new OutOfMemoryError("Required array size too large");
        }
        if (n >= 1073741819) {
          n = 2147483639;
        } else {
          n += (n >>> 1) + 1;
        }
        r = Arrays.copyOf(r, n);
      }
      r[(i++)] = e;
    }
    if ((a == r) && (i < n))
    {
      r[i] = null;
      return r;
    }
    return i == n ? r : Arrays.copyOf(r, i);
  }
  
  public final String toString()
  {
    StringBuilder sb = new StringBuilder();
    sb.append('[');
    Iterator<E> it = iterator();
    if (it.hasNext()) {
      for (;;)
      {
        Object e = it.next();
        sb.append(e == this ? "(this Collection)" : e);
        if (!it.hasNext()) {
          break;
        }
        sb.append(',').append(' ');
      }
    }
    return ']';
  }
  
  public final boolean containsAll(Collection<?> c)
  {
    if (c != this) {
      for (Object e : c) {
        if ((e == null) || (!contains(e))) {
          return false;
        }
      }
    }
    return true;
  }
  
  public final boolean removeAll(Collection<?> c)
  {
    boolean modified = false;
    for (Iterator<E> it = iterator(); it.hasNext();) {
      if (c.contains(it.next()))
      {
        it.remove();
        modified = true;
      }
    }
    return modified;
  }
  
  public final boolean retainAll(Collection<?> c)
  {
    boolean modified = false;
    for (Iterator<E> it = iterator(); it.hasNext();) {
      if (!c.contains(it.next()))
      {
        it.remove();
        modified = true;
      }
    }
    return modified;
  }
}

/* Location:
 * Qualified Name:     io.netty.util.internal.chmv8.ConcurrentHashMapV8.CollectionView
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */