package io.netty.util.internal.chmv8;

import java.io.Serializable;
import java.util.Collection;
import java.util.Iterator;
import java.util.Map.Entry;
import java.util.Set;

final class ConcurrentHashMapV8$EntrySetView<K, V>
  extends ConcurrentHashMapV8.CollectionView<K, V, Map.Entry<K, V>>
  implements Set<Map.Entry<K, V>>, Serializable
{
  private static final long serialVersionUID = 2249069246763182397L;
  
  ConcurrentHashMapV8$EntrySetView(ConcurrentHashMapV8<K, V> map)
  {
    super(map);
  }
  
  public boolean contains(Object o)
  {
    Map.Entry<?, ?> e;
    Object k;
    Object r;
    Object v;
    return ((o instanceof Map.Entry)) && ((k = (e = (Map.Entry)o).getKey()) != null) && ((r = map.get(k)) != null) && ((v = e.getValue()) != null) && ((v == r) || (v.equals(r)));
  }
  
  public boolean remove(Object o)
  {
    Map.Entry<?, ?> e;
    Object k;
    Object v;
    return ((o instanceof Map.Entry)) && ((k = (e = (Map.Entry)o).getKey()) != null) && ((v = e.getValue()) != null) && (map.remove(k, v));
  }
  
  public Iterator<Map.Entry<K, V>> iterator()
  {
    ConcurrentHashMapV8<K, V> m = map;
    ConcurrentHashMapV8.Node<K, V>[] t;
    int f = (t = table) == null ? 0 : t.length;
    return new ConcurrentHashMapV8.EntryIterator(t, f, 0, f, m);
  }
  
  public boolean add(Map.Entry<K, V> e)
  {
    return map.putVal(e.getKey(), e.getValue(), false) == null;
  }
  
  public boolean addAll(Collection<? extends Map.Entry<K, V>> c)
  {
    boolean added = false;
    for (Map.Entry<K, V> e : c) {
      if (add(e)) {
        added = true;
      }
    }
    return added;
  }
  
  public final int hashCode()
  {
    int h = 0;
    ConcurrentHashMapV8.Node<K, V>[] t;
    if ((t = map.table) != null)
    {
      ConcurrentHashMapV8.Traverser<K, V> it = new ConcurrentHashMapV8.Traverser(t, t.length, 0, t.length);
      ConcurrentHashMapV8.Node<K, V> p;
      while ((p = it.advance()) != null) {
        h += p.hashCode();
      }
    }
    return h;
  }
  
  public final boolean equals(Object o)
  {
    Set<?> c;
    return ((o instanceof Set)) && (((c = (Set)o) == this) || ((containsAll(c)) && (c.containsAll(this))));
  }
  
  public ConcurrentHashMapV8.ConcurrentHashMapSpliterator<Map.Entry<K, V>> spliterator166()
  {
    ConcurrentHashMapV8<K, V> m = map;
    long n = m.sumCount();
    ConcurrentHashMapV8.Node<K, V>[] t;
    int f = (t = table) == null ? 0 : t.length;
    return new ConcurrentHashMapV8.EntrySpliterator(t, f, 0, f, n < 0L ? 0L : n, m);
  }
  
  public void forEach(ConcurrentHashMapV8.Action<? super Map.Entry<K, V>> action)
  {
    if (action == null) {
      throw new NullPointerException();
    }
    ConcurrentHashMapV8.Node<K, V>[] t;
    if ((t = map.table) != null)
    {
      ConcurrentHashMapV8.Traverser<K, V> it = new ConcurrentHashMapV8.Traverser(t, t.length, 0, t.length);
      ConcurrentHashMapV8.Node<K, V> p;
      while ((p = it.advance()) != null) {
        action.apply(new ConcurrentHashMapV8.MapEntry(key, val, map));
      }
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.util.internal.chmv8.ConcurrentHashMapV8.EntrySetView
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */