package io.netty.util.internal.chmv8;

import java.io.Serializable;
import java.util.Collection;
import java.util.Iterator;
import java.util.Set;

public class ConcurrentHashMapV8$KeySetView<K, V>
  extends ConcurrentHashMapV8.CollectionView<K, V, K>
  implements Set<K>, Serializable
{
  private static final long serialVersionUID = 7249069246763182397L;
  private final V value;
  
  ConcurrentHashMapV8$KeySetView(ConcurrentHashMapV8<K, V> map, V value)
  {
    super(map);
    this.value = value;
  }
  
  public V getMappedValue()
  {
    return (V)value;
  }
  
  public boolean contains(Object o)
  {
    return map.containsKey(o);
  }
  
  public boolean remove(Object o)
  {
    return map.remove(o) != null;
  }
  
  public Iterator<K> iterator()
  {
    ConcurrentHashMapV8<K, V> m = map;
    ConcurrentHashMapV8.Node<K, V>[] t;
    int f = (t = table) == null ? 0 : t.length;
    return new ConcurrentHashMapV8.KeyIterator(t, f, 0, f, m);
  }
  
  public boolean add(K e)
  {
    V v;
    if ((v = value) == null) {
      throw new UnsupportedOperationException();
    }
    return map.putVal(e, v, true) == null;
  }
  
  public boolean addAll(Collection<? extends K> c)
  {
    boolean added = false;
    V v;
    if ((v = value) == null) {
      throw new UnsupportedOperationException();
    }
    for (K e : c) {
      if (map.putVal(e, v, true) == null) {
        added = true;
      }
    }
    return added;
  }
  
  public int hashCode()
  {
    int h = 0;
    for (K e : this) {
      h += e.hashCode();
    }
    return h;
  }
  
  public boolean equals(Object o)
  {
    Set<?> c;
    return ((o instanceof Set)) && (((c = (Set)o) == this) || ((containsAll(c)) && (c.containsAll(this))));
  }
  
  public ConcurrentHashMapV8.ConcurrentHashMapSpliterator<K> spliterator166()
  {
    ConcurrentHashMapV8<K, V> m = map;
    long n = m.sumCount();
    ConcurrentHashMapV8.Node<K, V>[] t;
    int f = (t = table) == null ? 0 : t.length;
    return new ConcurrentHashMapV8.KeySpliterator(t, f, 0, f, n < 0L ? 0L : n);
  }
  
  public void forEach(ConcurrentHashMapV8.Action<? super K> action)
  {
    if (action == null) {
      throw new NullPointerException();
    }
    ConcurrentHashMapV8.Node<K, V>[] t;
    if ((t = map.table) != null)
    {
      ConcurrentHashMapV8.Traverser<K, V> it = new ConcurrentHashMapV8.Traverser(t, t.length, 0, t.length);
      ConcurrentHashMapV8.Node<K, V> p;
      while ((p = it.advance()) != null) {
        action.apply(key);
      }
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.util.internal.chmv8.ConcurrentHashMapV8.KeySetView
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */