package io.netty.util.internal.chmv8;

import java.util.Map.Entry;

final class ConcurrentHashMapV8$MapEntry<K, V>
  implements Map.Entry<K, V>
{
  final K key;
  V val;
  final ConcurrentHashMapV8<K, V> map;
  
  ConcurrentHashMapV8$MapEntry(K key, V val, ConcurrentHashMapV8<K, V> map)
  {
    this.key = key;
    this.val = val;
    this.map = map;
  }
  
  public K getKey()
  {
    return (K)key;
  }
  
  public V getValue()
  {
    return (V)val;
  }
  
  public int hashCode()
  {
    return key.hashCode() ^ val.hashCode();
  }
  
  public String toString()
  {
    return key + "=" + val;
  }
  
  public boolean equals(Object o)
  {
    Map.Entry<?, ?> e;
    Object k;
    Object v;
    return ((o instanceof Map.Entry)) && ((k = (e = (Map.Entry)o).getKey()) != null) && ((v = e.getValue()) != null) && ((k == key) || (k.equals(key))) && ((v == val) || (v.equals(val)));
  }
  
  public V setValue(V value)
  {
    if (value == null) {
      throw new NullPointerException();
    }
    V v = val;
    val = value;
    map.put(key, value);
    return v;
  }
}

/* Location:
 * Qualified Name:     io.netty.util.internal.chmv8.ConcurrentHashMapV8.MapEntry
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */