package io.netty.util.internal.chmv8;

final class ConcurrentHashMapV8$MapReduceKeysTask<K, V, U>
  extends ConcurrentHashMapV8.BulkTask<K, V, U>
{
  final ConcurrentHashMapV8.Fun<? super K, ? extends U> transformer;
  final ConcurrentHashMapV8.BiFun<? super U, ? super U, ? extends U> reducer;
  U result;
  MapReduceKeysTask<K, V, U> rights;
  MapReduceKeysTask<K, V, U> nextRight;
  
  ConcurrentHashMapV8$MapReduceKeysTask(ConcurrentHashMapV8.BulkTask<K, V, ?> p, int b, int i, int f, ConcurrentHashMapV8.Node<K, V>[] t, MapReduceKeysTask<K, V, U> nextRight, ConcurrentHashMapV8.Fun<? super K, ? extends U> transformer, ConcurrentHashMapV8.BiFun<? super U, ? super U, ? extends U> reducer)
  {
    super(p, b, i, f, t);this.nextRight = nextRight;
    this.transformer = transformer;
    this.reducer = reducer;
  }
  
  public final U getRawResult()
  {
    return (U)result;
  }
  
  public final void compute()
  {
    ConcurrentHashMapV8.Fun<? super K, ? extends U> transformer;
    ConcurrentHashMapV8.BiFun<? super U, ? super U, ? extends U> reducer;
    if (((transformer = this.transformer) != null) && ((reducer = this.reducer) != null))
    {
      int f;
      int h;
      for (int i = baseIndex; (batch > 0) && ((h = (f = baseLimit) + i >>> 1) > i);)
      {
        addToPendingCount(1);
        (rights = new MapReduceKeysTask(this, batch >>>= 1, baseLimit = h, f, tab, rights, transformer, reducer)).fork();
      }
      U r = null;
      ConcurrentHashMapV8.Node<K, V> p;
      while ((p = advance()) != null)
      {
        U u;
        if ((u = transformer.apply(key)) != null) {
          r = r == null ? u : reducer.apply(r, u);
        }
      }
      result = r;
      for (CountedCompleter<?> c = firstComplete(); c != null; c = c.nextComplete())
      {
        MapReduceKeysTask<K, V, U> t = (MapReduceKeysTask)c;
        MapReduceKeysTask<K, V, U> s = rights;
        while (s != null)
        {
          U sr;
          if ((sr = result) != null)
          {
            U tr;
            result = ((tr = result) == null ? sr : reducer.apply(tr, sr));
          }
          s = rights = nextRight;
        }
      }
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.util.internal.chmv8.ConcurrentHashMapV8.MapReduceKeysTask
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */