package io.netty.util.internal.chmv8;

import java.util.Map.Entry;

class ConcurrentHashMapV8$Node<K, V>
  implements Map.Entry<K, V>
{
  final int hash;
  final K key;
  volatile V val;
  volatile Node<K, V> next;
  
  ConcurrentHashMapV8$Node(int hash, K key, V val, Node<K, V> next)
  {
    this.hash = hash;
    this.key = key;
    this.val = val;
    this.next = next;
  }
  
  public final K getKey()
  {
    return (K)key;
  }
  
  public final V getValue()
  {
    return (V)val;
  }
  
  public final int hashCode()
  {
    return key.hashCode() ^ val.hashCode();
  }
  
  public final String toString()
  {
    return key + "=" + val;
  }
  
  public final V setValue(V value)
  {
    throw new UnsupportedOperationException();
  }
  
  public final boolean equals(Object o)
  {
    Map.Entry<?, ?> e;
    Object k;
    Object v;
    Object u;
    return ((o instanceof Map.Entry)) && ((k = (e = (Map.Entry)o).getKey()) != null) && ((v = e.getValue()) != null) && ((k == key) || (k.equals(key))) && ((v == (u = val)) || (v.equals(u)));
  }
  
  Node<K, V> find(int h, Object k)
  {
    Node<K, V> e = this;
    if (k != null) {
      do
      {
        K ek;
        if ((hash == h) && (((ek = key) == k) || ((ek != null) && (k.equals(ek))))) {
          return e;
        }
      } while ((e = next) != null);
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     io.netty.util.internal.chmv8.ConcurrentHashMapV8.Node
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */