package io.netty.util.internal.chmv8;

import java.util.Map.Entry;

final class ConcurrentHashMapV8$ReduceEntriesTask<K, V>
  extends ConcurrentHashMapV8.BulkTask<K, V, Map.Entry<K, V>>
{
  final ConcurrentHashMapV8.BiFun<Map.Entry<K, V>, Map.Entry<K, V>, ? extends Map.Entry<K, V>> reducer;
  Map.Entry<K, V> result;
  ReduceEntriesTask<K, V> rights;
  ReduceEntriesTask<K, V> nextRight;
  
  ConcurrentHashMapV8$ReduceEntriesTask(ConcurrentHashMapV8.BulkTask<K, V, ?> p, int b, int i, int f, ConcurrentHashMapV8.Node<K, V>[] t, ReduceEntriesTask<K, V> nextRight, ConcurrentHashMapV8.BiFun<Map.Entry<K, V>, Map.Entry<K, V>, ? extends Map.Entry<K, V>> reducer)
  {
    super(p, b, i, f, t);this.nextRight = nextRight;
    this.reducer = reducer;
  }
  
  public final Map.Entry<K, V> getRawResult()
  {
    return result;
  }
  
  public final void compute()
  {
    ConcurrentHashMapV8.BiFun<Map.Entry<K, V>, Map.Entry<K, V>, ? extends Map.Entry<K, V>> reducer;
    if ((reducer = this.reducer) != null)
    {
      int f;
      int h;
      for (int i = baseIndex; (batch > 0) && ((h = (f = baseLimit) + i >>> 1) > i);)
      {
        addToPendingCount(1);
        (rights = new ReduceEntriesTask(this, batch >>>= 1, baseLimit = h, f, tab, rights, reducer)).fork();
      }
      Map.Entry<K, V> r = null;
      ConcurrentHashMapV8.Node<K, V> p;
      while ((p = advance()) != null) {
        r = r == null ? p : (Map.Entry)reducer.apply(r, p);
      }
      result = r;
      for (CountedCompleter<?> c = firstComplete(); c != null; c = c.nextComplete())
      {
        ReduceEntriesTask<K, V> t = (ReduceEntriesTask)c;
        ReduceEntriesTask<K, V> s = rights;
        while (s != null)
        {
          Map.Entry<K, V> sr;
          if ((sr = result) != null)
          {
            Map.Entry<K, V> tr;
            result = ((tr = result) == null ? sr : (Map.Entry)reducer.apply(tr, sr));
          }
          s = rights = nextRight;
        }
      }
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.util.internal.chmv8.ConcurrentHashMapV8.ReduceEntriesTask
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */