package io.netty.util.internal.chmv8;

import java.util.concurrent.atomic.AtomicReference;

final class ConcurrentHashMapV8$SearchKeysTask<K, V, U>
  extends ConcurrentHashMapV8.BulkTask<K, V, U>
{
  final ConcurrentHashMapV8.Fun<? super K, ? extends U> searchFunction;
  final AtomicReference<U> result;
  
  ConcurrentHashMapV8$SearchKeysTask(ConcurrentHashMapV8.BulkTask<K, V, ?> p, int b, int i, int f, ConcurrentHashMapV8.Node<K, V>[] t, ConcurrentHashMapV8.Fun<? super K, ? extends U> searchFunction, AtomicReference<U> result)
  {
    super(p, b, i, f, t);
    this.searchFunction = searchFunction;this.result = result;
  }
  
  public final U getRawResult()
  {
    return (U)result.get();
  }
  
  public final void compute()
  {
    ConcurrentHashMapV8.Fun<? super K, ? extends U> searchFunction;
    AtomicReference<U> result;
    if (((searchFunction = this.searchFunction) != null) && ((result = this.result) != null))
    {
      int f;
      int h;
      for (int i = baseIndex; (batch > 0) && ((h = (f = baseLimit) + i >>> 1) > i);)
      {
        if (result.get() != null) {
          return;
        }
        addToPendingCount(1);
        new SearchKeysTask(this, batch >>>= 1, baseLimit = h, f, tab, searchFunction, result).fork();
      }
      while (result.get() == null)
      {
        ConcurrentHashMapV8.Node<K, V> p;
        if ((p = advance()) == null)
        {
          propagateCompletion();
          break;
        }
        U u;
        if ((u = searchFunction.apply(key)) != null)
        {
          if (!result.compareAndSet(null, u)) {
            break;
          }
          quietlyCompleteRoot(); break;
        }
      }
    }
  }
}

/* Location:
 * Qualified Name:     io.netty.util.internal.chmv8.ConcurrentHashMapV8.SearchKeysTask
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */