package io.netty.util.internal.chmv8;

final class ConcurrentHashMapV8$TreeNode<K, V>
  extends ConcurrentHashMapV8.Node<K, V>
{
  TreeNode<K, V> parent;
  TreeNode<K, V> left;
  TreeNode<K, V> right;
  TreeNode<K, V> prev;
  boolean red;
  
  ConcurrentHashMapV8$TreeNode(int hash, K key, V val, ConcurrentHashMapV8.Node<K, V> next, TreeNode<K, V> parent)
  {
    super(hash, key, val, next);
    this.parent = parent;
  }
  
  ConcurrentHashMapV8.Node<K, V> find(int h, Object k)
  {
    return findTreeNode(h, k, null);
  }
  
  final TreeNode<K, V> findTreeNode(int h, Object k, Class<?> kc)
  {
    if (k != null)
    {
      TreeNode<K, V> p = this;
      do
      {
        TreeNode<K, V> pl = left;TreeNode<K, V> pr = right;
        int ph;
        if ((ph = hash) > h)
        {
          p = pl;
        }
        else if (ph < h)
        {
          p = pr;
        }
        else
        {
          K pk;
          if (((pk = key) == k) || ((pk != null) && (k.equals(pk)))) {
            return p;
          }
          if ((pl == null) && (pr == null)) {
            break;
          }
          int dir;
          if (((kc != null) || ((kc = ConcurrentHashMapV8.comparableClassFor(k)) != null)) && ((dir = ConcurrentHashMapV8.compareComparables(kc, k, pk)) != 0))
          {
            p = dir < 0 ? pl : pr;
          }
          else if (pl == null)
          {
            p = pr;
          }
          else
          {
            TreeNode<K, V> q;
            if ((pr == null) || ((q = pr.findTreeNode(h, k, kc)) == null))
            {
              p = pl;
            }
            else
            {
              TreeNode<K, V> q;
              return q;
            }
          }
        }
      } while (p != null);
    }
    return null;
  }
}

/* Location:
 * Qualified Name:     io.netty.util.internal.chmv8.ConcurrentHashMapV8.TreeNode
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */