package io.netty.util.internal.chmv8;

import java.util.concurrent.Callable;
import java.util.concurrent.RunnableFuture;

final class ForkJoinTask$AdaptedCallable<T>
  extends ForkJoinTask<T>
  implements RunnableFuture<T>
{
  final Callable<? extends T> callable;
  T result;
  private static final long serialVersionUID = 2838392045355241008L;
  
  ForkJoinTask$AdaptedCallable(Callable<? extends T> callable)
  {
    if (callable == null) {
      throw new NullPointerException();
    }
    this.callable = callable;
  }
  
  public final T getRawResult()
  {
    return (T)result;
  }
  
  public final void setRawResult(T v)
  {
    result = v;
  }
  
  public final boolean exec()
  {
    try
    {
      result = callable.call();
      return true;
    }
    catch (Error err)
    {
      throw err;
    }
    catch (RuntimeException rex)
    {
      throw rex;
    }
    catch (Exception ex)
    {
      throw new RuntimeException(ex);
    }
  }
  
  public final void run()
  {
    invoke();
  }
}

/* Location:
 * Qualified Name:     io.netty.util.internal.chmv8.ForkJoinTask.AdaptedCallable
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */