package io.netty.util.internal.logging;

import java.io.OutputStream;
import java.io.PrintStream;
import java.io.UnsupportedEncodingException;
import org.slf4j.LoggerFactory;
import org.slf4j.helpers.NOPLoggerFactory;

public class Slf4JLoggerFactory
  extends InternalLoggerFactory
{
  public static final InternalLoggerFactory INSTANCE = new Slf4JLoggerFactory();
  
  @Deprecated
  public Slf4JLoggerFactory() {}
  
  Slf4JLoggerFactory(boolean failIfNOP)
  {
    assert (failIfNOP);
    
    final StringBuffer buf = new StringBuffer();
    PrintStream err = System.err;
    try
    {
      System.setErr(new PrintStream(new OutputStream()
      {
        public void write(int b)
        {
          buf.append((char)b);
        }
      }, true, "US-ASCII"));
    }
    catch (UnsupportedEncodingException e)
    {
      throw new Error(e);
    }
    try
    {
      if ((LoggerFactory.getILoggerFactory() instanceof NOPLoggerFactory)) {
        throw new NoClassDefFoundError(buf.toString());
      }
      err.print(buf);
      err.flush();
    }
    finally
    {
      System.setErr(err);
    }
  }
  
  public InternalLogger newInstance(String name)
  {
    return new Slf4JLogger(LoggerFactory.getLogger(name));
  }
}

/* Location:
 * Qualified Name:     io.netty.util.internal.logging.Slf4JLoggerFactory
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */