package io.netty.util.internal.shaded.org.jctools.queues;

import io.netty.util.internal.shaded.org.jctools.util.JvmInfo;
import io.netty.util.internal.shaded.org.jctools.util.UnsafeRefArrayAccess;

public final class PaddedCircularArrayOffsetCalculator
{
  static final int REF_BUFFER_PAD = JvmInfo.CACHE_LINE_SIZE * 2 >> UnsafeRefArrayAccess.REF_ELEMENT_SHIFT;
  static final long REF_ARRAY_BASE;
  
  static
  {
    int paddingOffset = REF_BUFFER_PAD << UnsafeRefArrayAccess.REF_ELEMENT_SHIFT;
    REF_ARRAY_BASE = UnsafeRefArrayAccess.REF_ARRAY_BASE + paddingOffset;
  }
  
  public static <E> E[] allocate(int capacity)
  {
    return (Object[])new Object[capacity + REF_BUFFER_PAD * 2];
  }
  
  protected static long calcElementOffset(long index, long mask)
  {
    return REF_ARRAY_BASE + ((index & mask) << UnsafeRefArrayAccess.REF_ELEMENT_SHIFT);
  }
}

/* Location:
 * Qualified Name:     io.netty.util.internal.shaded.org.jctools.queues.PaddedCircularArrayOffsetCalculator
 * Java Class Version: 6 (50.0)
 * JD-Core Version:    0.7.1
 */