package org.apache.commons.io;

import java.io.File;
import java.lang.ref.PhantomReference;
import java.lang.ref.Reference;
import java.lang.ref.ReferenceQueue;
import java.util.Collection;
import java.util.Vector;

public class FileCleaner
{
  private static ReferenceQueue q = new ReferenceQueue();
  private static Collection trackers = new Vector();
  private static Thread reaper = new Thread("File Reaper")
  {
    public void run()
    {
      for (;;)
      {
        FileCleaner.Tracker tracker = null;
        try
        {
          tracker = (FileCleaner.Tracker)FileCleaner.q.remove();
        }
        catch (Exception e) {}
        continue;
        
        tracker.delete();
        tracker.clear();
        FileCleaner.trackers.remove(tracker);
      }
    }
  };
  
  static
  {
    reaper.setPriority(10);
    reaper.setDaemon(true);
    reaper.start();
  }
  
  public static void track(File file, Object marker)
  {
    trackers.add(new Tracker(file, marker, q));
  }
  
  public static void track(String path, Object marker)
  {
    trackers.add(new Tracker(path, marker, q));
  }
  
  public static int getTrackCount()
  {
    return trackers.size();
  }
  
  private static class Tracker
    extends PhantomReference
  {
    private String path;
    
    public Tracker(File file, Object marker, ReferenceQueue queue)
    {
      this(file.getPath(), marker, queue);
    }
    
    public Tracker(String path, Object marker, ReferenceQueue queue)
    {
      super(queue);
      this.path = path;
    }
    
    public boolean delete()
    {
      return new File(path).delete();
    }
  }
}

/* Location:
 * Qualified Name:     org.apache.commons.io.FileCleaner
 * Java Class Version: 1.1 (45.3)
 * JD-Core Version:    0.7.1
 */