package org.apache.commons.io.output;

import java.io.IOException;
import java.io.OutputStream;

public class CountingOutputStream
  extends ProxyOutputStream
{
  private int count;
  
  public CountingOutputStream(OutputStream out)
  {
    super(out);
  }
  
  public void write(byte[] b)
    throws IOException
  {
    count += b.length;
    super.write(b);
  }
  
  public void write(byte[] b, int off, int len)
    throws IOException
  {
    count += len;
    super.write(b, off, len);
  }
  
  public void write(int b)
    throws IOException
  {
    count += 1;
    super.write(b);
  }
  
  public int getCount()
  {
    return count;
  }
  
  public synchronized int resetCount()
  {
    int tmp = count;
    count = 0;
    return tmp;
  }
}

/* Location:
 * Qualified Name:     org.apache.commons.io.output.CountingOutputStream
 * Java Class Version: 1.1 (45.3)
 * JD-Core Version:    0.7.1
 */