package org.apache.commons.io.output;

import java.io.IOException;
import java.io.OutputStream;

public class DemuxOutputStream
  extends OutputStream
{
  private InheritableThreadLocal m_streams = new InheritableThreadLocal();
  
  public OutputStream bindStream(OutputStream output)
  {
    OutputStream stream = getStream();
    m_streams.set(output);
    return stream;
  }
  
  public void close()
    throws IOException
  {
    OutputStream output = getStream();
    if (null != output) {
      output.close();
    }
  }
  
  public void flush()
    throws IOException
  {
    OutputStream output = getStream();
    if (null != output) {
      output.flush();
    }
  }
  
  public void write(int ch)
    throws IOException
  {
    OutputStream output = getStream();
    if (null != output) {
      output.write(ch);
    }
  }
  
  private OutputStream getStream()
  {
    return (OutputStream)m_streams.get();
  }
}

/* Location:
 * Qualified Name:     org.apache.commons.io.output.DemuxOutputStream
 * Java Class Version: 1.1 (45.3)
 * JD-Core Version:    0.7.1
 */